

/*
 *
 *    OPEN-XCHANGE legal information
 *
 *    All intellectual property rights in the Software are protected by
 *    international copyright laws.
 *
 *
 *    In some countries OX, OX Open-Xchange, open xchange and OXtender
 *    as well as the corresponding Logos OX Open-Xchange and OX are registered
 *    trademarks.
 *    The use of the Logos is not covered by the GNU General Public License.
 *    Instead, you are allowed to use these Logos according to the terms and
 *    conditions of the Creative Commons License, Version 2.5, Attribution,
 *    Non-commercial, ShareAlike, and the interpretation of the term
 *    Non-commercial applicable to the aforementioned license is published
 *    on the web site http://www.open-xchange.com/EN/legal/index.html.
 *
 *    Please make sure that third-party modules and libraries are used
 *    according to their respective licenses.
 *
 *    Any modifications to this package must retain all copyright notices
 *    of the original copyright holder(s) for the original code used.
 *
 *    After any such modifications, the original and derivative code shall remain
 *    under the copyright of the copyright holder(s) and/or original author(s)per
 *    the Attribution and Assignment Agreement that can be located at
 *    http://www.open-xchange.com/EN/developer/. The contributing author shall be
 *    given Attribution for the derivative code and a license granting use.
 *
 *     Copyright (C) 2016-2020 OX Software GmbH
 *     Mail: info@open-xchange.com
 *
 *
 *     This program is free software; you can redistribute it and/or modify it
 *     under the terms of the GNU General Public License, Version 2 as published
 *     by the Free Software Foundation.
 *
 *     This program is distributed in the hope that it will be useful, but
 *     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 *     for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc., 59
 *     Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

package org.docx4j.dml.chartex2014;

import javax.xml.bind.annotation.XmlEnum;
import javax.xml.bind.annotation.XmlEnumValue;
import javax.xml.bind.annotation.XmlType;


/**
 * <p>Java class for ST_EntityType.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * <p>
 * <pre>
 * &lt;simpleType name="ST_EntityType">
 *   &lt;restriction base="{http://www.w3.org/2001/XMLSchema}string">
 *     &lt;enumeration value="Address"/>
 *     &lt;enumeration value="AdminDistrict"/>
 *     &lt;enumeration value="AdminDistrict2"/>
 *     &lt;enumeration value="AdminDistrict3"/>
 *     &lt;enumeration value="Continent"/>
 *     &lt;enumeration value="CountryRegion"/>
 *     &lt;enumeration value="Locality"/>
 *     &lt;enumeration value="Ocean"/>
 *     &lt;enumeration value="Planet"/>
 *     &lt;enumeration value="PostalCode"/>
 *     &lt;enumeration value="Region"/>
 *     &lt;enumeration value="Unsupported"/>
 *   &lt;/restriction>
 * &lt;/simpleType>
 * </pre>
 * 
 */
@XmlType(name = "ST_EntityType")
@XmlEnum
public enum STEntityType {

    @XmlEnumValue("Address")
    ADDRESS("Address"),
    @XmlEnumValue("AdminDistrict")
    ADMIN_DISTRICT("AdminDistrict"),
    @XmlEnumValue("AdminDistrict2")
    ADMIN_DISTRICT_2("AdminDistrict2"),
    @XmlEnumValue("AdminDistrict3")
    ADMIN_DISTRICT_3("AdminDistrict3"),
    @XmlEnumValue("Continent")
    CONTINENT("Continent"),
    @XmlEnumValue("CountryRegion")
    COUNTRY_REGION("CountryRegion"),
    @XmlEnumValue("Locality")
    LOCALITY("Locality"),
    @XmlEnumValue("Ocean")
    OCEAN("Ocean"),
    @XmlEnumValue("Planet")
    PLANET("Planet"),
    @XmlEnumValue("PostalCode")
    POSTAL_CODE("PostalCode"),
    @XmlEnumValue("Region")
    REGION("Region"),
    @XmlEnumValue("Unsupported")
    UNSUPPORTED("Unsupported");
    private final String value;

    STEntityType(String v) {
        value = v;
    }

    public String value() {
        return value;
    }

    public static STEntityType fromValue(String v) {
        for (STEntityType c: STEntityType.values()) {
            if (c.value.equals(v)) {
                return c;
            }
        }
        throw new IllegalArgumentException(v);
    }

}
