/*
 *
 *    OPEN-XCHANGE legal information
 *
 *    All intellectual property rights in the Software are protected by
 *    international copyright laws.
 *
 *
 *    In some countries OX, OX Open-Xchange, open xchange and OXtender
 *    as well as the corresponding Logos OX Open-Xchange and OX are registered
 *    trademarks.
 *    The use of the Logos is not covered by the GNU General Public License.
 *    Instead, you are allowed to use these Logos according to the terms and
 *    conditions of the Creative Commons License, Version 2.5, Attribution,
 *    Non-commercial, ShareAlike, and the interpretation of the term
 *    Non-commercial applicable to the aforementioned license is published
 *    on the web site http://www.open-xchange.com/EN/legal/index.html.
 *
 *    Please make sure that third-party modules and libraries are used
 *    according to their respective licenses.
 *
 *    Any modifications to this package must retain all copyright notices
 *    of the original copyright holder(s) for the original code used.
 *
 *    After any such modifications, the original and derivative code shall remain
 *    under the copyright of the copyright holder(s) and/or original author(s)per
 *    the Attribution and Assignment Agreement that can be located at
 *    http://www.open-xchange.com/EN/developer/. The contributing author shall be
 *    given Attribution for the derivative code and a license granting use.
 *
 *     Copyright (C) 2016-2020 OX Software GmbH
 *     Mail: info@open-xchange.com
 *
 *
 *     This program is free software; you can redistribute it and/or modify it
 *     under the terms of the GNU General Public License, Version 2 as published
 *     by the Free Software Foundation.
 *
 *     This program is distributed in the hope that it will be useful, but
 *     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 *     for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc., 59
 *     Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

package org.xlsx4j.schemas.microsoft.com.office.spreadsheetml_2010_11.main;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlSchemaType;
import javax.xml.bind.annotation.XmlType;
import org.xlsx4j.sml.CTExtensionList;


/**
 * <p>Java class for CT_DataModel complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="CT_DataModel">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element name="modelTables" type="{http://schemas.microsoft.com/office/spreadsheetml/2010/11/main}CT_ModelTables" minOccurs="0"/>
 *         &lt;element name="modelRelationships" type="{http://schemas.microsoft.com/office/spreadsheetml/2010/11/main}CT_ModelRelationships" minOccurs="0"/>
 *         &lt;element name="extLst" type="{http://schemas.openxmlformats.org/spreadsheetml/2006/main}CT_ExtensionList" minOccurs="0"/>
 *       &lt;/sequence>
 *       &lt;attribute name="minVersionLoad" type="{http://www.w3.org/2001/XMLSchema}unsignedByte" default="5" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "CT_DataModel", propOrder = {
    "modelTables",
    "modelRelationships",
    "extLst"
})
public class CTDataModel {

    protected CTModelTables modelTables;
    protected CTModelRelationships modelRelationships;
    protected CTExtensionList extLst;
    @XmlAttribute(name = "minVersionLoad")
    @XmlSchemaType(name = "unsignedByte")
    protected Short minVersionLoad;

    /**
     * Gets the value of the modelTables property.
     * 
     * @return
     *     possible object is
     *     {@link CTModelTables }
     *     
     */
    public CTModelTables getModelTables() {
        return modelTables;
    }

    /**
     * Sets the value of the modelTables property.
     * 
     * @param value
     *     allowed object is
     *     {@link CTModelTables }
     *     
     */
    public void setModelTables(CTModelTables value) {
        this.modelTables = value;
    }

    /**
     * Gets the value of the modelRelationships property.
     * 
     * @return
     *     possible object is
     *     {@link CTModelRelationships }
     *     
     */
    public CTModelRelationships getModelRelationships() {
        return modelRelationships;
    }

    /**
     * Sets the value of the modelRelationships property.
     * 
     * @param value
     *     allowed object is
     *     {@link CTModelRelationships }
     *     
     */
    public void setModelRelationships(CTModelRelationships value) {
        this.modelRelationships = value;
    }

    /**
     * Gets the value of the extLst property.
     * 
     * @return
     *     possible object is
     *     {@link CTExtensionList }
     *     
     */
    public CTExtensionList getExtLst() {
        return extLst;
    }

    /**
     * Sets the value of the extLst property.
     * 
     * @param value
     *     allowed object is
     *     {@link CTExtensionList }
     *     
     */
    public void setExtLst(CTExtensionList value) {
        this.extLst = value;
    }

    /**
     * Gets the value of the minVersionLoad property.
     * 
     * @return
     *     possible object is
     *     {@link Short }
     *     
     */
    public short getMinVersionLoad() {
        if (minVersionLoad == null) {
            return ((short) 5);
        } else {
            return minVersionLoad;
        }
    }

    /**
     * Sets the value of the minVersionLoad property.
     * 
     * @param value
     *     allowed object is
     *     {@link Short }
     *     
     */
    public void setMinVersionLoad(Short value) {
        this.minVersionLoad = value;
    }

}
