/*
 *
 *    OPEN-XCHANGE legal information
 *
 *    All intellectual property rights in the Software are protected by
 *    international copyright laws.
 *
 *
 *    In some countries OX, OX Open-Xchange, open xchange and OXtender
 *    as well as the corresponding Logos OX Open-Xchange and OX are registered
 *    trademarks.
 *    The use of the Logos is not covered by the GNU General Public License.
 *    Instead, you are allowed to use these Logos according to the terms and
 *    conditions of the Creative Commons License, Version 2.5, Attribution,
 *    Non-commercial, ShareAlike, and the interpretation of the term
 *    Non-commercial applicable to the aforementioned license is published
 *    on the web site http://www.open-xchange.com/EN/legal/index.html.
 *
 *    Please make sure that third-party modules and libraries are used
 *    according to their respective licenses.
 *
 *    Any modifications to this package must retain all copyright notices
 *    of the original copyright holder(s) for the original code used.
 *
 *    After any such modifications, the original and derivative code shall remain
 *    under the copyright of the copyright holder(s) and/or original author(s)per
 *    the Attribution and Assignment Agreement that can be located at
 *    http://www.open-xchange.com/EN/developer/. The contributing author shall be
 *    given Attribution for the derivative code and a license granting use.
 *
 *     Copyright (C) 2016-2020 OX Software GmbH
 *     Mail: info@open-xchange.com
 *
 *
 *     This program is free software; you can redistribute it and/or modify it
 *     under the terms of the GNU General Public License, Version 2 as published
 *     by the Free Software Foundation.
 *
 *     This program is distributed in the hope that it will be useful, but
 *     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 *     for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc., 59
 *     Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

package org.xlsx4j.schemas.microsoft.com.office.spreadsheetml_2010_11.main;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlSchemaType;
import javax.xml.bind.annotation.XmlType;
import org.xlsx4j.sml.CTExtensionList;
import org.xlsx4j.sml.STPivotFilterType;


/**
 * <p>Java class for CT_TimelineState complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="CT_TimelineState">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element name="selection" type="{http://schemas.microsoft.com/office/spreadsheetml/2010/11/main}CT_TimelineRange" minOccurs="0"/>
 *         &lt;element name="bounds" type="{http://schemas.microsoft.com/office/spreadsheetml/2010/11/main}CT_TimelineRange"/>
 *         &lt;element name="extLst" type="{http://schemas.openxmlformats.org/spreadsheetml/2006/main}CT_ExtensionList" minOccurs="0"/>
 *       &lt;/sequence>
 *       &lt;attribute name="singleRangeFilterState" type="{http://www.w3.org/2001/XMLSchema}boolean" default="true" />
 *       &lt;attribute name="minimalRefreshVersion" use="required" type="{http://www.w3.org/2001/XMLSchema}unsignedInt" />
 *       &lt;attribute name="lastRefreshVersion" use="required" type="{http://www.w3.org/2001/XMLSchema}unsignedInt" />
 *       &lt;attribute name="pivotCacheId" use="required" type="{http://www.w3.org/2001/XMLSchema}unsignedInt" />
 *       &lt;attribute name="filterType" use="required" type="{http://schemas.openxmlformats.org/spreadsheetml/2006/main}ST_PivotFilterType" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "CT_TimelineState", propOrder = {
    "selection",
    "bounds",
    "extLst"
})
public class CTTimelineState {

    protected CTTimelineRange selection;
    @XmlElement(required = true)
    protected CTTimelineRange bounds;
    protected CTExtensionList extLst;
    @XmlAttribute(name = "singleRangeFilterState")
    protected Boolean singleRangeFilterState;
    @XmlAttribute(name = "minimalRefreshVersion", required = true)
    @XmlSchemaType(name = "unsignedInt")
    protected long minimalRefreshVersion;
    @XmlAttribute(name = "lastRefreshVersion", required = true)
    @XmlSchemaType(name = "unsignedInt")
    protected long lastRefreshVersion;
    @XmlAttribute(name = "pivotCacheId", required = true)
    @XmlSchemaType(name = "unsignedInt")
    protected long pivotCacheId;
    @XmlAttribute(name = "filterType", required = true)
    protected STPivotFilterType filterType;

    /**
     * Gets the value of the selection property.
     * 
     * @return
     *     possible object is
     *     {@link CTTimelineRange }
     *     
     */
    public CTTimelineRange getSelection() {
        return selection;
    }

    /**
     * Sets the value of the selection property.
     * 
     * @param value
     *     allowed object is
     *     {@link CTTimelineRange }
     *     
     */
    public void setSelection(CTTimelineRange value) {
        this.selection = value;
    }

    /**
     * Gets the value of the bounds property.
     * 
     * @return
     *     possible object is
     *     {@link CTTimelineRange }
     *     
     */
    public CTTimelineRange getBounds() {
        return bounds;
    }

    /**
     * Sets the value of the bounds property.
     * 
     * @param value
     *     allowed object is
     *     {@link CTTimelineRange }
     *     
     */
    public void setBounds(CTTimelineRange value) {
        this.bounds = value;
    }

    /**
     * Gets the value of the extLst property.
     * 
     * @return
     *     possible object is
     *     {@link CTExtensionList }
     *     
     */
    public CTExtensionList getExtLst() {
        return extLst;
    }

    /**
     * Sets the value of the extLst property.
     * 
     * @param value
     *     allowed object is
     *     {@link CTExtensionList }
     *     
     */
    public void setExtLst(CTExtensionList value) {
        this.extLst = value;
    }

    /**
     * Gets the value of the singleRangeFilterState property.
     * 
     * @return
     *     possible object is
     *     {@link Boolean }
     *     
     */
    public boolean isSingleRangeFilterState() {
        if (singleRangeFilterState == null) {
            return true;
        } else {
            return singleRangeFilterState;
        }
    }

    /**
     * Sets the value of the singleRangeFilterState property.
     * 
     * @param value
     *     allowed object is
     *     {@link Boolean }
     *     
     */
    public void setSingleRangeFilterState(Boolean value) {
        this.singleRangeFilterState = value;
    }

    /**
     * Gets the value of the minimalRefreshVersion property.
     * 
     */
    public long getMinimalRefreshVersion() {
        return minimalRefreshVersion;
    }

    /**
     * Sets the value of the minimalRefreshVersion property.
     * 
     */
    public void setMinimalRefreshVersion(long value) {
        this.minimalRefreshVersion = value;
    }

    /**
     * Gets the value of the lastRefreshVersion property.
     * 
     */
    public long getLastRefreshVersion() {
        return lastRefreshVersion;
    }

    /**
     * Sets the value of the lastRefreshVersion property.
     * 
     */
    public void setLastRefreshVersion(long value) {
        this.lastRefreshVersion = value;
    }

    /**
     * Gets the value of the pivotCacheId property.
     * 
     */
    public long getPivotCacheId() {
        return pivotCacheId;
    }

    /**
     * Sets the value of the pivotCacheId property.
     * 
     */
    public void setPivotCacheId(long value) {
        this.pivotCacheId = value;
    }

    /**
     * Gets the value of the filterType property.
     * 
     * @return
     *     possible object is
     *     {@link STPivotFilterType }
     *     
     */
    public STPivotFilterType getFilterType() {
        return filterType;
    }

    /**
     * Sets the value of the filterType property.
     * 
     * @param value
     *     allowed object is
     *     {@link STPivotFilterType }
     *     
     */
    public void setFilterType(STPivotFilterType value) {
        this.filterType = value;
    }

}
