package com.openexchange.office.htmldoc;

import org.apache.commons.lang3.StringEscapeUtils;

public class Text
        extends SubNode
{
    private static final String SPANBEFORE = "<span ";
    private static final String SPANMIDDLE = "style=\"font-family: Arial, Helvetica, sans-serif; font-weight: normal; font-style: normal; text-decoration: none; color: rgb(0, 0, 0); font-size: 11pt; line-height: 20px; background-color: transparent;\">";
    private static final String SPANEND    = "</span>";

    // ////////////////////////////////////////////////////

    private final String        text;
    private boolean style = true;

    public Text(
            String text, int position)
    {
        super(position, text.length());
        this.text = text;
    }

    public String getText()
    {
        return text;
    }

    @Override
    public boolean appendContent(
        StringBuilder document)
        throws Exception
    {
        document.append(SPANBEFORE);
        GenDocHelper.appendAttributes(getAttribute(), document);
        if (isStyle()) {
            document.append(SPANMIDDLE);
        } else {
            document.append(">");
        }

        document.append(GenDocHelper.escapeUIString(text));
        document.append(SPANEND);
        return true;
    }

    @Override
    public String toString()
    {
        return "Text: " + getText();
    }

    @Override
    public boolean needsEmptySpan()
    {
        return false;
    }

    public boolean isStyle() {
        return style;
    }

    public void disableEmptySpanStyle() {
        this.style = false;
    }
}
