/*
 *
 *    OPEN-XCHANGE legal information
 *
 *    All intellectual property rights in the Software are protected by
 *    international copyright laws.
 *
 *
 *    In some countries OX, OX Open-Xchange, open xchange and OXtender
 *    as well as the corresponding Logos OX Open-Xchange and OX are registered
 *    trademarks of the OX Software GmbH group of companies.
 *    The use of the Logos is not covered by the GNU General Public License.
 *    Instead, you are allowed to use these Logos according to the terms and
 *    conditions of the Creative Commons License, Version 2.5, Attribution,
 *    Non-commercial, ShareAlike, and the interpretation of the term
 *    Non-commercial applicable to the aforementioned license is published
 *    on the web site http://www.open-xchange.com/EN/legal/index.html.
 *
 *    Please make sure that third-party modules and libraries are used
 *    according to their respective licenses.
 *
 *    Any modifications to this package must retain all copyright notices
 *    of the original copyright holder(s) for the original code used.
 *
 *    After any such modifications, the original and derivative code shall remain
 *    under the copyright of the copyright holder(s) and/or original author(s)per
 *    the Attribution and Assignment Agreement that can be located at
 *    http://www.open-xchange.com/EN/developer/. The contributing author shall be
 *    given Attribution for the derivative code and a license granting use.
 *
 *     Copyright (C) 2016-2020 OX Software GmbH
 *     Mail: info@open-xchange.com
 *
 *
 *     This program is free software; you can redistribute it and/or modify it
 *     under the terms of the GNU General Public License, Version 2 as published
 *     by the Free Software Foundation.
 *
 *     This program is distributed in the hope that it will be useful, but
 *     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 *     for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc., 59
 *     Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

package com.openexchange.office.rt2.core.doc;

public class MessageProperties
{
	private MessageProperties() {}

	public static final String PROP_WRITE_PROTECTED     = "writeProtected";
	public static final String PROP_CLIENT_IDENTIFIER   = "clientId";
	public static final String PROP_RENAME_NEEDS_RELOAD = "renameNeedsReload";
    public static final String PROP_CLIENTID            = PROP_CLIENT_IDENTIFIER;
    public static final String PROP_EDITUSERID          = "editUserId";
    public static final String PROP_HASERRORS           = "hasErrors";
    public static final String PROP_ERROR               = "error";
    public static final String PROP_OPERATIONS          = "operations";
    public static final String PROP_HTMLDOC             = "htmlDoc";
    public static final String PROP_SYNCINFO            = "syncInfo";
    public static final String PROP_SYNCLOAD            = "syncLoad";
    public static final String PROP_PREVIEW             = "preview";
    public static final String PROP_SERVEROSN           = "serverOSN";
    public static final String PROP_DOCSTATUS           = "docStatus";
    public static final String PROP_SLIDEINFO           = "slideInfo";
    public static final String PROP_ACTIVESLIDE         = "activeSlide";
    public static final String PROP_ACTIVESHEET         = "activeSheet";
    public static final String PROP_FILENAME            = "fileName";
    public static final String PROP_FILE                = "file";
    public static final String PROP_FILEID              = "fileId";
    public static final String PROP_SYNC                = "sync";
    public static final String PROP_ACTION              = "action";
    public static final String PROP_VALUE               = "value";
    public static final String PROP_CLIENTS             = "clients";
    public static final String PROP_SANITIZEDFILENAME   = "com.openexchange.file.sanitizedFilename";
    public static final String PROP_FORCEEDITRESULT     = "forceEditResult";
    public static final String PROP_RESULT              = "result";
    public static final String PROP_PERFORMANCE         = "performanceData";
}
