/*
 *  Copyright 2007-2008, Plutext Pty Ltd.
 *
 *  This file is part of docx4j.

    docx4j is licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.

    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

 */
package org.docx4j.wml;

import javax.xml.bind.JAXBElement;
import javax.xml.bind.annotation.XmlElementDecl;
import javax.xml.bind.annotation.XmlRegistry;
import javax.xml.namespace.QName;
import org.docx4j.math.CTAcc;
import org.docx4j.math.CTBar;
import org.docx4j.math.CTBorderBox;
import org.docx4j.math.CTBox;
import org.docx4j.math.CTD;
import org.docx4j.math.CTEqArr;
import org.docx4j.math.CTF;
import org.docx4j.math.CTFunc;
import org.docx4j.math.CTGroupChr;
import org.docx4j.math.CTLimLow;
import org.docx4j.math.CTLimUpp;
import org.docx4j.math.CTM;
import org.docx4j.math.CTNary;
import org.docx4j.math.CTPhant;
import org.docx4j.math.CTR;
import org.docx4j.math.CTRad;
import org.docx4j.math.CTSPre;
import org.docx4j.math.CTSSub;
import org.docx4j.math.CTSSubSup;
import org.docx4j.math.CTSSup;


/**
 * This object contains factory methods for each
 * Java content interface and Java element interface
 * generated in the org.docx4j.wml package.
 * <p>An ObjectFactory allows you to programatically
 * construct new instances of the Java representation
 * for XML content. The Java representation of XML
 * content can consist of schema derived interfaces
 * and classes representing the binding of schema
 * type definitions, element declarations and model
 * groups.  Factory methods for each of these are
 * provided in this class.
 *
 */
@XmlRegistry
public class ObjectFactory {

    private final static QName _Recipients_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "recipients");
    private final static QName _Endnotes_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "endnotes");
    private final static QName _WebSettings_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "webSettings");
    private final static QName _TxbxContent_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "txbxContent");
    private final static QName _Footnotes_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "footnotes");
    private final static QName _Body_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "body");
    private final static QName _Settings_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "settings");
    private final static QName _RMonthShort_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "monthShort");
    private final static QName _RYearLong_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "yearLong");
    private final static QName _RPgNum_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "pgNum");
    private final static QName _RFootnoteReference_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "footnoteReference");
    private final static QName _REndnoteRef_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "endnoteRef");
    private final static QName _RSoftHyphen_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "softHyphen");
    private final static QName _REndnoteReference_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "endnoteReference");
    private final static QName _RT_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "t");
    private final static QName _RCr_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "cr");
    private final static QName _RFldChar_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "fldChar");
    private final static QName _RCommentReference_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "commentReference");
    private final static QName _RSeparator_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "separator");
    private final static QName _RDayLong_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "dayLong");
    private final static QName _RAnnotationRef_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "annotationRef");
    private final static QName _RRuby_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "ruby");
    private final static QName _RObject_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "object");
    private final static QName _RTab_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "tab");
    private final static QName _RLastRenderedPageBreak_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "lastRenderedPageBreak");
    private final static QName _RDrawing_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "drawing");
    private final static QName _RDelInstrText_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "delInstrText");
    private final static QName _RInstrText_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "instrText");
    private final static QName _RSym_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "sym");
    private final static QName _RPict_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "pict");
    private final static QName _RContinuationSeparator_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "continuationSeparator");
    private final static QName _RFootnoteRef_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "footnoteRef");
    private final static QName _RYearShort_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "yearShort");
    private final static QName _RDayShort_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "dayShort");
    private final static QName _RMonthLong_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "monthLong");
    private final static QName _RPtab_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "ptab");
    private final static QName _RNoBreakHyphen_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "noBreakHyphen");
    private final static QName _CTRPrChangeRPrRtl_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "rtl");
    private final static QName _CTRPrChangeRPrB_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "b");
    private final static QName _CTRPrChangeRPrSnapToGrid_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "snapToGrid");
    private final static QName _CTRPrChangeRPrCs_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "cs");
    private final static QName _CTRPrChangeRPrDstrike_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "dstrike");
    private final static QName _CTRPrChangeRPrICs_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "iCs");
    private final static QName _CTRPrChangeRPrI_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "i");
    private final static QName _CTRPrChangeRPrOMath_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "oMath");
    private final static QName _CTRPrChangeRPrNoProof_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "noProof");
    private final static QName _CTRPrChangeRPrVertAlign_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "vertAlign");
    private final static QName _CTRPrChangeRPrW_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "w");
    private final static QName _CTRPrChangeRPrCaps_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "caps");
    private final static QName _CTRPrChangeRPrEffect_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "effect");
    private final static QName _CTRPrChangeRPrEm_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "em");
    private final static QName _CTRPrChangeRPrWebHidden_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "webHidden");
    private final static QName _CTRPrChangeRPrPosition_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "position");
    private final static QName _CTRPrChangeRPrShd_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "shd");
    private final static QName _CTRPrChangeRPrSmallCaps_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "smallCaps");
    private final static QName _CTRPrChangeRPrSpecVanish_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "specVanish");
    private final static QName _CTRPrChangeRPrSzCs_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "szCs");
    private final static QName _CTRPrChangeRPrSpacing_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "spacing");
    private final static QName _CTRPrChangeRPrEastAsianLayout_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "eastAsianLayout");
    private final static QName _CTRPrChangeRPrFitText_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "fitText");
    private final static QName _CTRPrChangeRPrKern_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "kern");
    private final static QName _CTRPrChangeRPrVanish_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "vanish");
    private final static QName _CTRPrChangeRPrLang_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "lang");
    private final static QName _CTRPrChangeRPrOutline_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "outline");
    private final static QName _CTRPrChangeRPrBCs_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "bCs");
    private final static QName _CTRPrChangeRPrStrike_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "strike");
    private final static QName _CTRPrChangeRPrShadow_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "shadow");
    private final static QName _CTRPrChangeRPrImprint_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "imprint");
    private final static QName _CTRPrChangeRPrBdr_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "bdr");
    private final static QName _CTRPrChangeRPrSz_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "sz");
    private final static QName _CTRPrChangeRPrEmboss_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "emboss");
    private final static QName _RunTrackChangeMoveFromRangeStart_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "moveFromRangeStart");
    private final static QName _RunTrackChangeMoveFromRangeEnd_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "moveFromRangeEnd");
    private final static QName _RunTrackChangeSPre_QNAME = new QName("http://schemas.openxmlformats.org/officeDocument/2006/math", "sPre");
    private final static QName _RunTrackChangeSdt_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "sdt");
    private final static QName _RunTrackChangeCustomXmlDelRangeEnd_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "customXmlDelRangeEnd");
    private final static QName _RunTrackChangeMoveToRangeEnd_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "moveToRangeEnd");
    private final static QName _RunTrackChangeBorderBox_QNAME = new QName("http://schemas.openxmlformats.org/officeDocument/2006/math", "borderBox");
    private final static QName _RunTrackChangeCustomXmlMoveToRangeEnd_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "customXmlMoveToRangeEnd");
    private final static QName _RunTrackChangeCustomXmlInsRangeStart_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "customXmlInsRangeStart");
    private final static QName _RunTrackChangeCustomXmlMoveToRangeStart_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "customXmlMoveToRangeStart");
    private final static QName _RunTrackChangeCustomXmlInsRangeEnd_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "customXmlInsRangeEnd");
    private final static QName _RunTrackChangeGroupChr_QNAME = new QName("http://schemas.openxmlformats.org/officeDocument/2006/math", "groupChr");
    private final static QName _RunTrackChangePermStart_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "permStart");
    private final static QName _RunTrackChangeMoveToRangeStart_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "moveToRangeStart");
    private final static QName _RunTrackChangeFunc_QNAME = new QName("http://schemas.openxmlformats.org/officeDocument/2006/math", "func");
    private final static QName _RunTrackChangeBookmarkEnd_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "bookmarkEnd");
    private final static QName _RunTrackChangeSSubSup_QNAME = new QName("http://schemas.openxmlformats.org/officeDocument/2006/math", "sSubSup");
    private final static QName _RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "customXmlMoveFromRangeEnd");
    private final static QName _RunTrackChangeLimUpp_QNAME = new QName("http://schemas.openxmlformats.org/officeDocument/2006/math", "limUpp");
    private final static QName _RunTrackChangeAcc_QNAME = new QName("http://schemas.openxmlformats.org/officeDocument/2006/math", "acc");
    private final static QName _RunTrackChangeMoveFrom_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "moveFrom");
    private final static QName _RunTrackChangeCustomXmlMoveFromRangeStart_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "customXmlMoveFromRangeStart");
    private final static QName _RunTrackChangeM_QNAME = new QName("http://schemas.openxmlformats.org/officeDocument/2006/math", "m");
    private final static QName _RunTrackChangeCustomXmlDelRangeStart_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "customXmlDelRangeStart");
    private final static QName _RunTrackChangeLimLow_QNAME = new QName("http://schemas.openxmlformats.org/officeDocument/2006/math", "limLow");
    private final static QName _RunTrackChangeSSup_QNAME = new QName("http://schemas.openxmlformats.org/officeDocument/2006/math", "sSup");
    private final static QName _RunTrackChangeD_QNAME = new QName("http://schemas.openxmlformats.org/officeDocument/2006/math", "d");
    private final static QName _RunTrackChangeF_QNAME = new QName("http://schemas.openxmlformats.org/officeDocument/2006/math", "f");
    private final static QName _RunTrackChangeEqArr_QNAME = new QName("http://schemas.openxmlformats.org/officeDocument/2006/math", "eqArr");
    private final static QName _RunTrackChangeNary_QNAME = new QName("http://schemas.openxmlformats.org/officeDocument/2006/math", "nary");
    private final static QName _RunTrackChangeRad_QNAME = new QName("http://schemas.openxmlformats.org/officeDocument/2006/math", "rad");
    private final static QName _RunTrackChangeBar_QNAME = new QName("http://schemas.openxmlformats.org/officeDocument/2006/math", "bar");
    private final static QName _RunTrackChangePermEnd_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "permEnd");
    private final static QName _RunTrackChangeBox_QNAME = new QName("http://schemas.openxmlformats.org/officeDocument/2006/math", "box");
    private final static QName _RunTrackChangeCustomXml_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "customXml");
    private final static QName _RunTrackChangeBookmarkStart_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "bookmarkStart");
    private final static QName _RunTrackChangeR_QNAME = new QName("http://schemas.openxmlformats.org/officeDocument/2006/math", "r");
    private final static QName _RunTrackChangeMoveTo_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "moveTo");
    private final static QName _RunTrackChangePhant_QNAME = new QName("http://schemas.openxmlformats.org/officeDocument/2006/math", "phant");
    private final static QName _RunTrackChangeSmartTag_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "smartTag");
    private final static QName _RunTrackChangeSSub_QNAME = new QName("http://schemas.openxmlformats.org/officeDocument/2006/math", "sSub");
    private final static QName _CTSmartTagRunFldSimple_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "fldSimple");
    private final static QName _CTSmartTagRunHyperlink_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "hyperlink");
    private final static QName _CTSmartTagRunSubDoc_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "subDoc");
    private final static QName _CTSdtContentCellTc_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "tc");
    private final static QName _SdtPrRPr_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "rPr");
    private final static QName _SdtPrText_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "text");
    private final static QName _SdtPrCitation_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "citation");
    private final static QName _SdtPrDocPartObj_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "docPartObj");
    private final static QName _SdtPrPlaceholder_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "placeholder");
    private final static QName _SdtPrShowingPlcHdr_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "showingPlcHdr");
    private final static QName _SdtPrAlias_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "alias");
    private final static QName _SdtPrLock_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "lock");
    private final static QName _SdtPrTemporary_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "temporary");
    private final static QName _SdtPrBibliography_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "bibliography");
    private final static QName _SdtPrComboBox_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "comboBox");
    private final static QName _SdtPrRichText_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "richText");
    private final static QName _SdtPrDate_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "date");
    private final static QName _SdtPrDropDownList_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "dropDownList");
    private final static QName _SdtPrPicture_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "picture");
    private final static QName _SdtPrEquation_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "equation");
    private final static QName _SdtPrDataBinding_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "dataBinding");
    private final static QName _SdtPrDocPartList_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "docPartList");
    private final static QName _SdtPrGroup_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "group");
    private final static QName _CTFtnEdnTbl_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "tbl");
    private final static QName _CTFtnEdnAltChunk_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "altChunk");
    private final static QName _CTFFDataDdList_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "ddList");
    private final static QName _CTFFDataEntryMacro_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "entryMacro");
    private final static QName _CTFFDataEnabled_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "enabled");
    private final static QName _CTFFDataCalcOnExit_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "calcOnExit");
    private final static QName _CTFFDataName_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "name");
    private final static QName _CTFFDataCheckBox_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "checkBox");
    private final static QName _CTFFDataStatusText_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "statusText");
    private final static QName _CTFFDataHelpText_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "helpText");
    private final static QName _CTFFDataTextInput_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "textInput");
    private final static QName _CTFFDataExitMacro_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "exitMacro");
    private final static QName _CTTrPrBaseTblHeader_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "tblHeader");
    private final static QName _CTTrPrBaseJc_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "jc");
    private final static QName _CTTrPrBaseCantSplit_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "cantSplit");
    private final static QName _CTTrPrBaseGridBefore_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "gridBefore");
    private final static QName _CTTrPrBaseHidden_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "hidden");
    private final static QName _CTTrPrBaseTrHeight_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "trHeight");
    private final static QName _CTTrPrBaseTblCellSpacing_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "tblCellSpacing");
    private final static QName _CTTrPrBaseGridAfter_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "gridAfter");
    private final static QName _CTTrPrBaseWAfter_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "wAfter");
    private final static QName _CTTrPrBaseWBefore_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "wBefore");
    private final static QName _CTTrPrBaseDivId_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "divId");
    private final static QName _CTTrPrBaseCnfStyle_QNAME = new QName("http://schemas.openxmlformats.org/wordprocessingml/2006/main", "cnfStyle");

    /**
     * Create a new ObjectFactory that can be used to create new instances of schema derived classes for package: org.docx4j.wml
     *
     */
    public ObjectFactory() {
    }

    /**
     * Create an instance of {@link Numbering }
     *
     */
    public Numbering createNumbering() {
        return new Numbering();
    }

    /**
     * Create an instance of {@link org.docx4j.wml.Style }
     *
     */
    public org.docx4j.wml.Style createStyle() {
        return new org.docx4j.wml.Style();
    }

    /**
     * Create an instance of {@link R }
     *
     */
    public R createR() {
        return new R();
    }

    /**
     * Create an instance of {@link P }
     *
     */
    public P createP() {
        return new P();
    }

    /**
     * Create an instance of {@link DocDefaults }
     *
     */
    public DocDefaults createDocDefaults() {
        return new DocDefaults();
    }

    /**
     * Create an instance of {@link Styles }
     *
     */
    public Styles createStyles() {
        return new Styles();
    }

    /**
     * Create an instance of {@link Fonts }
     *
     */
    public Fonts createFonts() {
        return new Fonts();
    }

    /**
     * Create an instance of {@link Comments }
     *
     */
    public Comments createComments() {
        return new Comments();
    }

    /**
     * Create an instance of {@link CTMailMerge }
     *
     */
    public CTMailMerge createCTMailMerge() {
        return new CTMailMerge();
    }

    /**
     * Create an instance of {@link CTOdsoFieldMapData }
     *
     */
    public CTOdsoFieldMapData createCTOdsoFieldMapData() {
        return new CTOdsoFieldMapData();
    }

    /**
     * Create an instance of {@link CTEdnProps }
     *
     */
    public CTEdnProps createCTEdnProps() {
        return new CTEdnProps();
    }

    /**
     * Create an instance of {@link CTSdtDate }
     *
     */
    public CTSdtDate createCTSdtDate() {
        return new CTSdtDate();
    }

    /**
     * Create an instance of {@link CTRecipientData }
     *
     */
    public CTRecipientData createCTRecipientData() {
        return new CTRecipientData();
    }

    /**
     * Create an instance of {@link CTPlaceholder }
     *
     */
    public CTPlaceholder createCTPlaceholder() {
        return new CTPlaceholder();
    }

    /**
     * Create an instance of {@link CTCustomXmlPr }
     *
     */
    public CTCustomXmlPr createCTCustomXmlPr() {
        return new CTCustomXmlPr();
    }

    /**
     * Create an instance of {@link CTFrame }
     *
     */
    public CTFrame createCTFrame() {
        return new CTFrame();
    }

    /**
     * Create an instance of {@link CTFFTextInput }
     *
     */
    public CTFFTextInput createCTFFTextInput() {
        return new CTFFTextInput();
    }

    /**
     * Create an instance of {@link CTFramesetSplitbar }
     *
     */
    public CTFramesetSplitbar createCTFramesetSplitbar() {
        return new CTFramesetSplitbar();
    }

    /**
     * Create an instance of {@link CTFFDDList }
     *
     */
    public CTFFDDList createCTFFDDList() {
        return new CTFFDDList();
    }

    /**
     * Create an instance of {@link CTTrPrBase }
     *
     */
    public CTTrPrBase createCTTrPrBase() {
        return new CTTrPrBase();
    }

    /**
     * Create an instance of {@link SdtPr }
     *
     */
    public SdtPr createSdtPr() {
        return new SdtPr();
    }

    /**
     * Create an instance of {@link CTOdso }
     *
     */
    public CTOdso createCTOdso() {
        return new CTOdso();
    }

    /**
     * Create an instance of {@link SectPr }
     *
     */
    public SectPr createSectPr() {
        return new SectPr();
    }

    /**
     * Create an instance of {@link CTRPrChange }
     *
     */
    public CTRPrChange createCTRPrChange() {
        return new CTRPrChange();
    }

    /**
     * Create an instance of {@link CTDocPartPr }
     *
     */
    public CTDocPartPr createCTDocPartPr() {
        return new CTDocPartPr();
    }

    /**
     * Create an instance of {@link TcPrInner }
     *
     */
    public TcPrInner createTcPrInner() {
        return new TcPrInner();
    }

    /**
     * Create an instance of {@link PPrBase }
     *
     */
    public PPrBase createPPrBase() {
        return new PPrBase();
    }

    /**
     * Create an instance of {@link PPrBase.NumPr }
     *
     */
    public PPrBase.NumPr createPPrBaseNumPr() {
        return new PPrBase.NumPr();
    }

    /**
     * Create an instance of {@link Lvl }
     *
     */
    public Lvl createLvl() {
        return new Lvl();
    }

    /**
     * Create an instance of {@link CTSdtDocPart }
     *
     */
    public CTSdtDocPart createCTSdtDocPart() {
        return new CTSdtDocPart();
    }

    /**
     * Create an instance of {@link CTTblPrBase }
     *
     */
    public CTTblPrBase createCTTblPrBase() {
        return new CTTblPrBase();
    }

    /**
     * Create an instance of {@link CTFrameset }
     *
     */
    public CTFrameset createCTFrameset() {
        return new CTFrameset();
    }

    /**
     * Create an instance of {@link CTDocPartCategory }
     *
     */
    public CTDocPartCategory createCTDocPartCategory() {
        return new CTDocPartCategory();
    }

    /**
     * Create an instance of {@link Fonts.Font }
     *
     */
    public Fonts.Font createFontsFont() {
        return new Fonts.Font();
    }

    /**
     * Create an instance of {@link Styles.LatentStyles }
     *
     */
    public Styles.LatentStyles createStylesLatentStyles() {
        return new Styles.LatentStyles();
    }

    /**
     * Create an instance of {@link CTWebSettings }
     *
     */
    public CTWebSettings createCTWebSettings() {
        return new CTWebSettings();
    }

    /**
     * Create an instance of {@link Numbering.Num }
     *
     */
    public Numbering.Num createNumberingNum() {
        return new Numbering.Num();
    }

    /**
     * Create an instance of {@link Numbering.Num.LvlOverride }
     *
     */
    public Numbering.Num.LvlOverride createNumberingNumLvlOverride() {
        return new Numbering.Num.LvlOverride();
    }

    /**
     * Create an instance of {@link Numbering.AbstractNum }
     *
     */
    public Numbering.AbstractNum createNumberingAbstractNum() {
        return new Numbering.AbstractNum();
    }

    /**
     * Create an instance of {@link CTSettings }
     *
     */
    public CTSettings createCTSettings() {
        return new CTSettings();
    }

    /**
     * Create an instance of {@link Body }
     *
     */
    public Body createBody() {
        return new Body();
    }

    /**
     * Create an instance of {@link CommentRangeStart }
     *
     */
    public CommentRangeStart createCommentRangeStart() {
        return new CommentRangeStart();
    }

    /**
     * Create an instance of {@link GlossaryDocument }
     *
     */
    public GlossaryDocument createGlossaryDocument() {
        return new GlossaryDocument();
    }

    /**
     * Create an instance of {@link CTBackground }
     *
     */
    public CTBackground createCTBackground() {
        return new CTBackground();
    }

    /**
     * Create an instance of {@link CTDocParts }
     *
     */
    public CTDocParts createCTDocParts() {
        return new CTDocParts();
    }

    /**
     * Create an instance of {@link Tr }
     *
     */
    public Tr createTr() {
        return new Tr();
    }

    /**
     * Create an instance of {@link CTTblPrEx }
     *
     */
    public CTTblPrEx createCTTblPrEx() {
        return new CTTblPrEx();
    }

    /**
     * Create an instance of {@link TrPr }
     *
     */
    public TrPr createTrPr() {
        return new TrPr();
    }

    /**
     * Create an instance of {@link Tc }
     *
     */
    public Tc createTc() {
        return new Tc();
    }

    /**
     * Create an instance of {@link CTCustomXmlCell }
     *
     */
    public CTCustomXmlCell createCTCustomXmlCell() {
        return new CTCustomXmlCell();
    }

    /**
     * Create an instance of {@link CTSdtCell }
     *
     */
    public CTSdtCell createCTSdtCell() {
        return new CTSdtCell();
    }

    /**
     * Create an instance of {@link ProofErr }
     *
     */
    public ProofErr createProofErr() {
        return new ProofErr();
    }

    /**
     * Create an instance of {@link RangePermissionStart }
     *
     */
    public RangePermissionStart createRangePermissionStart() {
        return new RangePermissionStart();
    }

    /**
     * Create an instance of {@link CTPerm }
     *
     */
    public CTPerm createCTPerm() {
        return new CTPerm();
    }

    /**
     * Create an instance of {@link CTBookmark }
     *
     */
    public CTBookmark createCTBookmark() {
        return new CTBookmark();
    }

    /**
     * Create an instance of {@link CTMarkupRange }
     *
     */
    public CTMarkupRange createCTMarkupRange() {
        return new CTMarkupRange();
    }

    /**
     * Create an instance of {@link CTMoveBookmark }
     *
     */
    public CTMoveBookmark createCTMoveBookmark() {
        return new CTMoveBookmark();
    }

    /**
     * Create an instance of {@link CTMoveFromRangeEnd }
     *
     */
    public CTMoveFromRangeEnd createCTMoveFromRangeEnd() {
        return new CTMoveFromRangeEnd();
    }

    /**
     * Create an instance of {@link CTMoveToRangeEnd }
     *
     */
    public CTMoveToRangeEnd createCTMoveToRangeEnd() {
        return new CTMoveToRangeEnd();
    }

    /**
     * Create an instance of {@link CommentRangeEnd }
     *
     */
    public CommentRangeEnd createCommentRangeEnd() {
        return new CommentRangeEnd();
    }

    /**
     * Create an instance of {@link CTTrackChange }
     *
     */
    public CTTrackChange createCTTrackChange() {
        return new CTTrackChange();
    }

    /**
     * Create an instance of {@link CTMarkup }
     *
     */
    public CTMarkup createCTMarkup() {
        return new CTMarkup();
    }

    /**
     * Create an instance of {@link RunIns }
     *
     */
    public RunIns createRunIns() {
        return new RunIns();
    }

    /**
     * Create an instance of {@link RunDel }
     *
     */
    public RunDel createRunDel() {
        return new RunDel();
    }

    /**
     * Create an instance of {@link RunMoveTo }
     *
     */
    public RunMoveTo createRunMoveTo() {
        return new RunMoveTo();
    }

    /**
     * Create an instance of {@link RunMoveFrom }
     *
     */
    public RunMoveFrom createRunMoveFrom() {
        return new RunMoveFrom();
    }

    /**
     * Create an instance of {@link DelText }
     *
     */
    public DelText createDelText() {
        return new DelText();
    }

    /**
     * Create an instance of {@link Tag }
     *
     */
    public Tag createTag() {
        return new Tag();
    }

    /**
     * Create an instance of {@link RStyle }
     *
     */
    public RStyle createRStyle() {
        return new RStyle();
    }

    /**
     * Create an instance of {@link Numbering.NumPicBullet }
     *
     */
    public Numbering.NumPicBullet createNumberingNumPicBullet() {
        return new Numbering.NumPicBullet();
    }

    /**
     * Create an instance of {@link Numbering.NumIdMacAtCleanup }
     *
     */
    public Numbering.NumIdMacAtCleanup createNumberingNumIdMacAtCleanup() {
        return new Numbering.NumIdMacAtCleanup();
    }

    /**
     * Create an instance of {@link Highlight }
     *
     */
    public Highlight createHighlight() {
        return new Highlight();
    }

    /**
     * Create an instance of {@link Br }
     *
     */
    public Br createBr() {
        return new Br();
    }

    /**
     * Create an instance of {@link FooterReference }
     *
     */
    public FooterReference createFooterReference() {
        return new FooterReference();
    }

    /**
     * Create an instance of {@link CTRel }
     *
     */
    public CTRel createCTRel() {
        return new CTRel();
    }

    /**
     * Create an instance of {@link Id }
     *
     */
    public Id createId() {
        return new Id();
    }

    /**
     * Create an instance of {@link Document }
     *
     */
    public Document createDocument() {
        return new Document();
    }

    /**
     * Create an instance of {@link CTTxbxContent }
     *
     */
    public CTTxbxContent createCTTxbxContent() {
        return new CTTxbxContent();
    }

    /**
     * Create an instance of {@link org.docx4j.wml.Style.Name }
     *
     */
    public org.docx4j.wml.Style.Name createStyleName() {
        return new org.docx4j.wml.Style.Name();
    }

    /**
     * Create an instance of {@link org.docx4j.wml.Style.Aliases }
     *
     */
    public org.docx4j.wml.Style.Aliases createStyleAliases() {
        return new org.docx4j.wml.Style.Aliases();
    }

    /**
     * Create an instance of {@link org.docx4j.wml.Style.BasedOn }
     *
     */
    public org.docx4j.wml.Style.BasedOn createStyleBasedOn() {
        return new org.docx4j.wml.Style.BasedOn();
    }

    /**
     * Create an instance of {@link org.docx4j.wml.Style.Next }
     *
     */
    public org.docx4j.wml.Style.Next createStyleNext() {
        return new org.docx4j.wml.Style.Next();
    }

    /**
     * Create an instance of {@link org.docx4j.wml.Style.Link }
     *
     */
    public org.docx4j.wml.Style.Link createStyleLink() {
        return new org.docx4j.wml.Style.Link();
    }

    /**
     * Create an instance of {@link BooleanDefaultTrue }
     *
     */
    public BooleanDefaultTrue createBooleanDefaultTrue() {
        return new BooleanDefaultTrue();
    }

    /**
     * Create an instance of {@link org.docx4j.wml.Style.UiPriority }
     *
     */
    public org.docx4j.wml.Style.UiPriority createStyleUiPriority() {
        return new org.docx4j.wml.Style.UiPriority();
    }

    /**
     * Create an instance of {@link CTLongHexNumber }
     *
     */
    public CTLongHexNumber createCTLongHexNumber() {
        return new CTLongHexNumber();
    }

    /**
     * Create an instance of {@link PPr }
     *
     */
    public PPr createPPr() {
        return new PPr();
    }

    /**
     * Create an instance of {@link org.docx4j.wml.RPr }
     *
     */
    public org.docx4j.wml.RPr createRPr() {
        return new org.docx4j.wml.RPr();
    }

    /**
     * Create an instance of {@link TcPr }
     *
     */
    public TcPr createTcPr() {
        return new TcPr();
    }

    /**
     * Create an instance of {@link CTTblStylePr }
     *
     */
    public CTTblStylePr createCTTblStylePr() {
        return new CTTblStylePr();
    }

    /**
     * Create an instance of {@link Hdr }
     *
     */
    public Hdr createHdr() {
        return new Hdr();
    }

    /**
     * Create an instance of {@link CTCustomXmlBlock }
     *
     */
    public CTCustomXmlBlock createCTCustomXmlBlock() {
        return new CTCustomXmlBlock();
    }

    /**
     * Create an instance of {@link SdtBlock }
     *
     */
    public SdtBlock createSdtBlock() {
        return new SdtBlock();
    }

    /**
     * Create an instance of {@link CTCustomXmlRun }
     *
     */
    public CTCustomXmlRun createCTCustomXmlRun() {
        return new CTCustomXmlRun();
    }

    /**
     * Create an instance of {@link CTSmartTagRun }
     *
     */
    public CTSmartTagRun createCTSmartTagRun() {
        return new CTSmartTagRun();
    }

    /**
     * Create an instance of {@link SdtRun }
     *
     */
    public SdtRun createSdtRun() {
        return new SdtRun();
    }

    /**
     * Create an instance of {@link Text }
     *
     */
    public Text createText() {
        return new Text();
    }

    /**
     * Create an instance of {@link R.NoBreakHyphen }
     *
     */
    public R.NoBreakHyphen createRNoBreakHyphen() {
        return new R.NoBreakHyphen();
    }

    /**
     * Create an instance of {@link R.SoftHyphen }
     *
     */
    public R.SoftHyphen createRSoftHyphen() {
        return new R.SoftHyphen();
    }

    /**
     * Create an instance of {@link R.DayShort }
     *
     */
    public R.DayShort createRDayShort() {
        return new R.DayShort();
    }

    /**
     * Create an instance of {@link R.MonthShort }
     *
     */
    public R.MonthShort createRMonthShort() {
        return new R.MonthShort();
    }

    /**
     * Create an instance of {@link R.YearShort }
     *
     */
    public R.YearShort createRYearShort() {
        return new R.YearShort();
    }

    /**
     * Create an instance of {@link R.DayLong }
     *
     */
    public R.DayLong createRDayLong() {
        return new R.DayLong();
    }

    /**
     * Create an instance of {@link R.MonthLong }
     *
     */
    public R.MonthLong createRMonthLong() {
        return new R.MonthLong();
    }

    /**
     * Create an instance of {@link R.YearLong }
     *
     */
    public R.YearLong createRYearLong() {
        return new R.YearLong();
    }

    /**
     * Create an instance of {@link R.AnnotationRef }
     *
     */
    public R.AnnotationRef createRAnnotationRef() {
        return new R.AnnotationRef();
    }

    /**
     * Create an instance of {@link R.FootnoteRef }
     *
     */
    public R.FootnoteRef createRFootnoteRef() {
        return new R.FootnoteRef();
    }

    /**
     * Create an instance of {@link R.EndnoteRef }
     *
     */
    public R.EndnoteRef createREndnoteRef() {
        return new R.EndnoteRef();
    }

    /**
     * Create an instance of {@link R.Separator }
     *
     */
    public R.Separator createRSeparator() {
        return new R.Separator();
    }

    /**
     * Create an instance of {@link R.ContinuationSeparator }
     *
     */
    public R.ContinuationSeparator createRContinuationSeparator() {
        return new R.ContinuationSeparator();
    }

    /**
     * Create an instance of {@link R.Sym }
     *
     */
    public R.Sym createRSym() {
        return new R.Sym();
    }

    /**
     * Create an instance of {@link R.PgNum }
     *
     */
    public R.PgNum createRPgNum() {
        return new R.PgNum();
    }

    /**
     * Create an instance of {@link R.Cr }
     *
     */
    public R.Cr createRCr() {
        return new R.Cr();
    }

    /**
     * Create an instance of {@link R.Tab }
     *
     */
    public R.Tab createRTab() {
        return new R.Tab();
    }

    /**
     * Create an instance of {@link CTObject }
     *
     */
    public CTObject createCTObject() {
        return new CTObject();
    }

    /**
     * Create an instance of {@link Pict }
     *
     */
    public Pict createPict() {
        return new Pict();
    }

    /**
     * Create an instance of {@link FldChar }
     *
     */
    public FldChar createFldChar() {
        return new FldChar();
    }

    /**
     * Create an instance of {@link CTRuby }
     *
     */
    public CTRuby createCTRuby() {
        return new CTRuby();
    }

    /**
     * Create an instance of {@link CTFtnEdnRef }
     *
     */
    public CTFtnEdnRef createCTFtnEdnRef() {
        return new CTFtnEdnRef();
    }

    /**
     * Create an instance of {@link R.CommentReference }
     *
     */
    public R.CommentReference createRCommentReference() {
        return new R.CommentReference();
    }

    /**
     * Create an instance of {@link Drawing }
     *
     */
    public Drawing createDrawing() {
        return new Drawing();
    }

    /**
     * Create an instance of {@link R.Ptab }
     *
     */
    public R.Ptab createRPtab() {
        return new R.Ptab();
    }

    /**
     * Create an instance of {@link R.LastRenderedPageBreak }
     *
     */
    public R.LastRenderedPageBreak createRLastRenderedPageBreak() {
        return new R.LastRenderedPageBreak();
    }

    /**
     * Create an instance of {@link CTSimpleField }
     *
     */
    public CTSimpleField createCTSimpleField() {
        return new CTSimpleField();
    }

    /**
     * Create an instance of {@link P.Hyperlink }
     *
     */
    public P.Hyperlink createPHyperlink() {
        return new P.Hyperlink();
    }

    /**
     * Create an instance of {@link Tbl }
     *
     */
    public Tbl createTbl() {
        return new Tbl();
    }

    /**
     * Create an instance of {@link CTAltChunk }
     *
     */
    public CTAltChunk createCTAltChunk() {
        return new CTAltChunk();
    }

    /**
     * Create an instance of {@link CTRecipients }
     *
     */
    public CTRecipients createCTRecipients() {
        return new CTRecipients();
    }

    /**
     * Create an instance of {@link DocDefaults.RPrDefault }
     *
     */
    public DocDefaults.RPrDefault createDocDefaultsRPrDefault() {
        return new DocDefaults.RPrDefault();
    }

    /**
     * Create an instance of {@link DocDefaults.PPrDefault }
     *
     */
    public DocDefaults.PPrDefault createDocDefaultsPPrDefault() {
        return new DocDefaults.PPrDefault();
    }

    /**
     * Create an instance of {@link CTFootnotes }
     *
     */
    public CTFootnotes createCTFootnotes() {
        return new CTFootnotes();
    }

    /**
     * Create an instance of {@link HeaderReference }
     *
     */
    public HeaderReference createHeaderReference() {
        return new HeaderReference();
    }

    /**
     * Create an instance of {@link Ftr }
     *
     */
    public Ftr createFtr() {
        return new Ftr();
    }

    /**
     * Create an instance of {@link U }
     *
     */
    public U createU() {
        return new U();
    }

    /**
     * Create an instance of {@link RFonts }
     *
     */
    public RFonts createRFonts() {
        return new RFonts();
    }

    /**
     * Create an instance of {@link org.docx4j.wml.Color }
     *
     */
    public org.docx4j.wml.Color createColor() {
        return new org.docx4j.wml.Color();
    }

    /**
     * Create an instance of {@link CTEndnotes }
     *
     */
    public CTEndnotes createCTEndnotes() {
        return new CTEndnotes();
    }

    /**
     * Create an instance of {@link Comments.Comment }
     *
     */
    public Comments.Comment createCommentsComment() {
        return new Comments.Comment();
    }

    /**
     * Create an instance of {@link CTMailMergeDataType }
     *
     */
    public CTMailMergeDataType createCTMailMergeDataType() {
        return new CTMailMergeDataType();
    }

    /**
     * Create an instance of {@link CTPaperSource }
     *
     */
    public CTPaperSource createCTPaperSource() {
        return new CTPaperSource();
    }

    /**
     * Create an instance of {@link CTEmpty }
     *
     */
    public CTEmpty createCTEmpty() {
        return new CTEmpty();
    }

    /**
     * Create an instance of {@link CTShapeDefaults }
     *
     */
    public CTShapeDefaults createCTShapeDefaults() {
        return new CTShapeDefaults();
    }

    /**
     * Create an instance of {@link CTFFHelpText }
     *
     */
    public CTFFHelpText createCTFFHelpText() {
        return new CTFFHelpText();
    }

    /**
     * Create an instance of {@link CTEm }
     *
     */
    public CTEm createCTEm() {
        return new CTEm();
    }

    /**
     * Create an instance of {@link CTGuid }
     *
     */
    public CTGuid createCTGuid() {
        return new CTGuid();
    }

    /**
     * Create an instance of {@link CTVerticalAlignRun }
     *
     */
    public CTVerticalAlignRun createCTVerticalAlignRun() {
        return new CTVerticalAlignRun();
    }

    /**
     * Create an instance of {@link ParaRPr }
     *
     */
    public ParaRPr createParaRPr() {
        return new ParaRPr();
    }

    /**
     * Create an instance of {@link CTWriteProtection }
     *
     */
    public CTWriteProtection createCTWriteProtection() {
        return new CTWriteProtection();
    }

    /**
     * Create an instance of {@link CTCustomXmlRow }
     *
     */
    public CTCustomXmlRow createCTCustomXmlRow() {
        return new CTCustomXmlRow();
    }

    /**
     * Create an instance of {@link TextDirection }
     *
     */
    public TextDirection createTextDirection() {
        return new TextDirection();
    }

    /**
     * Create an instance of {@link CTDocType }
     *
     */
    public CTDocType createCTDocType() {
        return new CTDocType();
    }

    /**
     * Create an instance of {@link CTMailMergeOdsoFMDFieldType }
     *
     */
    public CTMailMergeOdsoFMDFieldType createCTMailMergeOdsoFMDFieldType() {
        return new CTMailMergeOdsoFMDFieldType();
    }

    /**
     * Create an instance of {@link CTPPrChange }
     *
     */
    public CTPPrChange createCTPPrChange() {
        return new CTPPrChange();
    }

    /**
     * Create an instance of {@link CTDiv }
     *
     */
    public CTDiv createCTDiv() {
        return new CTDiv();
    }

    /**
     * Create an instance of {@link CTColumns }
     *
     */
    public CTColumns createCTColumns() {
        return new CTColumns();
    }

    /**
     * Create an instance of {@link CTFtnPos }
     *
     */
    public CTFtnPos createCTFtnPos() {
        return new CTFtnPos();
    }

    /**
     * Create an instance of {@link CTVerticalJc }
     *
     */
    public CTVerticalJc createCTVerticalJc() {
        return new CTVerticalJc();
    }

    /**
     * Create an instance of {@link CTAutoCaptions }
     *
     */
    public CTAutoCaptions createCTAutoCaptions() {
        return new CTAutoCaptions();
    }

    /**
     * Create an instance of {@link CTFtnProps }
     *
     */
    public CTFtnProps createCTFtnProps() {
        return new CTFtnProps();
    }

    /**
     * Create an instance of {@link CTTrackChangeRange }
     *
     */
    public CTTrackChangeRange createCTTrackChangeRange() {
        return new CTTrackChangeRange();
    }

    /**
     * Create an instance of {@link CTTblOverlap }
     *
     */
    public CTTblOverlap createCTTblOverlap() {
        return new CTTblOverlap();
    }

    /**
     * Create an instance of {@link CTTabStop }
     *
     */
    public CTTabStop createCTTabStop() {
        return new CTTabStop();
    }

    /**
     * Create an instance of {@link CTFitText }
     *
     */
    public CTFitText createCTFitText() {
        return new CTFitText();
    }

    /**
     * Create an instance of {@link TblPr }
     *
     */
    public TblPr createTblPr() {
        return new TblPr();
    }

    /**
     * Create an instance of {@link CTFFCheckBox }
     *
     */
    public CTFFCheckBox createCTFFCheckBox() {
        return new CTFFCheckBox();
    }

    /**
     * Create an instance of {@link CTDocPart }
     *
     */
    public CTDocPart createCTDocPart() {
        return new CTDocPart();
    }

    /**
     * Create an instance of {@link CTDocPartTypes }
     *
     */
    public CTDocPartTypes createCTDocPartTypes() {
        return new CTDocPartTypes();
    }

    /**
     * Create an instance of {@link CTMailMergeDest }
     *
     */
    public CTMailMergeDest createCTMailMergeDest() {
        return new CTMailMergeDest();
    }

    /**
     * Create an instance of {@link CTDataBinding }
     *
     */
    public CTDataBinding createCTDataBinding() {
        return new CTDataBinding();
    }

    /**
     * Create an instance of {@link CTSdtDropDownList }
     *
     */
    public CTSdtDropDownList createCTSdtDropDownList() {
        return new CTSdtDropDownList();
    }

    /**
     * Create an instance of {@link Tabs }
     *
     */
    public Tabs createTabs() {
        return new Tabs();
    }

    /**
     * Create an instance of {@link CTTblPrExBase }
     *
     */
    public CTTblPrExBase createCTTblPrExBase() {
        return new CTTblPrExBase();
    }

    /**
     * Create an instance of {@link CTLang }
     *
     */
    public CTLang createCTLang() {
        return new CTLang();
    }

    /**
     * Create an instance of {@link CTTwipsMeasure }
     *
     */
    public CTTwipsMeasure createCTTwipsMeasure() {
        return new CTTwipsMeasure();
    }

    /**
     * Create an instance of {@link CTCompat }
     *
     */
    public CTCompat createCTCompat() {
        return new CTCompat();
    }

    /**
     * Create an instance of {@link CTTrackChangeNumbering }
     *
     */
    public CTTrackChangeNumbering createCTTrackChangeNumbering() {
        return new CTTrackChangeNumbering();
    }

    /**
     * Create an instance of {@link CTEdnPos }
     *
     */
    public CTEdnPos createCTEdnPos() {
        return new CTEdnPos();
    }

    /**
     * Create an instance of {@link CTSdtDateMappingType }
     *
     */
    public CTSdtDateMappingType createCTSdtDateMappingType() {
        return new CTSdtDateMappingType();
    }

    /**
     * Create an instance of {@link CTTrackChangesView }
     *
     */
    public CTTrackChangesView createCTTrackChangesView() {
        return new CTTrackChangesView();
    }

    /**
     * Create an instance of {@link FontSig }
     *
     */
    public FontSig createFontSig() {
        return new FontSig();
    }

    /**
     * Create an instance of {@link CTParaRPrOriginal }
     *
     */
    public CTParaRPrOriginal createCTParaRPrOriginal() {
        return new CTParaRPrOriginal();
    }

    /**
     * Create an instance of {@link TblBorders }
     *
     */
    public TblBorders createTblBorders() {
        return new TblBorders();
    }

    /**
     * Create an instance of {@link FontPanose }
     *
     */
    public FontPanose createFontPanose() {
        return new FontPanose();
    }

    /**
     * Create an instance of {@link CTDocProtect }
     *
     */
    public CTDocProtect createCTDocProtect() {
        return new CTDocProtect();
    }

    /**
     * Create an instance of {@link CTSaveThroughXslt }
     *
     */
    public CTSaveThroughXslt createCTSaveThroughXslt() {
        return new CTSaveThroughXslt();
    }

    /**
     * Create an instance of {@link CTColor }
     *
     */
    public CTColor createCTColor() {
        return new CTColor();
    }

    /**
     * Create an instance of {@link CTColumn }
     *
     */
    public CTColumn createCTColumn() {
        return new CTColumn();
    }

    /**
     * Create an instance of {@link CTFFData }
     *
     */
    public CTFFData createCTFFData() {
        return new CTFFData();
    }

    /**
     * Create an instance of {@link CTTrPrChange }
     *
     */
    public CTTrPrChange createCTTrPrChange() {
        return new CTTrPrChange();
    }

    /**
     * Create an instance of {@link CTDocPartGallery }
     *
     */
    public CTDocPartGallery createCTDocPartGallery() {
        return new CTDocPartGallery();
    }

    /**
     * Create an instance of {@link CTDocVar }
     *
     */
    public CTDocVar createCTDocVar() {
        return new CTDocVar();
    }

    /**
     * Create an instance of {@link CTSdtListItem }
     *
     */
    public CTSdtListItem createCTSdtListItem() {
        return new CTSdtListItem();
    }

    /**
     * Create an instance of {@link CTDocRsids }
     *
     */
    public CTDocRsids createCTDocRsids() {
        return new CTDocRsids();
    }

    /**
     * Create an instance of {@link CTZoom }
     *
     */
    public CTZoom createCTZoom() {
        return new CTZoom();
    }

    /**
     * Create an instance of {@link Jc }
     *
     */
    public Jc createJc() {
        return new Jc();
    }

    /**
     * Create an instance of {@link CTSdtEndPr }
     *
     */
    public CTSdtEndPr createCTSdtEndPr() {
        return new CTSdtEndPr();
    }

    /**
     * Create an instance of {@link SectPrBase }
     *
     */
    public SectPrBase createSectPrBase() {
        return new SectPrBase();
    }

    /**
     * Create an instance of {@link CTFtnEdn }
     *
     */
    public CTFtnEdn createCTFtnEdn() {
        return new CTFtnEdn();
    }

    /**
     * Create an instance of {@link CTTblGridChange }
     *
     */
    public CTTblGridChange createCTTblGridChange() {
        return new CTTblGridChange();
    }

    /**
     * Create an instance of {@link ParaRPrChange }
     *
     */
    public ParaRPrChange createParaRPrChange() {
        return new ParaRPrChange();
    }

    /**
     * Create an instance of {@link CTDocVars }
     *
     */
    public CTDocVars createCTDocVars() {
        return new CTDocVars();
    }

    /**
     * Create an instance of {@link CTEastAsianLayout }
     *
     */
    public CTEastAsianLayout createCTEastAsianLayout() {
        return new CTEastAsianLayout();
    }

    /**
     * Create an instance of {@link CTFramePr }
     *
     */
    public CTFramePr createCTFramePr() {
        return new CTFramePr();
    }

    /**
     * Create an instance of {@link TblWidth }
     *
     */
    public TblWidth createTblWidth() {
        return new TblWidth();
    }

    /**
     * Create an instance of {@link FontPitch }
     *
     */
    public FontPitch createFontPitch() {
        return new FontPitch();
    }

    /**
     * Create an instance of {@link CTSignedTwipsMeasure }
     *
     */
    public CTSignedTwipsMeasure createCTSignedTwipsMeasure() {
        return new CTSignedTwipsMeasure();
    }

    /**
     * Create an instance of {@link NumFmt }
     *
     */
    public NumFmt createNumFmt() {
        return new NumFmt();
    }

    /**
     * Create an instance of {@link CTCalendarType }
     *
     */
    public CTCalendarType createCTCalendarType() {
        return new CTCalendarType();
    }

    /**
     * Create an instance of {@link CTDocPartBehavior }
     *
     */
    public CTDocPartBehavior createCTDocPartBehavior() {
        return new CTDocPartBehavior();
    }

    /**
     * Create an instance of {@link CTLineNumber }
     *
     */
    public CTLineNumber createCTLineNumber() {
        return new CTLineNumber();
    }

    /**
     * Create an instance of {@link CTSdtText }
     *
     */
    public CTSdtText createCTSdtText() {
        return new CTSdtText();
    }

    /**
     * Create an instance of {@link CTCellMergeTrackChange }
     *
     */
    public CTCellMergeTrackChange createCTCellMergeTrackChange() {
        return new CTCellMergeTrackChange();
    }

    /**
     * Create an instance of {@link BooleanDefaultFalse }
     *
     */
    public BooleanDefaultFalse createBooleanDefaultFalse() {
        return new BooleanDefaultFalse();
    }

    /**
     * Create an instance of {@link CTDivBdr }
     *
     */
    public CTDivBdr createCTDivBdr() {
        return new CTDivBdr();
    }

    /**
     * Create an instance of {@link CTControl }
     *
     */
    public CTControl createCTControl() {
        return new CTControl();
    }

    /**
     * Create an instance of {@link CTFtnEdnSepRef }
     *
     */
    public CTFtnEdnSepRef createCTFtnEdnSepRef() {
        return new CTFtnEdnSepRef();
    }

    /**
     * Create an instance of {@link CTCharacterSpacing }
     *
     */
    public CTCharacterSpacing createCTCharacterSpacing() {
        return new CTCharacterSpacing();
    }

    /**
     * Create an instance of {@link CTFFStatusText }
     *
     */
    public CTFFStatusText createCTFFStatusText() {
        return new CTFFStatusText();
    }

    /**
     * Create an instance of {@link SdtContentBlock }
     *
     */
    public SdtContentBlock createSdtContentBlock() {
        return new SdtContentBlock();
    }

    /**
     * Create an instance of {@link CTHeight }
     *
     */
    public CTHeight createCTHeight() {
        return new CTHeight();
    }

    /**
     * Create an instance of {@link CTKinsoku }
     *
     */
    public CTKinsoku createCTKinsoku() {
        return new CTKinsoku();
    }

    /**
     * Create an instance of {@link CTEdnDocProps }
     *
     */
    public CTEdnDocProps createCTEdnDocProps() {
        return new CTEdnDocProps();
    }

    /**
     * Create an instance of {@link CTFtnDocProps }
     *
     */
    public CTFtnDocProps createCTFtnDocProps() {
        return new CTFtnDocProps();
    }

    /**
     * Create an instance of {@link CTTextEffect }
     *
     */
    public CTTextEffect createCTTextEffect() {
        return new CTTextEffect();
    }

    /**
     * Create an instance of {@link CTShd }
     *
     */
    public CTShd createCTShd() {
        return new CTShd();
    }

    /**
     * Create an instance of {@link FontRel }
     *
     */
    public FontRel createFontRel() {
        return new FontRel();
    }

    /**
     * Create an instance of {@link CTAttr }
     *
     */
    public CTAttr createCTAttr() {
        return new CTAttr();
    }

    /**
     * Create an instance of {@link CTTextboxTightWrap }
     *
     */
    public CTTextboxTightWrap createCTTextboxTightWrap() {
        return new CTTextboxTightWrap();
    }

    /**
     * Create an instance of {@link CTNumRestart }
     *
     */
    public CTNumRestart createCTNumRestart() {
        return new CTNumRestart();
    }

    /**
     * Create an instance of {@link CTReadingModeInkLockDown }
     *
     */
    public CTReadingModeInkLockDown createCTReadingModeInkLockDown() {
        return new CTReadingModeInkLockDown();
    }

    /**
     * Create an instance of {@link CTTcPrChange }
     *
     */
    public CTTcPrChange createCTTcPrChange() {
        return new CTTcPrChange();
    }

    /**
     * Create an instance of {@link CTUcharHexNumber }
     *
     */
    public CTUcharHexNumber createCTUcharHexNumber() {
        return new CTUcharHexNumber();
    }

    /**
     * Create an instance of {@link CTDocPartBehaviors }
     *
     */
    public CTDocPartBehaviors createCTDocPartBehaviors() {
        return new CTDocPartBehaviors();
    }

    /**
     * Create an instance of {@link HpsMeasure }
     *
     */
    public HpsMeasure createHpsMeasure() {
        return new HpsMeasure();
    }

    /**
     * Create an instance of {@link CTAutoCaption }
     *
     */
    public CTAutoCaption createCTAutoCaption() {
        return new CTAutoCaption();
    }

    /**
     * Create an instance of {@link CTFrameLayout }
     *
     */
    public CTFrameLayout createCTFrameLayout() {
        return new CTFrameLayout();
    }

    /**
     * Create an instance of {@link CTRPrDefault }
     *
     */
    public CTRPrDefault createCTRPrDefault() {
        return new CTRPrDefault();
    }

    /**
     * Create an instance of {@link CTFrameScrollbar }
     *
     */
    public CTFrameScrollbar createCTFrameScrollbar() {
        return new CTFrameScrollbar();
    }

    /**
     * Create an instance of {@link TblGrid }
     *
     */
    public TblGrid createTblGrid() {
        return new TblGrid();
    }

    /**
     * Create an instance of {@link CTRubyAlign }
     *
     */
    public CTRubyAlign createCTRubyAlign() {
        return new CTRubyAlign();
    }

    /**
     * Create an instance of {@link CTSectPrChange }
     *
     */
    public CTSectPrChange createCTSectPrChange() {
        return new CTSectPrChange();
    }

    /**
     * Create an instance of {@link CTPixelsMeasure }
     *
     */
    public CTPixelsMeasure createCTPixelsMeasure() {
        return new CTPixelsMeasure();
    }

    /**
     * Create an instance of {@link CTPageNumber }
     *
     */
    public CTPageNumber createCTPageNumber() {
        return new CTPageNumber();
    }

    /**
     * Create an instance of {@link CTSdtContentRow }
     *
     */
    public CTSdtContentRow createCTSdtContentRow() {
        return new CTSdtContentRow();
    }

    /**
     * Create an instance of {@link TblGridBase }
     *
     */
    public TblGridBase createTblGridBase() {
        return new TblGridBase();
    }

    /**
     * Create an instance of {@link CTDocGrid }
     *
     */
    public CTDocGrid createCTDocGrid() {
        return new CTDocGrid();
    }

    /**
     * Create an instance of {@link CTPPrDefault }
     *
     */
    public CTPPrDefault createCTPPrDefault() {
        return new CTPPrDefault();
    }

    /**
     * Create an instance of {@link CTTblPrChange }
     *
     */
    public CTTblPrChange createCTTblPrChange() {
        return new CTTblPrChange();
    }

    /**
     * Create an instance of {@link CTRubyPr }
     *
     */
    public CTRubyPr createCTRubyPr() {
        return new CTRubyPr();
    }

    /**
     * Create an instance of {@link CTLanguage }
     *
     */
    public CTLanguage createCTLanguage() {
        return new CTLanguage();
    }

    /**
     * Create an instance of {@link CTSdtContentCell }
     *
     */
    public CTSdtContentCell createCTSdtContentCell() {
        return new CTSdtContentCell();
    }

    /**
     * Create an instance of {@link CTCaptions }
     *
     */
    public CTCaptions createCTCaptions() {
        return new CTCaptions();
    }

    /**
     * Create an instance of {@link CTLock }
     *
     */
    public CTLock createCTLock() {
        return new CTLock();
    }

    /**
     * Create an instance of {@link CTDivs }
     *
     */
    public CTDivs createCTDivs() {
        return new CTDivs();
    }

    /**
     * Create an instance of {@link CTView }
     *
     */
    public CTView createCTView() {
        return new CTView();
    }

    /**
     * Create an instance of {@link CTTextScale }
     *
     */
    public CTTextScale createCTTextScale() {
        return new CTTextScale();
    }

    /**
     * Create an instance of {@link CTTblLook }
     *
     */
    public CTTblLook createCTTblLook() {
        return new CTTblLook();
    }

    /**
     * Create an instance of {@link CTCaption }
     *
     */
    public CTCaption createCTCaption() {
        return new CTCaption();
    }

    /**
     * Create an instance of {@link CTTargetScreenSz }
     *
     */
    public CTTargetScreenSz createCTTargetScreenSz() {
        return new CTTargetScreenSz();
    }

    /**
     * Create an instance of {@link CTSdtContentRun }
     *
     */
    public CTSdtContentRun createCTSdtContentRun() {
        return new CTSdtContentRun();
    }

    /**
     * Create an instance of {@link CTSmartTagType }
     *
     */
    public CTSmartTagType createCTSmartTagType() {
        return new CTSmartTagType();
    }

    /**
     * Create an instance of {@link CTColorSchemeMapping }
     *
     */
    public CTColorSchemeMapping createCTColorSchemeMapping() {
        return new CTColorSchemeMapping();
    }

    /**
     * Create an instance of {@link CTFFTextType }
     *
     */
    public CTFFTextType createCTFFTextType() {
        return new CTFFTextType();
    }

    /**
     * Create an instance of {@link CTSmartTagPr }
     *
     */
    public CTSmartTagPr createCTSmartTagPr() {
        return new CTSmartTagPr();
    }

    /**
     * Create an instance of {@link CTTblLayoutType }
     *
     */
    public CTTblLayoutType createCTTblLayoutType() {
        return new CTTblLayoutType();
    }

    /**
     * Create an instance of {@link CTShortHexNumber }
     *
     */
    public CTShortHexNumber createCTShortHexNumber() {
        return new CTShortHexNumber();
    }

    /**
     * Create an instance of {@link CTSignedHpsMeasure }
     *
     */
    public CTSignedHpsMeasure createCTSignedHpsMeasure() {
        return new CTSignedHpsMeasure();
    }

    /**
     * Create an instance of {@link CTAltChunkPr }
     *
     */
    public CTAltChunkPr createCTAltChunkPr() {
        return new CTAltChunkPr();
    }

    /**
     * Create an instance of {@link CTMailMergeDocType }
     *
     */
    public CTMailMergeDocType createCTMailMergeDocType() {
        return new CTMailMergeDocType();
    }

    /**
     * Create an instance of {@link CTTblCellMar }
     *
     */
    public CTTblCellMar createCTTblCellMar() {
        return new CTTblCellMar();
    }

    /**
     * Create an instance of {@link CTMailMergeSourceType }
     *
     */
    public CTMailMergeSourceType createCTMailMergeSourceType() {
        return new CTMailMergeSourceType();
    }

    /**
     * Create an instance of {@link CTFFName }
     *
     */
    public CTFFName createCTFFName() {
        return new CTFFName();
    }

    /**
     * Create an instance of {@link CTCompatSetting }
     *
     */
    public CTCompatSetting createCTCompatSetting() {
        return new CTCompatSetting();
    }

    /**
     * Create an instance of {@link TblGridCol }
     *
     */
    public TblGridCol createTblGridCol() {
        return new TblGridCol();
    }

    /**
     * Create an instance of {@link CTTblPPr }
     *
     */
    public CTTblPPr createCTTblPPr() {
        return new CTTblPPr();
    }

    /**
     * Create an instance of {@link CTDocPartType }
     *
     */
    public CTDocPartType createCTDocPartType() {
        return new CTDocPartType();
    }

    /**
     * Create an instance of {@link CTSdtComboBox }
     *
     */
    public CTSdtComboBox createCTSdtComboBox() {
        return new CTSdtComboBox();
    }

    /**
     * Create an instance of {@link CTTblPrExChange }
     *
     */
    public CTTblPrExChange createCTTblPrExChange() {
        return new CTTblPrExChange();
    }

    /**
     * Create an instance of {@link CTDecimalNumber }
     *
     */
    public CTDecimalNumber createCTDecimalNumber() {
        return new CTDecimalNumber();
    }

    /**
     * Create an instance of {@link CTPictureBase }
     *
     */
    public CTPictureBase createCTPictureBase() {
        return new CTPictureBase();
    }

    /**
     * Create an instance of {@link CTDocPartName }
     *
     */
    public CTDocPartName createCTDocPartName() {
        return new CTDocPartName();
    }

    /**
     * Create an instance of {@link CTBookmarkRange }
     *
     */
    public CTBookmarkRange createCTBookmarkRange() {
        return new CTBookmarkRange();
    }

    /**
     * Create an instance of {@link FontFamily }
     *
     */
    public FontFamily createFontFamily() {
        return new FontFamily();
    }

    /**
     * Create an instance of {@link TcMar }
     *
     */
    public TcMar createTcMar() {
        return new TcMar();
    }

    /**
     * Create an instance of {@link CTRubyContent }
     *
     */
    public CTRubyContent createCTRubyContent() {
        return new CTRubyContent();
    }

    /**
     * Create an instance of {@link CTProof }
     *
     */
    public CTProof createCTProof() {
        return new CTProof();
    }

    /**
     * Create an instance of {@link CTCnf }
     *
     */
    public CTCnf createCTCnf() {
        return new CTCnf();
    }

    /**
     * Create an instance of {@link CTString }
     *
     */
    public CTString createCTString() {
        return new CTString();
    }

    /**
     * Create an instance of {@link CTSdtRow }
     *
     */
    public CTSdtRow createCTSdtRow() {
        return new CTSdtRow();
    }

    /**
     * Create an instance of {@link CTWritingStyle }
     *
     */
    public CTWritingStyle createCTWritingStyle() {
        return new CTWritingStyle();
    }

    /**
     * Create an instance of {@link CTBorder }
     *
     */
    public CTBorder createCTBorder() {
        return new CTBorder();
    }

    /**
     * Create an instance of {@link CTMacroName }
     *
     */
    public CTMacroName createCTMacroName() {
        return new CTMacroName();
    }

    /**
     * Create an instance of {@link CTMailMerge.ConnectString }
     *
     */
    public CTMailMerge.ConnectString createCTMailMergeConnectString() {
        return new CTMailMerge.ConnectString();
    }

    /**
     * Create an instance of {@link CTMailMerge.Query }
     *
     */
    public CTMailMerge.Query createCTMailMergeQuery() {
        return new CTMailMerge.Query();
    }

    /**
     * Create an instance of {@link CTMailMerge.AddressFieldName }
     *
     */
    public CTMailMerge.AddressFieldName createCTMailMergeAddressFieldName() {
        return new CTMailMerge.AddressFieldName();
    }

    /**
     * Create an instance of {@link CTMailMerge.MailSubject }
     *
     */
    public CTMailMerge.MailSubject createCTMailMergeMailSubject() {
        return new CTMailMerge.MailSubject();
    }

    /**
     * Create an instance of {@link CTMailMerge.ActiveRecord }
     *
     */
    public CTMailMerge.ActiveRecord createCTMailMergeActiveRecord() {
        return new CTMailMerge.ActiveRecord();
    }

    /**
     * Create an instance of {@link CTMailMerge.CheckErrors }
     *
     */
    public CTMailMerge.CheckErrors createCTMailMergeCheckErrors() {
        return new CTMailMerge.CheckErrors();
    }

    /**
     * Create an instance of {@link CTOdsoFieldMapData.Name }
     *
     */
    public CTOdsoFieldMapData.Name createCTOdsoFieldMapDataName() {
        return new CTOdsoFieldMapData.Name();
    }

    /**
     * Create an instance of {@link CTOdsoFieldMapData.MappedName }
     *
     */
    public CTOdsoFieldMapData.MappedName createCTOdsoFieldMapDataMappedName() {
        return new CTOdsoFieldMapData.MappedName();
    }

    /**
     * Create an instance of {@link CTOdsoFieldMapData.Column }
     *
     */
    public CTOdsoFieldMapData.Column createCTOdsoFieldMapDataColumn() {
        return new CTOdsoFieldMapData.Column();
    }

    /**
     * Create an instance of {@link CTEdnProps.NumStart }
     *
     */
    public CTEdnProps.NumStart createCTEdnPropsNumStart() {
        return new CTEdnProps.NumStart();
    }

    /**
     * Create an instance of {@link CTSdtDate.DateFormat }
     *
     */
    public CTSdtDate.DateFormat createCTSdtDateDateFormat() {
        return new CTSdtDate.DateFormat();
    }

    /**
     * Create an instance of {@link CTRecipientData.Column }
     *
     */
    public CTRecipientData.Column createCTRecipientDataColumn() {
        return new CTRecipientData.Column();
    }

    /**
     * Create an instance of {@link CTPlaceholder.DocPart }
     *
     */
    public CTPlaceholder.DocPart createCTPlaceholderDocPart() {
        return new CTPlaceholder.DocPart();
    }

    /**
     * Create an instance of {@link CTCustomXmlPr.Placeholder }
     *
     */
    public CTCustomXmlPr.Placeholder createCTCustomXmlPrPlaceholder() {
        return new CTCustomXmlPr.Placeholder();
    }

    /**
     * Create an instance of {@link CTFrame.Sz }
     *
     */
    public CTFrame.Sz createCTFrameSz() {
        return new CTFrame.Sz();
    }

    /**
     * Create an instance of {@link CTFrame.Name }
     *
     */
    public CTFrame.Name createCTFrameName() {
        return new CTFrame.Name();
    }

    /**
     * Create an instance of {@link CTFFTextInput.Default }
     *
     */
    public CTFFTextInput.Default createCTFFTextInputDefault() {
        return new CTFFTextInput.Default();
    }

    /**
     * Create an instance of {@link CTFFTextInput.MaxLength }
     *
     */
    public CTFFTextInput.MaxLength createCTFFTextInputMaxLength() {
        return new CTFFTextInput.MaxLength();
    }

    /**
     * Create an instance of {@link CTFFTextInput.Format }
     *
     */
    public CTFFTextInput.Format createCTFFTextInputFormat() {
        return new CTFFTextInput.Format();
    }

    /**
     * Create an instance of {@link CTFramesetSplitbar.Color }
     *
     */
    public CTFramesetSplitbar.Color createCTFramesetSplitbarColor() {
        return new CTFramesetSplitbar.Color();
    }

    /**
     * Create an instance of {@link CTFFDDList.Result }
     *
     */
    public CTFFDDList.Result createCTFFDDListResult() {
        return new CTFFDDList.Result();
    }

    /**
     * Create an instance of {@link CTFFDDList.Default }
     *
     */
    public CTFFDDList.Default createCTFFDDListDefault() {
        return new CTFFDDList.Default();
    }

    /**
     * Create an instance of {@link CTFFDDList.ListEntry }
     *
     */
    public CTFFDDList.ListEntry createCTFFDDListListEntry() {
        return new CTFFDDList.ListEntry();
    }

    /**
     * Create an instance of {@link CTTrPrBase.DivId }
     *
     */
    public CTTrPrBase.DivId createCTTrPrBaseDivId() {
        return new CTTrPrBase.DivId();
    }

    /**
     * Create an instance of {@link CTTrPrBase.GridBefore }
     *
     */
    public CTTrPrBase.GridBefore createCTTrPrBaseGridBefore() {
        return new CTTrPrBase.GridBefore();
    }

    /**
     * Create an instance of {@link CTTrPrBase.GridAfter }
     *
     */
    public CTTrPrBase.GridAfter createCTTrPrBaseGridAfter() {
        return new CTTrPrBase.GridAfter();
    }

    /**
     * Create an instance of {@link SdtPr.Alias }
     *
     */
    public SdtPr.Alias createSdtPrAlias() {
        return new SdtPr.Alias();
    }

    /**
     * Create an instance of {@link SdtPr.Equation }
     *
     */
    public SdtPr.Equation createSdtPrEquation() {
        return new SdtPr.Equation();
    }

    /**
     * Create an instance of {@link SdtPr.Picture }
     *
     */
    public SdtPr.Picture createSdtPrPicture() {
        return new SdtPr.Picture();
    }

    /**
     * Create an instance of {@link SdtPr.RichText }
     *
     */
    public SdtPr.RichText createSdtPrRichText() {
        return new SdtPr.RichText();
    }

    /**
     * Create an instance of {@link SdtPr.Citation }
     *
     */
    public SdtPr.Citation createSdtPrCitation() {
        return new SdtPr.Citation();
    }

    /**
     * Create an instance of {@link SdtPr.Group }
     *
     */
    public SdtPr.Group createSdtPrGroup() {
        return new SdtPr.Group();
    }

    /**
     * Create an instance of {@link SdtPr.Bibliography }
     *
     */
    public SdtPr.Bibliography createSdtPrBibliography() {
        return new SdtPr.Bibliography();
    }

    /**
     * Create an instance of {@link CTOdso.Udl }
     *
     */
    public CTOdso.Udl createCTOdsoUdl() {
        return new CTOdso.Udl();
    }

    /**
     * Create an instance of {@link CTOdso.Table }
     *
     */
    public CTOdso.Table createCTOdsoTable() {
        return new CTOdso.Table();
    }

    /**
     * Create an instance of {@link CTOdso.ColDelim }
     *
     */
    public CTOdso.ColDelim createCTOdsoColDelim() {
        return new CTOdso.ColDelim();
    }

    /**
     * Create an instance of {@link SectPr.Type }
     *
     */
    public SectPr.Type createSectPrType() {
        return new SectPr.Type();
    }

    /**
     * Create an instance of {@link SectPr.PgSz }
     *
     */
    public SectPr.PgSz createSectPrPgSz() {
        return new SectPr.PgSz();
    }

    /**
     * Create an instance of {@link SectPr.PgMar }
     *
     */
    public SectPr.PgMar createSectPrPgMar() {
        return new SectPr.PgMar();
    }

    /**
     * Create an instance of {@link SectPr.PgBorders }
     *
     */
    public SectPr.PgBorders createSectPrPgBorders() {
        return new SectPr.PgBorders();
    }

    /**
     * Create an instance of {@link CTRPrChange.RPr }
     *
     */
    public CTRPrChange.RPr createCTRPrChangeRPr() {
        return new CTRPrChange.RPr();
    }

    /**
     * Create an instance of {@link CTDocPartPr.Style }
     *
     */
    public CTDocPartPr.Style createCTDocPartPrStyle() {
        return new CTDocPartPr.Style();
    }

    /**
     * Create an instance of {@link CTDocPartPr.Description }
     *
     */
    public CTDocPartPr.Description createCTDocPartPrDescription() {
        return new CTDocPartPr.Description();
    }

    /**
     * Create an instance of {@link TcPrInner.GridSpan }
     *
     */
    public TcPrInner.GridSpan createTcPrInnerGridSpan() {
        return new TcPrInner.GridSpan();
    }

    /**
     * Create an instance of {@link TcPrInner.HMerge }
     *
     */
    public TcPrInner.HMerge createTcPrInnerHMerge() {
        return new TcPrInner.HMerge();
    }

    /**
     * Create an instance of {@link TcPrInner.VMerge }
     *
     */
    public TcPrInner.VMerge createTcPrInnerVMerge() {
        return new TcPrInner.VMerge();
    }

    /**
     * Create an instance of {@link TcPrInner.TcBorders }
     *
     */
    public TcPrInner.TcBorders createTcPrInnerTcBorders() {
        return new TcPrInner.TcBorders();
    }

    /**
     * Create an instance of {@link PPrBase.PStyle }
     *
     */
    public PPrBase.PStyle createPPrBasePStyle() {
        return new PPrBase.PStyle();
    }

    /**
     * Create an instance of {@link PPrBase.PBdr }
     *
     */
    public PPrBase.PBdr createPPrBasePBdr() {
        return new PPrBase.PBdr();
    }

    /**
     * Create an instance of {@link PPrBase.Spacing }
     *
     */
    public PPrBase.Spacing createPPrBaseSpacing() {
        return new PPrBase.Spacing();
    }

    /**
     * Create an instance of {@link PPrBase.Ind }
     *
     */
    public PPrBase.Ind createPPrBaseInd() {
        return new PPrBase.Ind();
    }

    /**
     * Create an instance of {@link PPrBase.TextAlignment }
     *
     */
    public PPrBase.TextAlignment createPPrBaseTextAlignment() {
        return new PPrBase.TextAlignment();
    }

    /**
     * Create an instance of {@link PPrBase.OutlineLvl }
     *
     */
    public PPrBase.OutlineLvl createPPrBaseOutlineLvl() {
        return new PPrBase.OutlineLvl();
    }

    /**
     * Create an instance of {@link PPrBase.DivId }
     *
     */
    public PPrBase.DivId createPPrBaseDivId() {
        return new PPrBase.DivId();
    }

    /**
     * Create an instance of {@link PPrBase.NumPr.Ilvl }
     *
     */
    public PPrBase.NumPr.Ilvl createPPrBaseNumPrIlvl() {
        return new PPrBase.NumPr.Ilvl();
    }

    /**
     * Create an instance of {@link PPrBase.NumPr.NumId }
     *
     */
    public PPrBase.NumPr.NumId createPPrBaseNumPrNumId() {
        return new PPrBase.NumPr.NumId();
    }

    /**
     * Create an instance of {@link Lvl.Start }
     *
     */
    public Lvl.Start createLvlStart() {
        return new Lvl.Start();
    }

    /**
     * Create an instance of {@link Lvl.LvlRestart }
     *
     */
    public Lvl.LvlRestart createLvlLvlRestart() {
        return new Lvl.LvlRestart();
    }

    /**
     * Create an instance of {@link Lvl.PStyle }
     *
     */
    public Lvl.PStyle createLvlPStyle() {
        return new Lvl.PStyle();
    }

    /**
     * Create an instance of {@link Lvl.Suff }
     *
     */
    public Lvl.Suff createLvlSuff() {
        return new Lvl.Suff();
    }

    /**
     * Create an instance of {@link Lvl.LvlText }
     *
     */
    public Lvl.LvlText createLvlLvlText() {
        return new Lvl.LvlText();
    }

    /**
     * Create an instance of {@link Lvl.LvlPicBulletId }
     *
     */
    public Lvl.LvlPicBulletId createLvlLvlPicBulletId() {
        return new Lvl.LvlPicBulletId();
    }

    /**
     * Create an instance of {@link Lvl.Legacy }
     *
     */
    public Lvl.Legacy createLvlLegacy() {
        return new Lvl.Legacy();
    }

    /**
     * Create an instance of {@link CTSdtDocPart.DocPartGallery }
     *
     */
    public CTSdtDocPart.DocPartGallery createCTSdtDocPartDocPartGallery() {
        return new CTSdtDocPart.DocPartGallery();
    }

    /**
     * Create an instance of {@link CTSdtDocPart.DocPartCategory }
     *
     */
    public CTSdtDocPart.DocPartCategory createCTSdtDocPartDocPartCategory() {
        return new CTSdtDocPart.DocPartCategory();
    }

    /**
     * Create an instance of {@link CTTblPrBase.TblStyle }
     *
     */
    public CTTblPrBase.TblStyle createCTTblPrBaseTblStyle() {
        return new CTTblPrBase.TblStyle();
    }

    /**
     * Create an instance of {@link CTTblPrBase.TblStyleRowBandSize }
     *
     */
    public CTTblPrBase.TblStyleRowBandSize createCTTblPrBaseTblStyleRowBandSize() {
        return new CTTblPrBase.TblStyleRowBandSize();
    }

    /**
     * Create an instance of {@link CTTblPrBase.TblStyleColBandSize }
     *
     */
    public CTTblPrBase.TblStyleColBandSize createCTTblPrBaseTblStyleColBandSize() {
        return new CTTblPrBase.TblStyleColBandSize();
    }

    /**
     * Create an instance of {@link CTFrameset.Sz }
     *
     */
    public CTFrameset.Sz createCTFramesetSz() {
        return new CTFrameset.Sz();
    }

    /**
     * Create an instance of {@link CTDocPartCategory.Name }
     *
     */
    public CTDocPartCategory.Name createCTDocPartCategoryName() {
        return new CTDocPartCategory.Name();
    }

    /**
     * Create an instance of {@link Fonts.Font.AltName }
     *
     */
    public Fonts.Font.AltName createFontsFontAltName() {
        return new Fonts.Font.AltName();
    }

    /**
     * Create an instance of {@link Styles.LatentStyles.LsdException }
     *
     */
    public Styles.LatentStyles.LsdException createStylesLatentStylesLsdException() {
        return new Styles.LatentStyles.LsdException();
    }

    /**
     * Create an instance of {@link CTWebSettings.Encoding }
     *
     */
    public CTWebSettings.Encoding createCTWebSettingsEncoding() {
        return new CTWebSettings.Encoding();
    }

    /**
     * Create an instance of {@link CTWebSettings.PixelsPerInch }
     *
     */
    public CTWebSettings.PixelsPerInch createCTWebSettingsPixelsPerInch() {
        return new CTWebSettings.PixelsPerInch();
    }

    /**
     * Create an instance of {@link Numbering.Num.AbstractNumId }
     *
     */
    public Numbering.Num.AbstractNumId createNumberingNumAbstractNumId() {
        return new Numbering.Num.AbstractNumId();
    }

    /**
     * Create an instance of {@link Numbering.Num.LvlOverride.StartOverride }
     *
     */
    public Numbering.Num.LvlOverride.StartOverride createNumberingNumLvlOverrideStartOverride() {
        return new Numbering.Num.LvlOverride.StartOverride();
    }

    /**
     * Create an instance of {@link Numbering.AbstractNum.MultiLevelType }
     *
     */
    public Numbering.AbstractNum.MultiLevelType createNumberingAbstractNumMultiLevelType() {
        return new Numbering.AbstractNum.MultiLevelType();
    }

    /**
     * Create an instance of {@link Numbering.AbstractNum.Name }
     *
     */
    public Numbering.AbstractNum.Name createNumberingAbstractNumName() {
        return new Numbering.AbstractNum.Name();
    }

    /**
     * Create an instance of {@link Numbering.AbstractNum.StyleLink }
     *
     */
    public Numbering.AbstractNum.StyleLink createNumberingAbstractNumStyleLink() {
        return new Numbering.AbstractNum.StyleLink();
    }

    /**
     * Create an instance of {@link Numbering.AbstractNum.NumStyleLink }
     *
     */
    public Numbering.AbstractNum.NumStyleLink createNumberingAbstractNumNumStyleLink() {
        return new Numbering.AbstractNum.NumStyleLink();
    }

    /**
     * Create an instance of {@link CTSettings.ConsecutiveHyphenLimit }
     *
     */
    public CTSettings.ConsecutiveHyphenLimit createCTSettingsConsecutiveHyphenLimit() {
        return new CTSettings.ConsecutiveHyphenLimit();
    }

    /**
     * Create an instance of {@link CTSettings.SummaryLength }
     *
     */
    public CTSettings.SummaryLength createCTSettingsSummaryLength() {
        return new CTSettings.SummaryLength();
    }

    /**
     * Create an instance of {@link CTSettings.ClickAndTypeStyle }
     *
     */
    public CTSettings.ClickAndTypeStyle createCTSettingsClickAndTypeStyle() {
        return new CTSettings.ClickAndTypeStyle();
    }

    /**
     * Create an instance of {@link CTSettings.DefaultTableStyle }
     *
     */
    public CTSettings.DefaultTableStyle createCTSettingsDefaultTableStyle() {
        return new CTSettings.DefaultTableStyle();
    }

    /**
     * Create an instance of {@link CTSettings.BookFoldPrintingSheets }
     *
     */
    public CTSettings.BookFoldPrintingSheets createCTSettingsBookFoldPrintingSheets() {
        return new CTSettings.BookFoldPrintingSheets();
    }

    /**
     * Create an instance of {@link CTSettings.DisplayHorizontalDrawingGridEvery }
     *
     */
    public CTSettings.DisplayHorizontalDrawingGridEvery createCTSettingsDisplayHorizontalDrawingGridEvery() {
        return new CTSettings.DisplayHorizontalDrawingGridEvery();
    }

    /**
     * Create an instance of {@link CTSettings.DisplayVerticalDrawingGridEvery }
     *
     */
    public CTSettings.DisplayVerticalDrawingGridEvery createCTSettingsDisplayVerticalDrawingGridEvery() {
        return new CTSettings.DisplayVerticalDrawingGridEvery();
    }

    /**
     * Create an instance of {@link CTSettings.AttachedSchema }
     *
     */
    public CTSettings.AttachedSchema createCTSettingsAttachedSchema() {
        return new CTSettings.AttachedSchema();
    }

    /**
     * Create an instance of {@link CTSettings.ForceUpgrade }
     *
     */
    public CTSettings.ForceUpgrade createCTSettingsForceUpgrade() {
        return new CTSettings.ForceUpgrade();
    }

    /**
     * Create an instance of {@link CTSettings.DecimalSymbol }
     *
     */
    public CTSettings.DecimalSymbol createCTSettingsDecimalSymbol() {
        return new CTSettings.DecimalSymbol();
    }

    /**
     * Create an instance of {@link CTSettings.ListSeparator }
     *
     */
    public CTSettings.ListSeparator createCTSettingsListSeparator() {
        return new CTSettings.ListSeparator();
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTRecipients }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "recipients")
    public JAXBElement<CTRecipients> createRecipients(CTRecipients value) {
        return new JAXBElement<CTRecipients>(_Recipients_QNAME, CTRecipients.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTEndnotes }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "endnotes")
    public JAXBElement<CTEndnotes> createEndnotes(CTEndnotes value) {
        return new JAXBElement<CTEndnotes>(_Endnotes_QNAME, CTEndnotes.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTWebSettings }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "webSettings")
    public JAXBElement<CTWebSettings> createWebSettings(CTWebSettings value) {
        return new JAXBElement<CTWebSettings>(_WebSettings_QNAME, CTWebSettings.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTxbxContent }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "txbxContent")
    public JAXBElement<CTTxbxContent> createTxbxContent(CTTxbxContent value) {
        return new JAXBElement<CTTxbxContent>(_TxbxContent_QNAME, CTTxbxContent.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTFootnotes }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "footnotes")
    public JAXBElement<CTFootnotes> createFootnotes(CTFootnotes value) {
        return new JAXBElement<CTFootnotes>(_Footnotes_QNAME, CTFootnotes.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Body }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "body")
    public JAXBElement<Body> createBody(Body value) {
        return new JAXBElement<Body>(_Body_QNAME, Body.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSettings }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "settings")
    public JAXBElement<CTSettings> createSettings(CTSettings value) {
        return new JAXBElement<CTSettings>(_Settings_QNAME, CTSettings.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link R.MonthShort }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "monthShort", scope = R.class)
    public JAXBElement<R.MonthShort> createRMonthShort(R.MonthShort value) {
        return new JAXBElement<R.MonthShort>(_RMonthShort_QNAME, R.MonthShort.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link R.YearLong }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "yearLong", scope = R.class)
    public JAXBElement<R.YearLong> createRYearLong(R.YearLong value) {
        return new JAXBElement<R.YearLong>(_RYearLong_QNAME, R.YearLong.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link R.PgNum }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "pgNum", scope = R.class)
    public JAXBElement<R.PgNum> createRPgNum(R.PgNum value) {
        return new JAXBElement<R.PgNum>(_RPgNum_QNAME, R.PgNum.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTFtnEdnRef }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "footnoteReference", scope = R.class)
    public JAXBElement<CTFtnEdnRef> createRFootnoteReference(CTFtnEdnRef value) {
        return new JAXBElement<CTFtnEdnRef>(_RFootnoteReference_QNAME, CTFtnEdnRef.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link R.EndnoteRef }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "endnoteRef", scope = R.class)
    public JAXBElement<R.EndnoteRef> createREndnoteRef(R.EndnoteRef value) {
        return new JAXBElement<R.EndnoteRef>(_REndnoteRef_QNAME, R.EndnoteRef.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link R.SoftHyphen }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "softHyphen", scope = R.class)
    public JAXBElement<R.SoftHyphen> createRSoftHyphen(R.SoftHyphen value) {
        return new JAXBElement<R.SoftHyphen>(_RSoftHyphen_QNAME, R.SoftHyphen.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTFtnEdnRef }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "endnoteReference", scope = R.class)
    public JAXBElement<CTFtnEdnRef> createREndnoteReference(CTFtnEdnRef value) {
        return new JAXBElement<CTFtnEdnRef>(_REndnoteReference_QNAME, CTFtnEdnRef.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Text }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "t", scope = R.class)
    public JAXBElement<Text> createRT(Text value) {
        return new JAXBElement<Text>(_RT_QNAME, Text.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link R.Cr }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "cr", scope = R.class)
    public JAXBElement<R.Cr> createRCr(R.Cr value) {
        return new JAXBElement<R.Cr>(_RCr_QNAME, R.Cr.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link FldChar }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "fldChar", scope = R.class)
    public JAXBElement<FldChar> createRFldChar(FldChar value) {
        return new JAXBElement<FldChar>(_RFldChar_QNAME, FldChar.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link R.CommentReference }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "commentReference", scope = R.class)
    public JAXBElement<R.CommentReference> createRCommentReference(R.CommentReference value) {
        return new JAXBElement<R.CommentReference>(_RCommentReference_QNAME, R.CommentReference.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link R.Separator }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "separator", scope = R.class)
    public JAXBElement<R.Separator> createRSeparator(R.Separator value) {
        return new JAXBElement<R.Separator>(_RSeparator_QNAME, R.Separator.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link R.DayLong }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "dayLong", scope = R.class)
    public JAXBElement<R.DayLong> createRDayLong(R.DayLong value) {
        return new JAXBElement<R.DayLong>(_RDayLong_QNAME, R.DayLong.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link R.AnnotationRef }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "annotationRef", scope = R.class)
    public JAXBElement<R.AnnotationRef> createRAnnotationRef(R.AnnotationRef value) {
        return new JAXBElement<R.AnnotationRef>(_RAnnotationRef_QNAME, R.AnnotationRef.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTRuby }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "ruby", scope = R.class)
    public JAXBElement<CTRuby> createRRuby(CTRuby value) {
        return new JAXBElement<CTRuby>(_RRuby_QNAME, CTRuby.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTObject }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "object", scope = R.class)
    public JAXBElement<CTObject> createRObject(CTObject value) {
        return new JAXBElement<CTObject>(_RObject_QNAME, CTObject.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link R.Tab }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "tab", scope = R.class)
    public JAXBElement<R.Tab> createRTab(R.Tab value) {
        return new JAXBElement<R.Tab>(_RTab_QNAME, R.Tab.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link R.LastRenderedPageBreak }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "lastRenderedPageBreak", scope = R.class)
    public JAXBElement<R.LastRenderedPageBreak> createRLastRenderedPageBreak(R.LastRenderedPageBreak value) {
        return new JAXBElement<R.LastRenderedPageBreak>(_RLastRenderedPageBreak_QNAME, R.LastRenderedPageBreak.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Drawing }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "drawing", scope = R.class)
    public JAXBElement<Drawing> createRDrawing(Drawing value) {
        return new JAXBElement<Drawing>(_RDrawing_QNAME, Drawing.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Text }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "delInstrText", scope = R.class)
    public JAXBElement<DelInstrText> createRDelInstrText(DelInstrText value) {
        return new JAXBElement<DelInstrText>(_RDelInstrText_QNAME, DelInstrText.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Text }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "instrText", scope = R.class)
    public JAXBElement<InstrText> createRInstrText(InstrText value) {
        return new JAXBElement<InstrText>(_RInstrText_QNAME, InstrText.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link R.Sym }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "sym", scope = R.class)
    public JAXBElement<R.Sym> createRSym(R.Sym value) {
        return new JAXBElement<R.Sym>(_RSym_QNAME, R.Sym.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Pict }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "pict", scope = R.class)
    public JAXBElement<Pict> createRPict(Pict value) {
        return new JAXBElement<Pict>(_RPict_QNAME, Pict.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link R.ContinuationSeparator }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "continuationSeparator", scope = R.class)
    public JAXBElement<R.ContinuationSeparator> createRContinuationSeparator(R.ContinuationSeparator value) {
        return new JAXBElement<R.ContinuationSeparator>(_RContinuationSeparator_QNAME, R.ContinuationSeparator.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link R.FootnoteRef }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "footnoteRef", scope = R.class)
    public JAXBElement<R.FootnoteRef> createRFootnoteRef(R.FootnoteRef value) {
        return new JAXBElement<R.FootnoteRef>(_RFootnoteRef_QNAME, R.FootnoteRef.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link R.YearShort }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "yearShort", scope = R.class)
    public JAXBElement<R.YearShort> createRYearShort(R.YearShort value) {
        return new JAXBElement<R.YearShort>(_RYearShort_QNAME, R.YearShort.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link R.DayShort }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "dayShort", scope = R.class)
    public JAXBElement<R.DayShort> createRDayShort(R.DayShort value) {
        return new JAXBElement<R.DayShort>(_RDayShort_QNAME, R.DayShort.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link R.MonthLong }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "monthLong", scope = R.class)
    public JAXBElement<R.MonthLong> createRMonthLong(R.MonthLong value) {
        return new JAXBElement<R.MonthLong>(_RMonthLong_QNAME, R.MonthLong.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link R.Ptab }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "ptab", scope = R.class)
    public JAXBElement<R.Ptab> createRPtab(R.Ptab value) {
        return new JAXBElement<R.Ptab>(_RPtab_QNAME, R.Ptab.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link R.NoBreakHyphen }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "noBreakHyphen", scope = R.class)
    public JAXBElement<R.NoBreakHyphen> createRNoBreakHyphen(R.NoBreakHyphen value) {
        return new JAXBElement<R.NoBreakHyphen>(_RNoBreakHyphen_QNAME, R.NoBreakHyphen.class, R.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "rtl", scope = CTRPrChange.RPr.class)
    public JAXBElement<BooleanDefaultTrue> createCTRPrChangeRPrRtl(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrRtl_QNAME, BooleanDefaultTrue.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "b", scope = CTRPrChange.RPr.class)
    public JAXBElement<BooleanDefaultTrue> createCTRPrChangeRPrB(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrB_QNAME, BooleanDefaultTrue.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "snapToGrid", scope = CTRPrChange.RPr.class)
    public JAXBElement<BooleanDefaultTrue> createCTRPrChangeRPrSnapToGrid(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrSnapToGrid_QNAME, BooleanDefaultTrue.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "cs", scope = CTRPrChange.RPr.class)
    public JAXBElement<BooleanDefaultTrue> createCTRPrChangeRPrCs(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrCs_QNAME, BooleanDefaultTrue.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "dstrike", scope = CTRPrChange.RPr.class)
    public JAXBElement<BooleanDefaultTrue> createCTRPrChangeRPrDstrike(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrDstrike_QNAME, BooleanDefaultTrue.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "iCs", scope = CTRPrChange.RPr.class)
    public JAXBElement<BooleanDefaultTrue> createCTRPrChangeRPrICs(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrICs_QNAME, BooleanDefaultTrue.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "i", scope = CTRPrChange.RPr.class)
    public JAXBElement<BooleanDefaultTrue> createCTRPrChangeRPrI(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrI_QNAME, BooleanDefaultTrue.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "oMath", scope = CTRPrChange.RPr.class)
    public JAXBElement<BooleanDefaultTrue> createCTRPrChangeRPrOMath(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrOMath_QNAME, BooleanDefaultTrue.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "noProof", scope = CTRPrChange.RPr.class)
    public JAXBElement<BooleanDefaultTrue> createCTRPrChangeRPrNoProof(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrNoProof_QNAME, BooleanDefaultTrue.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTVerticalAlignRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "vertAlign", scope = CTRPrChange.RPr.class)
    public JAXBElement<CTVerticalAlignRun> createCTRPrChangeRPrVertAlign(CTVerticalAlignRun value) {
        return new JAXBElement<CTVerticalAlignRun>(_CTRPrChangeRPrVertAlign_QNAME, CTVerticalAlignRun.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTextScale }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "w", scope = CTRPrChange.RPr.class)
    public JAXBElement<CTTextScale> createCTRPrChangeRPrW(CTTextScale value) {
        return new JAXBElement<CTTextScale>(_CTRPrChangeRPrW_QNAME, CTTextScale.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "caps", scope = CTRPrChange.RPr.class)
    public JAXBElement<BooleanDefaultTrue> createCTRPrChangeRPrCaps(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrCaps_QNAME, BooleanDefaultTrue.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTextEffect }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "effect", scope = CTRPrChange.RPr.class)
    public JAXBElement<CTTextEffect> createCTRPrChangeRPrEffect(CTTextEffect value) {
        return new JAXBElement<CTTextEffect>(_CTRPrChangeRPrEffect_QNAME, CTTextEffect.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTEm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "em", scope = CTRPrChange.RPr.class)
    public JAXBElement<CTEm> createCTRPrChangeRPrEm(CTEm value) {
        return new JAXBElement<CTEm>(_CTRPrChangeRPrEm_QNAME, CTEm.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "webHidden", scope = CTRPrChange.RPr.class)
    public JAXBElement<BooleanDefaultTrue> createCTRPrChangeRPrWebHidden(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrWebHidden_QNAME, BooleanDefaultTrue.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSignedHpsMeasure }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "position", scope = CTRPrChange.RPr.class)
    public JAXBElement<CTSignedHpsMeasure> createCTRPrChangeRPrPosition(CTSignedHpsMeasure value) {
        return new JAXBElement<CTSignedHpsMeasure>(_CTRPrChangeRPrPosition_QNAME, CTSignedHpsMeasure.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTShd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "shd", scope = CTRPrChange.RPr.class)
    public JAXBElement<CTShd> createCTRPrChangeRPrShd(CTShd value) {
        return new JAXBElement<CTShd>(_CTRPrChangeRPrShd_QNAME, CTShd.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "smallCaps", scope = CTRPrChange.RPr.class)
    public JAXBElement<BooleanDefaultTrue> createCTRPrChangeRPrSmallCaps(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrSmallCaps_QNAME, BooleanDefaultTrue.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "specVanish", scope = CTRPrChange.RPr.class)
    public JAXBElement<BooleanDefaultTrue> createCTRPrChangeRPrSpecVanish(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrSpecVanish_QNAME, BooleanDefaultTrue.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link HpsMeasure }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "szCs", scope = CTRPrChange.RPr.class)
    public JAXBElement<HpsMeasure> createCTRPrChangeRPrSzCs(HpsMeasure value) {
        return new JAXBElement<HpsMeasure>(_CTRPrChangeRPrSzCs_QNAME, HpsMeasure.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSignedTwipsMeasure }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "spacing", scope = CTRPrChange.RPr.class)
    public JAXBElement<CTSignedTwipsMeasure> createCTRPrChangeRPrSpacing(CTSignedTwipsMeasure value) {
        return new JAXBElement<CTSignedTwipsMeasure>(_CTRPrChangeRPrSpacing_QNAME, CTSignedTwipsMeasure.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTEastAsianLayout }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "eastAsianLayout", scope = CTRPrChange.RPr.class)
    public JAXBElement<CTEastAsianLayout> createCTRPrChangeRPrEastAsianLayout(CTEastAsianLayout value) {
        return new JAXBElement<CTEastAsianLayout>(_CTRPrChangeRPrEastAsianLayout_QNAME, CTEastAsianLayout.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTFitText }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "fitText", scope = CTRPrChange.RPr.class)
    public JAXBElement<CTFitText> createCTRPrChangeRPrFitText(CTFitText value) {
        return new JAXBElement<CTFitText>(_CTRPrChangeRPrFitText_QNAME, CTFitText.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link HpsMeasure }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "kern", scope = CTRPrChange.RPr.class)
    public JAXBElement<HpsMeasure> createCTRPrChangeRPrKern(HpsMeasure value) {
        return new JAXBElement<HpsMeasure>(_CTRPrChangeRPrKern_QNAME, HpsMeasure.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "vanish", scope = CTRPrChange.RPr.class)
    public JAXBElement<BooleanDefaultTrue> createCTRPrChangeRPrVanish(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrVanish_QNAME, BooleanDefaultTrue.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTLanguage }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "lang", scope = CTRPrChange.RPr.class)
    public JAXBElement<CTLanguage> createCTRPrChangeRPrLang(CTLanguage value) {
        return new JAXBElement<CTLanguage>(_CTRPrChangeRPrLang_QNAME, CTLanguage.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "outline", scope = CTRPrChange.RPr.class)
    public JAXBElement<BooleanDefaultTrue> createCTRPrChangeRPrOutline(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrOutline_QNAME, BooleanDefaultTrue.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bCs", scope = CTRPrChange.RPr.class)
    public JAXBElement<BooleanDefaultTrue> createCTRPrChangeRPrBCs(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrBCs_QNAME, BooleanDefaultTrue.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "strike", scope = CTRPrChange.RPr.class)
    public JAXBElement<BooleanDefaultTrue> createCTRPrChangeRPrStrike(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrStrike_QNAME, BooleanDefaultTrue.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "shadow", scope = CTRPrChange.RPr.class)
    public JAXBElement<BooleanDefaultTrue> createCTRPrChangeRPrShadow(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrShadow_QNAME, BooleanDefaultTrue.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "imprint", scope = CTRPrChange.RPr.class)
    public JAXBElement<BooleanDefaultTrue> createCTRPrChangeRPrImprint(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrImprint_QNAME, BooleanDefaultTrue.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBorder }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bdr", scope = CTRPrChange.RPr.class)
    public JAXBElement<CTBorder> createCTRPrChangeRPrBdr(CTBorder value) {
        return new JAXBElement<CTBorder>(_CTRPrChangeRPrBdr_QNAME, CTBorder.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link HpsMeasure }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "sz", scope = CTRPrChange.RPr.class)
    public JAXBElement<HpsMeasure> createCTRPrChangeRPrSz(HpsMeasure value) {
        return new JAXBElement<HpsMeasure>(_CTRPrChangeRPrSz_QNAME, HpsMeasure.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "emboss", scope = CTRPrChange.RPr.class)
    public JAXBElement<BooleanDefaultTrue> createCTRPrChangeRPrEmboss(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrEmboss_QNAME, BooleanDefaultTrue.class, CTRPrChange.RPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = RunMoveFrom.class)
    public JAXBElement<CTMoveBookmark> createRunMoveFromMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = RunMoveTo.class)
    public JAXBElement<CTMoveBookmark> createRunMoveToMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = RunMoveFrom.class)
    public JAXBElement<CTMoveFromRangeEnd> createRunMoveFromMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = RunMoveTo.class)
    public JAXBElement<CTMoveFromRangeEnd> createRunMoveToMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSPre }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "sPre", scope = RunMoveFrom.class)
    public JAXBElement<CTSPre> createRunMoveFromSPre(CTSPre value) {
        return new JAXBElement<CTSPre>(_RunTrackChangeSPre_QNAME, CTSPre.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSPre }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "sPre", scope = RunMoveTo.class)
    public JAXBElement<CTSPre> createRunMoveToSPre(CTSPre value) {
        return new JAXBElement<CTSPre>(_RunTrackChangeSPre_QNAME, CTSPre.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link SdtRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "sdt", scope = RunMoveFrom.class)
    public JAXBElement<SdtRun> createRunMoveFromSdt(SdtRun value) {
        return new JAXBElement<SdtRun>(_RunTrackChangeSdt_QNAME, SdtRun.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link SdtRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "sdt", scope = RunMoveTo.class)
    public JAXBElement<SdtRun> createRunMoveToSdt(SdtRun value) {
        return new JAXBElement<SdtRun>(_RunTrackChangeSdt_QNAME, SdtRun.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = RunMoveFrom.class)
    public JAXBElement<CTMarkup> createRunMoveFromCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = RunMoveTo.class)
    public JAXBElement<CTMarkup> createRunMoveToCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = RunMoveFrom.class)
    public JAXBElement<CTMoveToRangeEnd> createRunMoveFromMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = RunMoveTo.class)
    public JAXBElement<CTMoveToRangeEnd> createRunMoveToMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBorderBox }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "borderBox", scope = RunMoveFrom.class)
    public JAXBElement<CTBorderBox> createRunMoveFromBorderBox(CTBorderBox value) {
        return new JAXBElement<CTBorderBox>(_RunTrackChangeBorderBox_QNAME, CTBorderBox.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBorderBox }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "borderBox", scope = RunMoveTo.class)
    public JAXBElement<CTBorderBox> createRunMoveToBorderBox(CTBorderBox value) {
        return new JAXBElement<CTBorderBox>(_RunTrackChangeBorderBox_QNAME, CTBorderBox.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = RunMoveFrom.class)
    public JAXBElement<CTMarkup> createRunMoveFromCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = RunMoveTo.class)
    public JAXBElement<CTMarkup> createRunMoveToCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = RunMoveFrom.class)
    public JAXBElement<CTTrackChange> createRunMoveFromCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = RunMoveTo.class)
    public JAXBElement<CTTrackChange> createRunMoveToCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = RunMoveFrom.class)
    public JAXBElement<CTTrackChange> createRunMoveFromCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = RunMoveTo.class)
    public JAXBElement<CTTrackChange> createRunMoveToCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = RunMoveFrom.class)
    public JAXBElement<CTMarkup> createRunMoveFromCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = RunMoveTo.class)
    public JAXBElement<CTMarkup> createRunMoveToCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTGroupChr }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "groupChr", scope = RunMoveFrom.class)
    public JAXBElement<CTGroupChr> createRunMoveFromGroupChr(CTGroupChr value) {
        return new JAXBElement<CTGroupChr>(_RunTrackChangeGroupChr_QNAME, CTGroupChr.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTGroupChr }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "groupChr", scope = RunMoveTo.class)
    public JAXBElement<CTGroupChr> createRunMoveToGroupChr(CTGroupChr value) {
        return new JAXBElement<CTGroupChr>(_RunTrackChangeGroupChr_QNAME, CTGroupChr.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = RunMoveFrom.class)
    public JAXBElement<RangePermissionStart> createRunMoveFromPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = RunMoveTo.class)
    public JAXBElement<RangePermissionStart> createRunMoveToPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = RunMoveFrom.class)
    public JAXBElement<CTMoveBookmark> createRunMoveFromMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = RunMoveTo.class)
    public JAXBElement<CTMoveBookmark> createRunMoveToMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTFunc }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "func", scope = RunMoveFrom.class)
    public JAXBElement<CTFunc> createRunMoveFromFunc(CTFunc value) {
        return new JAXBElement<CTFunc>(_RunTrackChangeFunc_QNAME, CTFunc.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTFunc }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "func", scope = RunMoveTo.class)
    public JAXBElement<CTFunc> createRunMoveToFunc(CTFunc value) {
        return new JAXBElement<CTFunc>(_RunTrackChangeFunc_QNAME, CTFunc.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = RunMoveFrom.class)
    public JAXBElement<CTMarkupRange> createRunMoveFromBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = RunMoveTo.class)
    public JAXBElement<CTMarkupRange> createRunMoveToBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSSubSup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "sSubSup", scope = RunMoveFrom.class)
    public JAXBElement<CTSSubSup> createRunMoveFromSSubSup(CTSSubSup value) {
        return new JAXBElement<CTSSubSup>(_RunTrackChangeSSubSup_QNAME, CTSSubSup.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSSubSup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "sSubSup", scope = RunMoveTo.class)
    public JAXBElement<CTSSubSup> createRunMoveToSSubSup(CTSSubSup value) {
        return new JAXBElement<CTSSubSup>(_RunTrackChangeSSubSup_QNAME, CTSSubSup.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = RunMoveFrom.class)
    public JAXBElement<CTMarkup> createRunMoveFromCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = RunMoveTo.class)
    public JAXBElement<CTMarkup> createRunMoveToCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTLimUpp }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "limUpp", scope = RunMoveFrom.class)
    public JAXBElement<CTLimUpp> createRunMoveFromLimUpp(CTLimUpp value) {
        return new JAXBElement<CTLimUpp>(_RunTrackChangeLimUpp_QNAME, CTLimUpp.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTLimUpp }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "limUpp", scope = RunMoveTo.class)
    public JAXBElement<CTLimUpp> createRunMoveToLimUpp(CTLimUpp value) {
        return new JAXBElement<CTLimUpp>(_RunTrackChangeLimUpp_QNAME, CTLimUpp.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTAcc }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "acc", scope = RunMoveFrom.class)
    public JAXBElement<CTAcc> createRunMoveFromAcc(CTAcc value) {
        return new JAXBElement<CTAcc>(_RunTrackChangeAcc_QNAME, CTAcc.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTAcc }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "acc", scope = RunMoveTo.class)
    public JAXBElement<CTAcc> createRunMoveToAcc(CTAcc value) {
        return new JAXBElement<CTAcc>(_RunTrackChangeAcc_QNAME, CTAcc.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = RunMoveFrom.class)
    public JAXBElement<RunMoveFrom> createRuMoveFromMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = RunMoveTo.class)
    public JAXBElement<RunMoveFrom> createRunMoveToMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = RunMoveFrom.class)
    public JAXBElement<CTTrackChange> createRunMoveFromCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = RunMoveTo.class)
    public JAXBElement<CTTrackChange> createRunMoveToCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTM }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "m", scope = RunMoveFrom.class)
    public JAXBElement<CTM> createRunMoveFromM(CTM value) {
        return new JAXBElement<CTM>(_RunTrackChangeM_QNAME, CTM.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTM }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "m", scope = RunMoveTo.class)
    public JAXBElement<CTM> createRunMoveToM(CTM value) {
        return new JAXBElement<CTM>(_RunTrackChangeM_QNAME, CTM.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = RunMoveFrom.class)
    public JAXBElement<CTTrackChange> createRunMoveFromCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = RunMoveTo.class)
    public JAXBElement<CTTrackChange> createRunMoveToCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTLimLow }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "limLow", scope = RunMoveFrom.class)
    public JAXBElement<CTLimLow> createRunMoveFromLimLow(CTLimLow value) {
        return new JAXBElement<CTLimLow>(_RunTrackChangeLimLow_QNAME, CTLimLow.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTLimLow }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "limLow", scope = RunMoveTo.class)
    public JAXBElement<CTLimLow> createRunMoveToLimLow(CTLimLow value) {
        return new JAXBElement<CTLimLow>(_RunTrackChangeLimLow_QNAME, CTLimLow.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSSup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "sSup", scope = RunMoveFrom.class)
    public JAXBElement<CTSSup> createRunMoveFromSSup(CTSSup value) {
        return new JAXBElement<CTSSup>(_RunTrackChangeSSup_QNAME, CTSSup.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSSup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "sSup", scope = RunMoveTo.class)
    public JAXBElement<CTSSup> createRunMoveToSSup(CTSSup value) {
        return new JAXBElement<CTSSup>(_RunTrackChangeSSup_QNAME, CTSSup.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTD }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "d", scope = RunMoveFrom.class)
    public JAXBElement<CTD> createRunMoveFromD(CTD value) {
        return new JAXBElement<CTD>(_RunTrackChangeD_QNAME, CTD.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTD }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "d", scope = RunMoveTo.class)
    public JAXBElement<CTD> createRunMoveToD(CTD value) {
        return new JAXBElement<CTD>(_RunTrackChangeD_QNAME, CTD.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTF }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "f", scope = RunMoveFrom.class)
    public JAXBElement<CTF> createRunMoveFromF(CTF value) {
        return new JAXBElement<CTF>(_RunTrackChangeF_QNAME, CTF.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTF }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "f", scope = RunMoveTo.class)
    public JAXBElement<CTF> createRunMoveToF(CTF value) {
        return new JAXBElement<CTF>(_RunTrackChangeF_QNAME, CTF.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTEqArr }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "eqArr", scope = RunMoveFrom.class)
    public JAXBElement<CTEqArr> createRunMoveFromEqArr(CTEqArr value) {
        return new JAXBElement<CTEqArr>(_RunTrackChangeEqArr_QNAME, CTEqArr.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTEqArr }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "eqArr", scope = RunMoveTo.class)
    public JAXBElement<CTEqArr> createRunMoveToEqArr(CTEqArr value) {
        return new JAXBElement<CTEqArr>(_RunTrackChangeEqArr_QNAME, CTEqArr.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTNary }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "nary", scope = RunMoveFrom.class)
    public JAXBElement<CTNary> createRunMoveFromNary(CTNary value) {
        return new JAXBElement<CTNary>(_RunTrackChangeNary_QNAME, CTNary.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTNary }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "nary", scope = RunMoveTo.class)
    public JAXBElement<CTNary> createRunMoveToNary(CTNary value) {
        return new JAXBElement<CTNary>(_RunTrackChangeNary_QNAME, CTNary.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTRad }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "rad", scope = RunMoveFrom.class)
    public JAXBElement<CTRad> createRunMoveFromTrackChangeRad(CTRad value) {
        return new JAXBElement<CTRad>(_RunTrackChangeRad_QNAME, CTRad.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTRad }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "rad", scope = RunMoveTo.class)
    public JAXBElement<CTRad> createRunMoveToRad(CTRad value) {
        return new JAXBElement<CTRad>(_RunTrackChangeRad_QNAME, CTRad.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBar }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "bar", scope = RunMoveFrom.class)
    public JAXBElement<CTBar> createRunMoveFromBar(CTBar value) {
        return new JAXBElement<CTBar>(_RunTrackChangeBar_QNAME, CTBar.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBar }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "bar", scope = RunMoveTo.class)
    public JAXBElement<CTBar> createRunTrackChangeBar(CTBar value) {
        return new JAXBElement<CTBar>(_RunTrackChangeBar_QNAME, CTBar.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = RunMoveFrom.class)
    public JAXBElement<CTPerm> createRunTrackChangePermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = RunMoveTo.class)
    public JAXBElement<CTPerm> createRunMoveToPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBox }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "box", scope = RunMoveFrom.class)
    public JAXBElement<CTBox> createRunMoveFromBox(CTBox value) {
        return new JAXBElement<CTBox>(_RunTrackChangeBox_QNAME, CTBox.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBox }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "box", scope = RunMoveTo.class)
    public JAXBElement<CTBox> createRunMoveToBox(CTBox value) {
        return new JAXBElement<CTBox>(_RunTrackChangeBox_QNAME, CTBox.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = RunMoveFrom.class)
    public JAXBElement<CTCustomXmlRun> createRunMoveFromChangeCustomXml(CTCustomXmlRun value) {
        return new JAXBElement<CTCustomXmlRun>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlRun.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = RunMoveTo.class)
    public JAXBElement<CTCustomXmlRun> createRunMoveToCustomXml(CTCustomXmlRun value) {
        return new JAXBElement<CTCustomXmlRun>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlRun.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = RunMoveFrom.class)
    public JAXBElement<CTBookmark> createRunMoveFromBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = RunMoveTo.class)
    public JAXBElement<CTBookmark> createRunMoveToBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTR }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "r", scope = RunMoveFrom.class)
    public JAXBElement<CTR> createRunMoveFromR(CTR value) {
        return new JAXBElement<CTR>(_RunTrackChangeR_QNAME, CTR.class, RunMoveFrom.class, value);
    }


    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTR }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "r", scope = RunMoveTo.class)
    public JAXBElement<CTR> createRunMoveToR(CTR value) {
        return new JAXBElement<CTR>(_RunTrackChangeR_QNAME, CTR.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = RunMoveFrom.class)
    public JAXBElement<RunMoveTo> createRunMoveFromMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = RunMoveTo.class)
    public JAXBElement<RunMoveTo> createRunMoveTokChangeMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPhant }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "phant", scope = RunMoveFrom.class)
    public JAXBElement<CTPhant> createRunMoveFromPhant(CTPhant value) {
        return new JAXBElement<CTPhant>(_RunTrackChangePhant_QNAME, CTPhant.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPhant }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "phant", scope = RunMoveTo.class)
    public JAXBElement<CTPhant> createRunTrackChangePhant(CTPhant value) {
        return new JAXBElement<CTPhant>(_RunTrackChangePhant_QNAME, CTPhant.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSmartTagRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "smartTag", scope = RunMoveFrom.class)
    public JAXBElement<CTSmartTagRun> createRunMoveFromSmartTag(CTSmartTagRun value) {
        return new JAXBElement<CTSmartTagRun>(_RunTrackChangeSmartTag_QNAME, CTSmartTagRun.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSmartTagRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "smartTag", scope = RunMoveTo.class)
    public JAXBElement<CTSmartTagRun> createRunMoveToSmartTag(CTSmartTagRun value) {
        return new JAXBElement<CTSmartTagRun>(_RunTrackChangeSmartTag_QNAME, CTSmartTagRun.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSSub }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "sSub", scope = RunMoveFrom.class)
    public JAXBElement<CTSSub> createRunMoveFromSSub(CTSSub value) {
        return new JAXBElement<CTSSub>(_RunTrackChangeSSub_QNAME, CTSSub.class, RunMoveFrom.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSSub }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "sSub", scope = RunMoveTo.class)
    public JAXBElement<CTSSub> createRunMoveToSSub(CTSSub value) {
        return new JAXBElement<CTSSub>(_RunTrackChangeSSub_QNAME, CTSSub.class, RunMoveTo.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = CTSmartTagRun.class)
    public JAXBElement<CTMoveBookmark> createCTSmartTagRunMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = CTSmartTagRun.class)
    public JAXBElement<RunMoveFrom> createCTSmartTagRunMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = CTSmartTagRun.class)
    public JAXBElement<CTMoveFromRangeEnd> createCTSmartTagRunMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSimpleField }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "fldSimple", scope = CTSmartTagRun.class)
    public JAXBElement<CTSimpleField> createCTSmartTagRunFldSimple(CTSimpleField value) {
        return new JAXBElement<CTSimpleField>(_CTSmartTagRunFldSimple_QNAME, CTSimpleField.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = CTSmartTagRun.class)
    public JAXBElement<CTTrackChange> createCTSmartTagRunCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link SdtRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "sdt", scope = CTSmartTagRun.class)
    public JAXBElement<SdtRun> createCTSmartTagRunSdt(SdtRun value) {
        return new JAXBElement<SdtRun>(_RunTrackChangeSdt_QNAME, SdtRun.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = CTSmartTagRun.class)
    public JAXBElement<CTMarkup> createCTSmartTagRunCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = CTSmartTagRun.class)
    public JAXBElement<CTTrackChange> createCTSmartTagRunCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = CTSmartTagRun.class)
    public JAXBElement<CTMoveToRangeEnd> createCTSmartTagRunMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = CTSmartTagRun.class)
    public JAXBElement<CTMarkup> createCTSmartTagRunCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = CTSmartTagRun.class)
    public JAXBElement<CTTrackChange> createCTSmartTagRunCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = CTSmartTagRun.class)
    public JAXBElement<CTTrackChange> createCTSmartTagRunCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = CTSmartTagRun.class)
    public JAXBElement<CTMarkup> createCTSmartTagRunCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link P.Hyperlink }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "hyperlink", scope = CTSmartTagRun.class)
    public JAXBElement<P.Hyperlink> createCTSmartTagRunHyperlink(P.Hyperlink value) {
        return new JAXBElement<P.Hyperlink>(_CTSmartTagRunHyperlink_QNAME, P.Hyperlink.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = CTSmartTagRun.class)
    public JAXBElement<RangePermissionStart> createCTSmartTagRunPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = CTSmartTagRun.class)
    public JAXBElement<CTPerm> createCTSmartTagRunPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = CTSmartTagRun.class)
    public JAXBElement<CTMoveBookmark> createCTSmartTagRunMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = CTSmartTagRun.class)
    public JAXBElement<CTMarkupRange> createCTSmartTagRunBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = CTSmartTagRun.class)
    public JAXBElement<CTCustomXmlRun> createCTSmartTagRunCustomXml(CTCustomXmlRun value) {
        return new JAXBElement<CTCustomXmlRun>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlRun.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = CTSmartTagRun.class)
    public JAXBElement<CTBookmark> createCTSmartTagRunBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = CTSmartTagRun.class)
    public JAXBElement<RunMoveTo> createCTSmartTagRunMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSmartTagRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "smartTag", scope = CTSmartTagRun.class)
    public JAXBElement<CTSmartTagRun> createCTSmartTagRunSmartTag(CTSmartTagRun value) {
        return new JAXBElement<CTSmartTagRun>(_RunTrackChangeSmartTag_QNAME, CTSmartTagRun.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = CTSmartTagRun.class)
    public JAXBElement<CTMarkup> createCTSmartTagRunCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTRel }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "subDoc", scope = CTSmartTagRun.class)
    public JAXBElement<CTRel> createCTSmartTagRunSubDoc(CTRel value) {
        return new JAXBElement<CTRel>(_CTSmartTagRunSubDoc_QNAME, CTRel.class, CTSmartTagRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = CTSdtContentRun.class)
    public JAXBElement<CTMoveBookmark> createCTSdtContentRunMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = CTSdtContentRun.class)
    public JAXBElement<RunMoveFrom> createCTSdtContentRunMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = CTSdtContentRun.class)
    public JAXBElement<CTMoveFromRangeEnd> createCTSdtContentRunMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSimpleField }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "fldSimple", scope = CTSdtContentRun.class)
    public JAXBElement<CTSimpleField> createCTSdtContentRunFldSimple(CTSimpleField value) {
        return new JAXBElement<CTSimpleField>(_CTSmartTagRunFldSimple_QNAME, CTSimpleField.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = CTSdtContentRun.class)
    public JAXBElement<CTTrackChange> createCTSdtContentRunCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link SdtRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "sdt", scope = CTSdtContentRun.class)
    public JAXBElement<SdtRun> createCTSdtContentRunSdt(SdtRun value) {
        return new JAXBElement<SdtRun>(_RunTrackChangeSdt_QNAME, SdtRun.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = CTSdtContentRun.class)
    public JAXBElement<CTMarkup> createCTSdtContentRunCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = CTSdtContentRun.class)
    public JAXBElement<CTTrackChange> createCTSdtContentRunCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = CTSdtContentRun.class)
    public JAXBElement<CTMoveToRangeEnd> createCTSdtContentRunMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = CTSdtContentRun.class)
    public JAXBElement<CTMarkup> createCTSdtContentRunCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = CTSdtContentRun.class)
    public JAXBElement<CTTrackChange> createCTSdtContentRunCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = CTSdtContentRun.class)
    public JAXBElement<CTTrackChange> createCTSdtContentRunCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = CTSdtContentRun.class)
    public JAXBElement<CTMarkup> createCTSdtContentRunCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link P.Hyperlink }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "hyperlink", scope = CTSdtContentRun.class)
    public JAXBElement<P.Hyperlink> createCTSdtContentRunHyperlink(P.Hyperlink value) {
        return new JAXBElement<P.Hyperlink>(_CTSmartTagRunHyperlink_QNAME, P.Hyperlink.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = CTSdtContentRun.class)
    public JAXBElement<RangePermissionStart> createCTSdtContentRunPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = CTSdtContentRun.class)
    public JAXBElement<CTPerm> createCTSdtContentRunPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = CTSdtContentRun.class)
    public JAXBElement<CTMoveBookmark> createCTSdtContentRunMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = CTSdtContentRun.class)
    public JAXBElement<CTMarkupRange> createCTSdtContentRunBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = CTSdtContentRun.class)
    public JAXBElement<CTCustomXmlRun> createCTSdtContentRunCustomXml(CTCustomXmlRun value) {
        return new JAXBElement<CTCustomXmlRun>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlRun.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = CTSdtContentRun.class)
    public JAXBElement<CTBookmark> createCTSdtContentRunBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = CTSdtContentRun.class)
    public JAXBElement<RunMoveTo> createCTSdtContentRunMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSmartTagRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "smartTag", scope = CTSdtContentRun.class)
    public JAXBElement<CTSmartTagRun> createCTSdtContentRunSmartTag(CTSmartTagRun value) {
        return new JAXBElement<CTSmartTagRun>(_RunTrackChangeSmartTag_QNAME, CTSmartTagRun.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = CTSdtContentRun.class)
    public JAXBElement<CTMarkup> createCTSdtContentRunCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTRel }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "subDoc", scope = CTSdtContentRun.class)
    public JAXBElement<CTRel> createCTSdtContentRunSubDoc(CTRel value) {
        return new JAXBElement<CTRel>(_CTSmartTagRunSubDoc_QNAME, CTRel.class, CTSdtContentRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = CTSdtContentCell.class)
    public JAXBElement<CTMoveBookmark> createCTSdtContentCellMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, CTSdtContentCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = CTSdtContentCell.class)
    public JAXBElement<RunMoveFrom> createCTSdtContentCellMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, CTSdtContentCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = CTSdtContentCell.class)
    public JAXBElement<CTMoveFromRangeEnd> createCTSdtContentCellMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, CTSdtContentCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = CTSdtContentCell.class)
    public JAXBElement<CTTrackChange> createCTSdtContentCellCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, CTSdtContentCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSdtCell }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "sdt", scope = CTSdtContentCell.class)
    public JAXBElement<CTSdtCell> createCTSdtContentCellSdt(CTSdtCell value) {
        return new JAXBElement<CTSdtCell>(_RunTrackChangeSdt_QNAME, CTSdtCell.class, CTSdtContentCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = CTSdtContentCell.class)
    public JAXBElement<CTMarkup> createCTSdtContentCellCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, CTSdtContentCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = CTSdtContentCell.class)
    public JAXBElement<CTTrackChange> createCTSdtContentCellCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, CTSdtContentCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = CTSdtContentCell.class)
    public JAXBElement<CTMoveToRangeEnd> createCTSdtContentCellMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, CTSdtContentCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = CTSdtContentCell.class)
    public JAXBElement<CTMarkup> createCTSdtContentCellCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, CTSdtContentCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = CTSdtContentCell.class)
    public JAXBElement<CTTrackChange> createCTSdtContentCellCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, CTSdtContentCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = CTSdtContentCell.class)
    public JAXBElement<CTTrackChange> createCTSdtContentCellCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, CTSdtContentCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = CTSdtContentCell.class)
    public JAXBElement<CTMarkup> createCTSdtContentCellCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, CTSdtContentCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = CTSdtContentCell.class)
    public JAXBElement<RangePermissionStart> createCTSdtContentCellPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, CTSdtContentCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = CTSdtContentCell.class)
    public JAXBElement<CTPerm> createCTSdtContentCellPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, CTSdtContentCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = CTSdtContentCell.class)
    public JAXBElement<CTMoveBookmark> createCTSdtContentCellMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, CTSdtContentCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Tc }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "tc", scope = CTSdtContentCell.class)
    public JAXBElement<Tc> createCTSdtContentCellTc(Tc value) {
        return new JAXBElement<Tc>(_CTSdtContentCellTc_QNAME, Tc.class, CTSdtContentCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = CTSdtContentCell.class)
    public JAXBElement<CTMarkupRange> createCTSdtContentCellBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, CTSdtContentCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlCell }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = CTSdtContentCell.class)
    public JAXBElement<CTCustomXmlCell> createCTSdtContentCellCustomXml(CTCustomXmlCell value) {
        return new JAXBElement<CTCustomXmlCell>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlCell.class, CTSdtContentCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = CTSdtContentCell.class)
    public JAXBElement<CTBookmark> createCTSdtContentCellBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, CTSdtContentCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = CTSdtContentCell.class)
    public JAXBElement<RunMoveTo> createCTSdtContentCellMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, CTSdtContentCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = CTSdtContentCell.class)
    public JAXBElement<CTMarkup> createCTSdtContentCellCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, CTSdtContentCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link org.docx4j.wml.RPr }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "rPr", scope = SdtPr.class)
    public JAXBElement<org.docx4j.wml.RPr> createSdtPrRPr(org.docx4j.wml.RPr value) {
        return new JAXBElement<org.docx4j.wml.RPr>(_SdtPrRPr_QNAME, org.docx4j.wml.RPr.class, SdtPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSdtText }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "text", scope = SdtPr.class)
    public JAXBElement<CTSdtText> createSdtPrText(CTSdtText value) {
        return new JAXBElement<CTSdtText>(_SdtPrText_QNAME, CTSdtText.class, SdtPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link SdtPr.Citation }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "citation", scope = SdtPr.class)
    public JAXBElement<SdtPr.Citation> createSdtPrCitation(SdtPr.Citation value) {
        return new JAXBElement<SdtPr.Citation>(_SdtPrCitation_QNAME, SdtPr.Citation.class, SdtPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSdtDocPart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "docPartObj", scope = SdtPr.class)
    public JAXBElement<CTSdtDocPart> createSdtPrDocPartObj(CTSdtDocPart value) {
        return new JAXBElement<CTSdtDocPart>(_SdtPrDocPartObj_QNAME, CTSdtDocPart.class, SdtPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPlaceholder }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "placeholder", scope = SdtPr.class)
    public JAXBElement<CTPlaceholder> createSdtPrPlaceholder(CTPlaceholder value) {
        return new JAXBElement<CTPlaceholder>(_SdtPrPlaceholder_QNAME, CTPlaceholder.class, SdtPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "showingPlcHdr", scope = SdtPr.class)
    public JAXBElement<BooleanDefaultTrue> createSdtPrShowingPlcHdr(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_SdtPrShowingPlcHdr_QNAME, BooleanDefaultTrue.class, SdtPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link SdtPr.Alias }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "alias", scope = SdtPr.class)
    public JAXBElement<SdtPr.Alias> createSdtPrAlias(SdtPr.Alias value) {
        return new JAXBElement<SdtPr.Alias>(_SdtPrAlias_QNAME, SdtPr.Alias.class, SdtPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTLock }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "lock", scope = SdtPr.class)
    public JAXBElement<CTLock> createSdtPrLock(CTLock value) {
        return new JAXBElement<CTLock>(_SdtPrLock_QNAME, CTLock.class, SdtPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "temporary", scope = SdtPr.class)
    public JAXBElement<BooleanDefaultTrue> createSdtPrTemporary(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_SdtPrTemporary_QNAME, BooleanDefaultTrue.class, SdtPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link SdtPr.Bibliography }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bibliography", scope = SdtPr.class)
    public JAXBElement<SdtPr.Bibliography> createSdtPrBibliography(SdtPr.Bibliography value) {
        return new JAXBElement<SdtPr.Bibliography>(_SdtPrBibliography_QNAME, SdtPr.Bibliography.class, SdtPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSdtComboBox }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "comboBox", scope = SdtPr.class)
    public JAXBElement<CTSdtComboBox> createSdtPrComboBox(CTSdtComboBox value) {
        return new JAXBElement<CTSdtComboBox>(_SdtPrComboBox_QNAME, CTSdtComboBox.class, SdtPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link SdtPr.RichText }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "richText", scope = SdtPr.class)
    public JAXBElement<SdtPr.RichText> createSdtPrRichText(SdtPr.RichText value) {
        return new JAXBElement<SdtPr.RichText>(_SdtPrRichText_QNAME, SdtPr.RichText.class, SdtPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSdtDate }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "date", scope = SdtPr.class)
    public JAXBElement<CTSdtDate> createSdtPrDate(CTSdtDate value) {
        return new JAXBElement<CTSdtDate>(_SdtPrDate_QNAME, CTSdtDate.class, SdtPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSdtDropDownList }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "dropDownList", scope = SdtPr.class)
    public JAXBElement<CTSdtDropDownList> createSdtPrDropDownList(CTSdtDropDownList value) {
        return new JAXBElement<CTSdtDropDownList>(_SdtPrDropDownList_QNAME, CTSdtDropDownList.class, SdtPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link SdtPr.Picture }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "picture", scope = SdtPr.class)
    public JAXBElement<SdtPr.Picture> createSdtPrPicture(SdtPr.Picture value) {
        return new JAXBElement<SdtPr.Picture>(_SdtPrPicture_QNAME, SdtPr.Picture.class, SdtPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link SdtPr.Equation }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "equation", scope = SdtPr.class)
    public JAXBElement<SdtPr.Equation> createSdtPrEquation(SdtPr.Equation value) {
        return new JAXBElement<SdtPr.Equation>(_SdtPrEquation_QNAME, SdtPr.Equation.class, SdtPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTDataBinding }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "dataBinding", scope = SdtPr.class)
    public JAXBElement<CTDataBinding> createSdtPrDataBinding(CTDataBinding value) {
        return new JAXBElement<CTDataBinding>(_SdtPrDataBinding_QNAME, CTDataBinding.class, SdtPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSdtDocPart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "docPartList", scope = SdtPr.class)
    public JAXBElement<CTSdtDocPart> createSdtPrDocPartList(CTSdtDocPart value) {
        return new JAXBElement<CTSdtDocPart>(_SdtPrDocPartList_QNAME, CTSdtDocPart.class, SdtPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link SdtPr.Group }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "group", scope = SdtPr.class)
    public JAXBElement<SdtPr.Group> createSdtPrGroup(SdtPr.Group value) {
        return new JAXBElement<SdtPr.Group>(_SdtPrGroup_QNAME, SdtPr.Group.class, SdtPr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = CTFtnEdn.class)
    public JAXBElement<CTMoveBookmark> createCTFtnEdnMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, CTFtnEdn.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = CTFtnEdn.class)
    public JAXBElement<RunMoveFrom> createCTFtnEdnMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, CTFtnEdn.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Tbl }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "tbl", scope = CTFtnEdn.class)
    public JAXBElement<Tbl> createCTFtnEdnTbl(Tbl value) {
        return new JAXBElement<Tbl>(_CTFtnEdnTbl_QNAME, Tbl.class, CTFtnEdn.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = CTFtnEdn.class)
    public JAXBElement<CTMoveFromRangeEnd> createCTFtnEdnMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, CTFtnEdn.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = CTFtnEdn.class)
    public JAXBElement<CTTrackChange> createCTFtnEdnCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, CTFtnEdn.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = CTFtnEdn.class)
    public JAXBElement<CTMarkup> createCTFtnEdnCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, CTFtnEdn.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = CTFtnEdn.class)
    public JAXBElement<CTMoveToRangeEnd> createCTFtnEdnMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, CTFtnEdn.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = CTFtnEdn.class)
    public JAXBElement<CTTrackChange> createCTFtnEdnCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, CTFtnEdn.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = CTFtnEdn.class)
    public JAXBElement<CTMarkup> createCTFtnEdnCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, CTFtnEdn.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = CTFtnEdn.class)
    public JAXBElement<CTTrackChange> createCTFtnEdnCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, CTFtnEdn.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = CTFtnEdn.class)
    public JAXBElement<CTTrackChange> createCTFtnEdnCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, CTFtnEdn.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTAltChunk }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "altChunk", scope = CTFtnEdn.class)
    public JAXBElement<CTAltChunk> createCTFtnEdnAltChunk(CTAltChunk value) {
        return new JAXBElement<CTAltChunk>(_CTFtnEdnAltChunk_QNAME, CTAltChunk.class, CTFtnEdn.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = CTFtnEdn.class)
    public JAXBElement<CTMarkup> createCTFtnEdnCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, CTFtnEdn.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = CTFtnEdn.class)
    public JAXBElement<RangePermissionStart> createCTFtnEdnPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, CTFtnEdn.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = CTFtnEdn.class)
    public JAXBElement<CTPerm> createCTFtnEdnPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, CTFtnEdn.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = CTFtnEdn.class)
    public JAXBElement<CTMoveBookmark> createCTFtnEdnMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, CTFtnEdn.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = CTFtnEdn.class)
    public JAXBElement<CTMarkupRange> createCTFtnEdnBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, CTFtnEdn.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlBlock }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = CTFtnEdn.class)
    public JAXBElement<CTCustomXmlBlock> createCTFtnEdnCustomXml(CTCustomXmlBlock value) {
        return new JAXBElement<CTCustomXmlBlock>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlBlock.class, CTFtnEdn.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = CTFtnEdn.class)
    public JAXBElement<CTBookmark> createCTFtnEdnBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, CTFtnEdn.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = CTFtnEdn.class)
    public JAXBElement<RunMoveTo> createCTFtnEdnMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, CTFtnEdn.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = CTFtnEdn.class)
    public JAXBElement<CTMarkup> createCTFtnEdnCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, CTFtnEdn.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = RunIns.class)
    public JAXBElement<CTMoveBookmark> createRunInsMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = RunIns.class)
    public JAXBElement<CTMoveFromRangeEnd> createRunInsMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSPre }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "sPre", scope = RunIns.class)
    public JAXBElement<CTSPre> createRunInsSPre(CTSPre value) {
        return new JAXBElement<CTSPre>(_RunTrackChangeSPre_QNAME, CTSPre.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link SdtRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "sdt", scope = RunIns.class)
    public JAXBElement<SdtRun> createRunInsSdt(SdtRun value) {
        return new JAXBElement<SdtRun>(_RunTrackChangeSdt_QNAME, SdtRun.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = RunIns.class)
    public JAXBElement<CTMoveToRangeEnd> createRunInsMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = RunIns.class)
    public JAXBElement<CTMarkup> createRunInsCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBorderBox }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "borderBox", scope = RunIns.class)
    public JAXBElement<CTBorderBox> createRunInsBorderBox(CTBorderBox value) {
        return new JAXBElement<CTBorderBox>(_RunTrackChangeBorderBox_QNAME, CTBorderBox.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = RunIns.class)
    public JAXBElement<CTMarkup> createRunInsCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = RunIns.class)
    public JAXBElement<CTTrackChange> createRunInsCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = RunIns.class)
    public JAXBElement<CTTrackChange> createRunInsCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = RunIns.class)
    public JAXBElement<CTMarkup> createRunInsCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTGroupChr }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "groupChr", scope = RunIns.class)
    public JAXBElement<CTGroupChr> createRunInsGroupChr(CTGroupChr value) {
        return new JAXBElement<CTGroupChr>(_RunTrackChangeGroupChr_QNAME, CTGroupChr.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = RunIns.class)
    public JAXBElement<RangePermissionStart> createRunInsPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTFunc }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "func", scope = RunIns.class)
    public JAXBElement<CTFunc> createRunInsFunc(CTFunc value) {
        return new JAXBElement<CTFunc>(_RunTrackChangeFunc_QNAME, CTFunc.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = RunIns.class)
    public JAXBElement<CTMoveBookmark> createRunInsMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = RunIns.class)
    public JAXBElement<CTMarkupRange> createRunInsBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSSubSup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "sSubSup", scope = RunIns.class)
    public JAXBElement<CTSSubSup> createRunInsSSubSup(CTSSubSup value) {
        return new JAXBElement<CTSSubSup>(_RunTrackChangeSSubSup_QNAME, CTSSubSup.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTLimUpp }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "limUpp", scope = RunIns.class)
    public JAXBElement<CTLimUpp> createRunInsLimUpp(CTLimUpp value) {
        return new JAXBElement<CTLimUpp>(_RunTrackChangeLimUpp_QNAME, CTLimUpp.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = RunIns.class)
    public JAXBElement<CTMarkup> createRunInsCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTAcc }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "acc", scope = RunIns.class)
    public JAXBElement<CTAcc> createRunInsAcc(CTAcc value) {
        return new JAXBElement<CTAcc>(_RunTrackChangeAcc_QNAME, CTAcc.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = RunIns.class)
    public JAXBElement<RunMoveFrom> createRunInsMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTM }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "m", scope = RunIns.class)
    public JAXBElement<CTM> createRunInsM(CTM value) {
        return new JAXBElement<CTM>(_RunTrackChangeM_QNAME, CTM.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = RunIns.class)
    public JAXBElement<CTTrackChange> createRunInsCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTLimLow }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "limLow", scope = RunIns.class)
    public JAXBElement<CTLimLow> createRunInsLimLow(CTLimLow value) {
        return new JAXBElement<CTLimLow>(_RunTrackChangeLimLow_QNAME, CTLimLow.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = RunIns.class)
    public JAXBElement<CTTrackChange> createRunInsCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSSup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "sSup", scope = RunIns.class)
    public JAXBElement<CTSSup> createRunInsSSup(CTSSup value) {
        return new JAXBElement<CTSSup>(_RunTrackChangeSSup_QNAME, CTSSup.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTD }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "d", scope = RunIns.class)
    public JAXBElement<CTD> createRunInsD(CTD value) {
        return new JAXBElement<CTD>(_RunTrackChangeD_QNAME, CTD.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTF }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "f", scope = RunIns.class)
    public JAXBElement<CTF> createRunInsF(CTF value) {
        return new JAXBElement<CTF>(_RunTrackChangeF_QNAME, CTF.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTEqArr }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "eqArr", scope = RunIns.class)
    public JAXBElement<CTEqArr> createRunInsEqArr(CTEqArr value) {
        return new JAXBElement<CTEqArr>(_RunTrackChangeEqArr_QNAME, CTEqArr.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTRad }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "rad", scope = RunIns.class)
    public JAXBElement<CTRad> createRunInsRad(CTRad value) {
        return new JAXBElement<CTRad>(_RunTrackChangeRad_QNAME, CTRad.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTNary }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "nary", scope = RunIns.class)
    public JAXBElement<CTNary> createRunInsNary(CTNary value) {
        return new JAXBElement<CTNary>(_RunTrackChangeNary_QNAME, CTNary.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBar }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "bar", scope = RunIns.class)
    public JAXBElement<CTBar> createRunInsBar(CTBar value) {
        return new JAXBElement<CTBar>(_RunTrackChangeBar_QNAME, CTBar.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = RunIns.class)
    public JAXBElement<CTPerm> createRunInsPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBox }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "box", scope = RunIns.class)
    public JAXBElement<CTBox> createRunInsBox(CTBox value) {
        return new JAXBElement<CTBox>(_RunTrackChangeBox_QNAME, CTBox.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = RunIns.class)
    public JAXBElement<CTCustomXmlRun> createRunInsCustomXml(CTCustomXmlRun value) {
        return new JAXBElement<CTCustomXmlRun>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlRun.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTR }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "r", scope = RunIns.class)
    public JAXBElement<CTR> createRunInsR(CTR value) {
        return new JAXBElement<CTR>(_RunTrackChangeR_QNAME, CTR.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = RunIns.class)
    public JAXBElement<CTBookmark> createRunInsBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPhant }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "phant", scope = RunIns.class)
    public JAXBElement<CTPhant> createRunInsPhant(CTPhant value) {
        return new JAXBElement<CTPhant>(_RunTrackChangePhant_QNAME, CTPhant.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSmartTagRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "smartTag", scope = RunIns.class)
    public JAXBElement<CTSmartTagRun> createRunInsSmartTag(CTSmartTagRun value) {
        return new JAXBElement<CTSmartTagRun>(_RunTrackChangeSmartTag_QNAME, CTSmartTagRun.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = RunIns.class)
    public JAXBElement<RunMoveTo> createRunInsMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSSub }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "sSub", scope = RunIns.class)
    public JAXBElement<CTSSub> createRunInsSSub(CTSSub value) {
        return new JAXBElement<CTSSub>(_RunTrackChangeSSub_QNAME, CTSSub.class, RunIns.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = CTRubyContent.class)
    public JAXBElement<CTMoveBookmark> createCTRubyContentMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, CTRubyContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = CTRubyContent.class)
    public JAXBElement<RunMoveFrom> createCTRubyContentMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, CTRubyContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = CTRubyContent.class)
    public JAXBElement<CTMoveFromRangeEnd> createCTRubyContentMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, CTRubyContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = CTRubyContent.class)
    public JAXBElement<CTTrackChange> createCTRubyContentCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, CTRubyContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = CTRubyContent.class)
    public JAXBElement<CTMoveToRangeEnd> createCTRubyContentMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, CTRubyContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = CTRubyContent.class)
    public JAXBElement<CTTrackChange> createCTRubyContentCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, CTRubyContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = CTRubyContent.class)
    public JAXBElement<CTMarkup> createCTRubyContentCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, CTRubyContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = CTRubyContent.class)
    public JAXBElement<CTMarkup> createCTRubyContentCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, CTRubyContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = CTRubyContent.class)
    public JAXBElement<CTTrackChange> createCTRubyContentCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, CTRubyContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = CTRubyContent.class)
    public JAXBElement<CTTrackChange> createCTRubyContentCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, CTRubyContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = CTRubyContent.class)
    public JAXBElement<CTMarkup> createCTRubyContentCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, CTRubyContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = CTRubyContent.class)
    public JAXBElement<RangePermissionStart> createCTRubyContentPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, CTRubyContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = CTRubyContent.class)
    public JAXBElement<CTPerm> createCTRubyContentPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, CTRubyContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = CTRubyContent.class)
    public JAXBElement<CTMoveBookmark> createCTRubyContentMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, CTRubyContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = CTRubyContent.class)
    public JAXBElement<CTMarkupRange> createCTRubyContentBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, CTRubyContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = CTRubyContent.class)
    public JAXBElement<CTBookmark> createCTRubyContentBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, CTRubyContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = CTRubyContent.class)
    public JAXBElement<RunMoveTo> createCTRubyContentMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, CTRubyContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = CTRubyContent.class)
    public JAXBElement<CTMarkup> createCTRubyContentCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, CTRubyContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = Comments.Comment.class)
    public JAXBElement<CTMoveBookmark> createCommentsCommentMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, Comments.Comment.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = Comments.Comment.class)
    public JAXBElement<RunMoveFrom> createCommentsCommentMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, Comments.Comment.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Tbl }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "tbl", scope = Comments.Comment.class)
    public JAXBElement<Tbl> createCommentsCommentTbl(Tbl value) {
        return new JAXBElement<Tbl>(_CTFtnEdnTbl_QNAME, Tbl.class, Comments.Comment.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = Comments.Comment.class)
    public JAXBElement<CTMoveFromRangeEnd> createCommentsCommentMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, Comments.Comment.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = Comments.Comment.class)
    public JAXBElement<CTTrackChange> createCommentsCommentCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, Comments.Comment.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = Comments.Comment.class)
    public JAXBElement<CTMarkup> createCommentsCommentCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, Comments.Comment.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = Comments.Comment.class)
    public JAXBElement<CTMoveToRangeEnd> createCommentsCommentMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, Comments.Comment.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = Comments.Comment.class)
    public JAXBElement<CTTrackChange> createCommentsCommentCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, Comments.Comment.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = Comments.Comment.class)
    public JAXBElement<CTMarkup> createCommentsCommentCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, Comments.Comment.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = Comments.Comment.class)
    public JAXBElement<CTTrackChange> createCommentsCommentCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, Comments.Comment.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = Comments.Comment.class)
    public JAXBElement<CTTrackChange> createCommentsCommentCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, Comments.Comment.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTAltChunk }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "altChunk", scope = Comments.Comment.class)
    public JAXBElement<CTAltChunk> createCommentsCommentAltChunk(CTAltChunk value) {
        return new JAXBElement<CTAltChunk>(_CTFtnEdnAltChunk_QNAME, CTAltChunk.class, Comments.Comment.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = Comments.Comment.class)
    public JAXBElement<CTMarkup> createCommentsCommentCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, Comments.Comment.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = Comments.Comment.class)
    public JAXBElement<RangePermissionStart> createCommentsCommentPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, Comments.Comment.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = Comments.Comment.class)
    public JAXBElement<CTPerm> createCommentsCommentPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, Comments.Comment.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = Comments.Comment.class)
    public JAXBElement<CTMoveBookmark> createCommentsCommentMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, Comments.Comment.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = Comments.Comment.class)
    public JAXBElement<CTMarkupRange> createCommentsCommentBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, Comments.Comment.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlBlock }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = Comments.Comment.class)
    public JAXBElement<CTCustomXmlBlock> createCommentsCommentCustomXml(CTCustomXmlBlock value) {
        return new JAXBElement<CTCustomXmlBlock>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlBlock.class, Comments.Comment.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = Comments.Comment.class)
    public JAXBElement<CTBookmark> createCommentsCommentBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, Comments.Comment.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = Comments.Comment.class)
    public JAXBElement<RunMoveTo> createCommentsCommentMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, Comments.Comment.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = Comments.Comment.class)
    public JAXBElement<CTMarkup> createCommentsCommentCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, Comments.Comment.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = CTTxbxContent.class)
    public JAXBElement<CTMoveBookmark> createCTTxbxContentMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, CTTxbxContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = CTTxbxContent.class)
    public JAXBElement<RunMoveFrom> createCTTxbxContentMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, CTTxbxContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Tbl }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "tbl", scope = CTTxbxContent.class)
    public JAXBElement<Tbl> createCTTxbxContentTbl(Tbl value) {
        return new JAXBElement<Tbl>(_CTFtnEdnTbl_QNAME, Tbl.class, CTTxbxContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = CTTxbxContent.class)
    public JAXBElement<CTMoveFromRangeEnd> createCTTxbxContentMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, CTTxbxContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = CTTxbxContent.class)
    public JAXBElement<CTTrackChange> createCTTxbxContentCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, CTTxbxContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = CTTxbxContent.class)
    public JAXBElement<CTMarkup> createCTTxbxContentCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, CTTxbxContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = CTTxbxContent.class)
    public JAXBElement<CTMoveToRangeEnd> createCTTxbxContentMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, CTTxbxContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = CTTxbxContent.class)
    public JAXBElement<CTTrackChange> createCTTxbxContentCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, CTTxbxContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = CTTxbxContent.class)
    public JAXBElement<CTMarkup> createCTTxbxContentCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, CTTxbxContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = CTTxbxContent.class)
    public JAXBElement<CTTrackChange> createCTTxbxContentCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, CTTxbxContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = CTTxbxContent.class)
    public JAXBElement<CTTrackChange> createCTTxbxContentCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, CTTxbxContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTAltChunk }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "altChunk", scope = CTTxbxContent.class)
    public JAXBElement<CTAltChunk> createCTTxbxContentAltChunk(CTAltChunk value) {
        return new JAXBElement<CTAltChunk>(_CTFtnEdnAltChunk_QNAME, CTAltChunk.class, CTTxbxContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = CTTxbxContent.class)
    public JAXBElement<CTMarkup> createCTTxbxContentCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, CTTxbxContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = CTTxbxContent.class)
    public JAXBElement<RangePermissionStart> createCTTxbxContentPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, CTTxbxContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = CTTxbxContent.class)
    public JAXBElement<CTPerm> createCTTxbxContentPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, CTTxbxContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = CTTxbxContent.class)
    public JAXBElement<CTMoveBookmark> createCTTxbxContentMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, CTTxbxContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = CTTxbxContent.class)
    public JAXBElement<CTMarkupRange> createCTTxbxContentBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, CTTxbxContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlBlock }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = CTTxbxContent.class)
    public JAXBElement<CTCustomXmlBlock> createCTTxbxContentCustomXml(CTCustomXmlBlock value) {
        return new JAXBElement<CTCustomXmlBlock>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlBlock.class, CTTxbxContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = CTTxbxContent.class)
    public JAXBElement<CTBookmark> createCTTxbxContentBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, CTTxbxContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = CTTxbxContent.class)
    public JAXBElement<RunMoveTo> createCTTxbxContentMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, CTTxbxContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = CTTxbxContent.class)
    public JAXBElement<CTMarkup> createCTTxbxContentCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, CTTxbxContent.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = Ftr.class)
    public JAXBElement<CTMoveBookmark> createFtrMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, Ftr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = Ftr.class)
    public JAXBElement<RunMoveFrom> createFtrMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, Ftr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Tbl }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "tbl", scope = Ftr.class)
    public JAXBElement<Tbl> createFtrTbl(Tbl value) {
        return new JAXBElement<Tbl>(_CTFtnEdnTbl_QNAME, Tbl.class, Ftr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = Ftr.class)
    public JAXBElement<CTMoveFromRangeEnd> createFtrMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, Ftr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = Ftr.class)
    public JAXBElement<CTTrackChange> createFtrCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, Ftr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = Ftr.class)
    public JAXBElement<CTMarkup> createFtrCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, Ftr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = Ftr.class)
    public JAXBElement<CTMoveToRangeEnd> createFtrMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, Ftr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = Ftr.class)
    public JAXBElement<CTTrackChange> createFtrCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, Ftr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = Ftr.class)
    public JAXBElement<CTMarkup> createFtrCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, Ftr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = Ftr.class)
    public JAXBElement<CTTrackChange> createFtrCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, Ftr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = Ftr.class)
    public JAXBElement<CTTrackChange> createFtrCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, Ftr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTAltChunk }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "altChunk", scope = Ftr.class)
    public JAXBElement<CTAltChunk> createFtrAltChunk(CTAltChunk value) {
        return new JAXBElement<CTAltChunk>(_CTFtnEdnAltChunk_QNAME, CTAltChunk.class, Ftr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = Ftr.class)
    public JAXBElement<CTMarkup> createFtrCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, Ftr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = Ftr.class)
    public JAXBElement<RangePermissionStart> createFtrPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, Ftr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = Ftr.class)
    public JAXBElement<CTPerm> createFtrPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, Ftr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = Ftr.class)
    public JAXBElement<CTMoveBookmark> createFtrMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, Ftr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = Ftr.class)
    public JAXBElement<CTMarkupRange> createFtrBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, Ftr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlBlock }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = Ftr.class)
    public JAXBElement<CTCustomXmlBlock> createFtrCustomXml(CTCustomXmlBlock value) {
        return new JAXBElement<CTCustomXmlBlock>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlBlock.class, Ftr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = Ftr.class)
    public JAXBElement<CTBookmark> createFtrBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, Ftr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = Ftr.class)
    public JAXBElement<RunMoveTo> createFtrMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, Ftr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = Ftr.class)
    public JAXBElement<CTMarkup> createFtrCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, Ftr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = P.class)
    public JAXBElement<CTMoveBookmark> createPMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = P.class)
    public JAXBElement<RunMoveFrom> createPMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = P.class)
    public JAXBElement<CTMoveFromRangeEnd> createPMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSimpleField }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "fldSimple", scope = P.class)
    public JAXBElement<CTSimpleField> createPFldSimple(CTSimpleField value) {
        return new JAXBElement<CTSimpleField>(_CTSmartTagRunFldSimple_QNAME, CTSimpleField.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = P.class)
    public JAXBElement<CTTrackChange> createPCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link SdtRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "sdt", scope = P.class)
    public JAXBElement<SdtRun> createPSdt(SdtRun value) {
        return new JAXBElement<SdtRun>(_RunTrackChangeSdt_QNAME, SdtRun.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = P.class)
    public JAXBElement<CTMarkup> createPCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = P.class)
    public JAXBElement<CTTrackChange> createPCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = P.class)
    public JAXBElement<CTMoveToRangeEnd> createPMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = P.class)
    public JAXBElement<CTMarkup> createPCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = P.class)
    public JAXBElement<CTTrackChange> createPCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = P.class)
    public JAXBElement<CTTrackChange> createPCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = P.class)
    public JAXBElement<CTMarkup> createPCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link P.Hyperlink }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "hyperlink", scope = P.class)
    public JAXBElement<P.Hyperlink> createPHyperlink(P.Hyperlink value) {
        return new JAXBElement<P.Hyperlink>(_CTSmartTagRunHyperlink_QNAME, P.Hyperlink.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = P.class)
    public JAXBElement<RangePermissionStart> createPPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = P.class)
    public JAXBElement<CTPerm> createPPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = P.class)
    public JAXBElement<CTMoveBookmark> createPMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = P.class)
    public JAXBElement<CTMarkupRange> createPBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = P.class)
    public JAXBElement<CTCustomXmlRun> createPCustomXml(CTCustomXmlRun value) {
        return new JAXBElement<CTCustomXmlRun>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlRun.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = P.class)
    public JAXBElement<CTBookmark> createPBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = P.class)
    public JAXBElement<RunMoveTo> createPMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSmartTagRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "smartTag", scope = P.class)
    public JAXBElement<CTSmartTagRun> createPSmartTag(CTSmartTagRun value) {
        return new JAXBElement<CTSmartTagRun>(_RunTrackChangeSmartTag_QNAME, CTSmartTagRun.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = P.class)
    public JAXBElement<CTMarkup> createPCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTRel }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "subDoc", scope = P.class)
    public JAXBElement<CTRel> createPSubDoc(CTRel value) {
        return new JAXBElement<CTRel>(_CTSmartTagRunSubDoc_QNAME, CTRel.class, P.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = CTCustomXmlRun.class)
    public JAXBElement<CTMoveBookmark> createCTCustomXmlRunMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = CTCustomXmlRun.class)
    public JAXBElement<RunMoveFrom> createCTCustomXmlRunMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = CTCustomXmlRun.class)
    public JAXBElement<CTMoveFromRangeEnd> createCTCustomXmlRunMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSimpleField }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "fldSimple", scope = CTCustomXmlRun.class)
    public JAXBElement<CTSimpleField> createCTCustomXmlRunFldSimple(CTSimpleField value) {
        return new JAXBElement<CTSimpleField>(_CTSmartTagRunFldSimple_QNAME, CTSimpleField.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = CTCustomXmlRun.class)
    public JAXBElement<CTTrackChange> createCTCustomXmlRunCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link SdtRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "sdt", scope = CTCustomXmlRun.class)
    public JAXBElement<SdtRun> createCTCustomXmlRunSdt(SdtRun value) {
        return new JAXBElement<SdtRun>(_RunTrackChangeSdt_QNAME, SdtRun.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = CTCustomXmlRun.class)
    public JAXBElement<CTMarkup> createCTCustomXmlRunCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = CTCustomXmlRun.class)
    public JAXBElement<CTTrackChange> createCTCustomXmlRunCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = CTCustomXmlRun.class)
    public JAXBElement<CTMoveToRangeEnd> createCTCustomXmlRunMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = CTCustomXmlRun.class)
    public JAXBElement<CTMarkup> createCTCustomXmlRunCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = CTCustomXmlRun.class)
    public JAXBElement<CTTrackChange> createCTCustomXmlRunCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = CTCustomXmlRun.class)
    public JAXBElement<CTTrackChange> createCTCustomXmlRunCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = CTCustomXmlRun.class)
    public JAXBElement<CTMarkup> createCTCustomXmlRunCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link P.Hyperlink }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "hyperlink", scope = CTCustomXmlRun.class)
    public JAXBElement<P.Hyperlink> createCTCustomXmlRunHyperlink(P.Hyperlink value) {
        return new JAXBElement<P.Hyperlink>(_CTSmartTagRunHyperlink_QNAME, P.Hyperlink.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = CTCustomXmlRun.class)
    public JAXBElement<RangePermissionStart> createCTCustomXmlRunPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = CTCustomXmlRun.class)
    public JAXBElement<CTPerm> createCTCustomXmlRunPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = CTCustomXmlRun.class)
    public JAXBElement<CTMoveBookmark> createCTCustomXmlRunMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = CTCustomXmlRun.class)
    public JAXBElement<CTMarkupRange> createCTCustomXmlRunBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = CTCustomXmlRun.class)
    public JAXBElement<CTCustomXmlRun> createCTCustomXmlRunCustomXml(CTCustomXmlRun value) {
        return new JAXBElement<CTCustomXmlRun>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlRun.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = CTCustomXmlRun.class)
    public JAXBElement<CTBookmark> createCTCustomXmlRunBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = CTCustomXmlRun.class)
    public JAXBElement<RunMoveTo> createCTCustomXmlRunMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSmartTagRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "smartTag", scope = CTCustomXmlRun.class)
    public JAXBElement<CTSmartTagRun> createCTCustomXmlRunSmartTag(CTSmartTagRun value) {
        return new JAXBElement<CTSmartTagRun>(_RunTrackChangeSmartTag_QNAME, CTSmartTagRun.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = CTCustomXmlRun.class)
    public JAXBElement<CTMarkup> createCTCustomXmlRunCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTRel }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "subDoc", scope = CTCustomXmlRun.class)
    public JAXBElement<CTRel> createCTCustomXmlRunSubDoc(CTRel value) {
        return new JAXBElement<CTRel>(_CTSmartTagRunSubDoc_QNAME, CTRel.class, CTCustomXmlRun.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = CTSimpleField.class)
    public JAXBElement<CTMoveBookmark> createCTSimpleFieldMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = CTSimpleField.class)
    public JAXBElement<RunMoveFrom> createCTSimpleFieldMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = CTSimpleField.class)
    public JAXBElement<CTMoveFromRangeEnd> createCTSimpleFieldMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSimpleField }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "fldSimple", scope = CTSimpleField.class)
    public JAXBElement<CTSimpleField> createCTSimpleFieldFldSimple(CTSimpleField value) {
        return new JAXBElement<CTSimpleField>(_CTSmartTagRunFldSimple_QNAME, CTSimpleField.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = CTSimpleField.class)
    public JAXBElement<CTTrackChange> createCTSimpleFieldCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link SdtRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "sdt", scope = CTSimpleField.class)
    public JAXBElement<SdtRun> createCTSimpleFieldSdt(SdtRun value) {
        return new JAXBElement<SdtRun>(_RunTrackChangeSdt_QNAME, SdtRun.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = CTSimpleField.class)
    public JAXBElement<CTMarkup> createCTSimpleFieldCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = CTSimpleField.class)
    public JAXBElement<CTTrackChange> createCTSimpleFieldCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = CTSimpleField.class)
    public JAXBElement<CTMoveToRangeEnd> createCTSimpleFieldMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = CTSimpleField.class)
    public JAXBElement<CTMarkup> createCTSimpleFieldCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = CTSimpleField.class)
    public JAXBElement<CTTrackChange> createCTSimpleFieldCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = CTSimpleField.class)
    public JAXBElement<CTTrackChange> createCTSimpleFieldCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = CTSimpleField.class)
    public JAXBElement<CTMarkup> createCTSimpleFieldCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link P.Hyperlink }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "hyperlink", scope = CTSimpleField.class)
    public JAXBElement<P.Hyperlink> createCTSimpleFieldHyperlink(P.Hyperlink value) {
        return new JAXBElement<P.Hyperlink>(_CTSmartTagRunHyperlink_QNAME, P.Hyperlink.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = CTSimpleField.class)
    public JAXBElement<RangePermissionStart> createCTSimpleFieldPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = CTSimpleField.class)
    public JAXBElement<CTPerm> createCTSimpleFieldPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = CTSimpleField.class)
    public JAXBElement<CTMoveBookmark> createCTSimpleFieldMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = CTSimpleField.class)
    public JAXBElement<CTMarkupRange> createCTSimpleFieldBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = CTSimpleField.class)
    public JAXBElement<CTCustomXmlRun> createCTSimpleFieldCustomXml(CTCustomXmlRun value) {
        return new JAXBElement<CTCustomXmlRun>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlRun.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = CTSimpleField.class)
    public JAXBElement<CTBookmark> createCTSimpleFieldBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = CTSimpleField.class)
    public JAXBElement<RunMoveTo> createCTSimpleFieldMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSmartTagRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "smartTag", scope = CTSimpleField.class)
    public JAXBElement<CTSmartTagRun> createCTSimpleFieldSmartTag(CTSmartTagRun value) {
        return new JAXBElement<CTSmartTagRun>(_RunTrackChangeSmartTag_QNAME, CTSmartTagRun.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = CTSimpleField.class)
    public JAXBElement<CTMarkup> createCTSimpleFieldCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTRel }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "subDoc", scope = CTSimpleField.class)
    public JAXBElement<CTRel> createCTSimpleFieldSubDoc(CTRel value) {
        return new JAXBElement<CTRel>(_CTSmartTagRunSubDoc_QNAME, CTRel.class, CTSimpleField.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = Tbl.class)
    public JAXBElement<CTMoveBookmark> createTblMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, Tbl.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = Tbl.class)
    public JAXBElement<RunMoveFrom> createTblMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, Tbl.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = Tbl.class)
    public JAXBElement<CTMoveFromRangeEnd> createTblMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, Tbl.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = Tbl.class)
    public JAXBElement<CTTrackChange> createTblCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, Tbl.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSdtRow }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "sdt", scope = Tbl.class)
    public JAXBElement<CTSdtRow> createTblSdt(CTSdtRow value) {
        return new JAXBElement<CTSdtRow>(_RunTrackChangeSdt_QNAME, CTSdtRow.class, Tbl.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = Tbl.class)
    public JAXBElement<CTMarkup> createTblCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, Tbl.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = Tbl.class)
    public JAXBElement<CTMoveToRangeEnd> createTblMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, Tbl.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = Tbl.class)
    public JAXBElement<CTTrackChange> createTblCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, Tbl.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = Tbl.class)
    public JAXBElement<CTMarkup> createTblCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, Tbl.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = Tbl.class)
    public JAXBElement<CTTrackChange> createTblCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, Tbl.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = Tbl.class)
    public JAXBElement<CTTrackChange> createTblCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, Tbl.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = Tbl.class)
    public JAXBElement<CTMarkup> createTblCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, Tbl.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = Tbl.class)
    public JAXBElement<RangePermissionStart> createTblPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, Tbl.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = Tbl.class)
    public JAXBElement<CTPerm> createTblPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, Tbl.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = Tbl.class)
    public JAXBElement<CTMoveBookmark> createTblMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, Tbl.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = Tbl.class)
    public JAXBElement<CTMarkupRange> createTblBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, Tbl.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlRow }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = Tbl.class)
    public JAXBElement<CTCustomXmlRow> createTblCustomXml(CTCustomXmlRow value) {
        return new JAXBElement<CTCustomXmlRow>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlRow.class, Tbl.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = Tbl.class)
    public JAXBElement<CTBookmark> createTblBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, Tbl.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = Tbl.class)
    public JAXBElement<RunMoveTo> createTblMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, Tbl.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = Tbl.class)
    public JAXBElement<CTMarkup> createTblCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, Tbl.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTFFDDList }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "ddList", scope = CTFFData.class)
    public JAXBElement<CTFFDDList> createCTFFDataDdList(CTFFDDList value) {
        return new JAXBElement<CTFFDDList>(_CTFFDataDdList_QNAME, CTFFDDList.class, CTFFData.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMacroName }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "entryMacro", scope = CTFFData.class)
    public JAXBElement<CTMacroName> createCTFFDataEntryMacro(CTMacroName value) {
        return new JAXBElement<CTMacroName>(_CTFFDataEntryMacro_QNAME, CTMacroName.class, CTFFData.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "enabled", scope = CTFFData.class)
    public JAXBElement<BooleanDefaultTrue> createCTFFDataEnabled(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTFFDataEnabled_QNAME, BooleanDefaultTrue.class, CTFFData.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "calcOnExit", scope = CTFFData.class)
    public JAXBElement<BooleanDefaultTrue> createCTFFDataCalcOnExit(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTFFDataCalcOnExit_QNAME, BooleanDefaultTrue.class, CTFFData.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTFFName }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "name", scope = CTFFData.class)
    public JAXBElement<CTFFName> createCTFFDataName(CTFFName value) {
        return new JAXBElement<CTFFName>(_CTFFDataName_QNAME, CTFFName.class, CTFFData.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTFFCheckBox }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "checkBox", scope = CTFFData.class)
    public JAXBElement<CTFFCheckBox> createCTFFDataCheckBox(CTFFCheckBox value) {
        return new JAXBElement<CTFFCheckBox>(_CTFFDataCheckBox_QNAME, CTFFCheckBox.class, CTFFData.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTFFStatusText }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "statusText", scope = CTFFData.class)
    public JAXBElement<CTFFStatusText> createCTFFDataStatusText(CTFFStatusText value) {
        return new JAXBElement<CTFFStatusText>(_CTFFDataStatusText_QNAME, CTFFStatusText.class, CTFFData.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTFFHelpText }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "helpText", scope = CTFFData.class)
    public JAXBElement<CTFFHelpText> createCTFFDataHelpText(CTFFHelpText value) {
        return new JAXBElement<CTFFHelpText>(_CTFFDataHelpText_QNAME, CTFFHelpText.class, CTFFData.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTFFTextInput }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "textInput", scope = CTFFData.class)
    public JAXBElement<CTFFTextInput> createCTFFDataTextInput(CTFFTextInput value) {
        return new JAXBElement<CTFFTextInput>(_CTFFDataTextInput_QNAME, CTFFTextInput.class, CTFFData.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMacroName }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "exitMacro", scope = CTFFData.class)
    public JAXBElement<CTMacroName> createCTFFDataExitMacro(CTMacroName value) {
        return new JAXBElement<CTMacroName>(_CTFFDataExitMacro_QNAME, CTMacroName.class, CTFFData.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "rtl", scope = CTParaRPrOriginal.class)
    public JAXBElement<BooleanDefaultTrue> createCTParaRPrOriginalRtl(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrRtl_QNAME, BooleanDefaultTrue.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "b", scope = CTParaRPrOriginal.class)
    public JAXBElement<BooleanDefaultTrue> createCTParaRPrOriginalB(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrB_QNAME, BooleanDefaultTrue.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "snapToGrid", scope = CTParaRPrOriginal.class)
    public JAXBElement<BooleanDefaultTrue> createCTParaRPrOriginalSnapToGrid(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrSnapToGrid_QNAME, BooleanDefaultTrue.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "cs", scope = CTParaRPrOriginal.class)
    public JAXBElement<BooleanDefaultTrue> createCTParaRPrOriginalCs(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrCs_QNAME, BooleanDefaultTrue.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "dstrike", scope = CTParaRPrOriginal.class)
    public JAXBElement<BooleanDefaultTrue> createCTParaRPrOriginalDstrike(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrDstrike_QNAME, BooleanDefaultTrue.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "iCs", scope = CTParaRPrOriginal.class)
    public JAXBElement<BooleanDefaultTrue> createCTParaRPrOriginalICs(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrICs_QNAME, BooleanDefaultTrue.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "i", scope = CTParaRPrOriginal.class)
    public JAXBElement<BooleanDefaultTrue> createCTParaRPrOriginalI(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrI_QNAME, BooleanDefaultTrue.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "oMath", scope = CTParaRPrOriginal.class)
    public JAXBElement<BooleanDefaultTrue> createCTParaRPrOriginalOMath(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrOMath_QNAME, BooleanDefaultTrue.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "noProof", scope = CTParaRPrOriginal.class)
    public JAXBElement<BooleanDefaultTrue> createCTParaRPrOriginalNoProof(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrNoProof_QNAME, BooleanDefaultTrue.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTVerticalAlignRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "vertAlign", scope = CTParaRPrOriginal.class)
    public JAXBElement<CTVerticalAlignRun> createCTParaRPrOriginalVertAlign(CTVerticalAlignRun value) {
        return new JAXBElement<CTVerticalAlignRun>(_CTRPrChangeRPrVertAlign_QNAME, CTVerticalAlignRun.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTextScale }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "w", scope = CTParaRPrOriginal.class)
    public JAXBElement<CTTextScale> createCTParaRPrOriginalW(CTTextScale value) {
        return new JAXBElement<CTTextScale>(_CTRPrChangeRPrW_QNAME, CTTextScale.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "caps", scope = CTParaRPrOriginal.class)
    public JAXBElement<BooleanDefaultTrue> createCTParaRPrOriginalCaps(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrCaps_QNAME, BooleanDefaultTrue.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTextEffect }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "effect", scope = CTParaRPrOriginal.class)
    public JAXBElement<CTTextEffect> createCTParaRPrOriginalEffect(CTTextEffect value) {
        return new JAXBElement<CTTextEffect>(_CTRPrChangeRPrEffect_QNAME, CTTextEffect.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTEm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "em", scope = CTParaRPrOriginal.class)
    public JAXBElement<CTEm> createCTParaRPrOriginalEm(CTEm value) {
        return new JAXBElement<CTEm>(_CTRPrChangeRPrEm_QNAME, CTEm.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "webHidden", scope = CTParaRPrOriginal.class)
    public JAXBElement<BooleanDefaultTrue> createCTParaRPrOriginalWebHidden(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrWebHidden_QNAME, BooleanDefaultTrue.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSignedHpsMeasure }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "position", scope = CTParaRPrOriginal.class)
    public JAXBElement<CTSignedHpsMeasure> createCTParaRPrOriginalPosition(CTSignedHpsMeasure value) {
        return new JAXBElement<CTSignedHpsMeasure>(_CTRPrChangeRPrPosition_QNAME, CTSignedHpsMeasure.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTShd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "shd", scope = CTParaRPrOriginal.class)
    public JAXBElement<CTShd> createCTParaRPrOriginalShd(CTShd value) {
        return new JAXBElement<CTShd>(_CTRPrChangeRPrShd_QNAME, CTShd.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "smallCaps", scope = CTParaRPrOriginal.class)
    public JAXBElement<BooleanDefaultTrue> createCTParaRPrOriginalSmallCaps(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrSmallCaps_QNAME, BooleanDefaultTrue.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "specVanish", scope = CTParaRPrOriginal.class)
    public JAXBElement<BooleanDefaultTrue> createCTParaRPrOriginalSpecVanish(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrSpecVanish_QNAME, BooleanDefaultTrue.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link HpsMeasure }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "szCs", scope = CTParaRPrOriginal.class)
    public JAXBElement<HpsMeasure> createCTParaRPrOriginalSzCs(HpsMeasure value) {
        return new JAXBElement<HpsMeasure>(_CTRPrChangeRPrSzCs_QNAME, HpsMeasure.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSignedTwipsMeasure }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "spacing", scope = CTParaRPrOriginal.class)
    public JAXBElement<CTSignedTwipsMeasure> createCTParaRPrOriginalSpacing(CTSignedTwipsMeasure value) {
        return new JAXBElement<CTSignedTwipsMeasure>(_CTRPrChangeRPrSpacing_QNAME, CTSignedTwipsMeasure.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTEastAsianLayout }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "eastAsianLayout", scope = CTParaRPrOriginal.class)
    public JAXBElement<CTEastAsianLayout> createCTParaRPrOriginalEastAsianLayout(CTEastAsianLayout value) {
        return new JAXBElement<CTEastAsianLayout>(_CTRPrChangeRPrEastAsianLayout_QNAME, CTEastAsianLayout.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTFitText }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "fitText", scope = CTParaRPrOriginal.class)
    public JAXBElement<CTFitText> createCTParaRPrOriginalFitText(CTFitText value) {
        return new JAXBElement<CTFitText>(_CTRPrChangeRPrFitText_QNAME, CTFitText.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link HpsMeasure }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "kern", scope = CTParaRPrOriginal.class)
    public JAXBElement<HpsMeasure> createCTParaRPrOriginalKern(HpsMeasure value) {
        return new JAXBElement<HpsMeasure>(_CTRPrChangeRPrKern_QNAME, HpsMeasure.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "vanish", scope = CTParaRPrOriginal.class)
    public JAXBElement<BooleanDefaultTrue> createCTParaRPrOriginalVanish(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrVanish_QNAME, BooleanDefaultTrue.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTLanguage }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "lang", scope = CTParaRPrOriginal.class)
    public JAXBElement<CTLanguage> createCTParaRPrOriginalLang(CTLanguage value) {
        return new JAXBElement<CTLanguage>(_CTRPrChangeRPrLang_QNAME, CTLanguage.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "outline", scope = CTParaRPrOriginal.class)
    public JAXBElement<BooleanDefaultTrue> createCTParaRPrOriginalOutline(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrOutline_QNAME, BooleanDefaultTrue.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bCs", scope = CTParaRPrOriginal.class)
    public JAXBElement<BooleanDefaultTrue> createCTParaRPrOriginalBCs(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrBCs_QNAME, BooleanDefaultTrue.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "strike", scope = CTParaRPrOriginal.class)
    public JAXBElement<BooleanDefaultTrue> createCTParaRPrOriginalStrike(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrStrike_QNAME, BooleanDefaultTrue.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "shadow", scope = CTParaRPrOriginal.class)
    public JAXBElement<BooleanDefaultTrue> createCTParaRPrOriginalShadow(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrShadow_QNAME, BooleanDefaultTrue.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "imprint", scope = CTParaRPrOriginal.class)
    public JAXBElement<BooleanDefaultTrue> createCTParaRPrOriginalImprint(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrImprint_QNAME, BooleanDefaultTrue.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBorder }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bdr", scope = CTParaRPrOriginal.class)
    public JAXBElement<CTBorder> createCTParaRPrOriginalBdr(CTBorder value) {
        return new JAXBElement<CTBorder>(_CTRPrChangeRPrBdr_QNAME, CTBorder.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link HpsMeasure }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "sz", scope = CTParaRPrOriginal.class)
    public JAXBElement<HpsMeasure> createCTParaRPrOriginalSz(HpsMeasure value) {
        return new JAXBElement<HpsMeasure>(_CTRPrChangeRPrSz_QNAME, HpsMeasure.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "emboss", scope = CTParaRPrOriginal.class)
    public JAXBElement<BooleanDefaultTrue> createCTParaRPrOriginalEmboss(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTRPrChangeRPrEmboss_QNAME, BooleanDefaultTrue.class, CTParaRPrOriginal.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = P.Hyperlink.class)
    public JAXBElement<CTMoveBookmark> createPHyperlinkMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = P.Hyperlink.class)
    public JAXBElement<RunMoveFrom> createPHyperlinkMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = P.Hyperlink.class)
    public JAXBElement<CTMoveFromRangeEnd> createPHyperlinkMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSimpleField }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "fldSimple", scope = P.Hyperlink.class)
    public JAXBElement<CTSimpleField> createPHyperlinkFldSimple(CTSimpleField value) {
        return new JAXBElement<CTSimpleField>(_CTSmartTagRunFldSimple_QNAME, CTSimpleField.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = P.Hyperlink.class)
    public JAXBElement<CTTrackChange> createPHyperlinkCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link SdtRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "sdt", scope = P.Hyperlink.class)
    public JAXBElement<SdtRun> createPHyperlinkSdt(SdtRun value) {
        return new JAXBElement<SdtRun>(_RunTrackChangeSdt_QNAME, SdtRun.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = P.Hyperlink.class)
    public JAXBElement<CTMarkup> createPHyperlinkCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = P.Hyperlink.class)
    public JAXBElement<CTTrackChange> createPHyperlinkCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = P.Hyperlink.class)
    public JAXBElement<CTMoveToRangeEnd> createPHyperlinkMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = P.Hyperlink.class)
    public JAXBElement<CTMarkup> createPHyperlinkCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = P.Hyperlink.class)
    public JAXBElement<CTTrackChange> createPHyperlinkCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = P.Hyperlink.class)
    public JAXBElement<CTTrackChange> createPHyperlinkCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = P.Hyperlink.class)
    public JAXBElement<CTMarkup> createPHyperlinkCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link P.Hyperlink }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "hyperlink", scope = P.Hyperlink.class)
    public JAXBElement<P.Hyperlink> createPHyperlinkHyperlink(P.Hyperlink value) {
        return new JAXBElement<P.Hyperlink>(_CTSmartTagRunHyperlink_QNAME, P.Hyperlink.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = P.Hyperlink.class)
    public JAXBElement<RangePermissionStart> createPHyperlinkPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = P.Hyperlink.class)
    public JAXBElement<CTPerm> createPHyperlinkPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = P.Hyperlink.class)
    public JAXBElement<CTMoveBookmark> createPHyperlinkMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = P.Hyperlink.class)
    public JAXBElement<CTMarkupRange> createPHyperlinkBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = P.Hyperlink.class)
    public JAXBElement<CTCustomXmlRun> createPHyperlinkCustomXml(CTCustomXmlRun value) {
        return new JAXBElement<CTCustomXmlRun>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlRun.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = P.Hyperlink.class)
    public JAXBElement<CTBookmark> createPHyperlinkBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = P.Hyperlink.class)
    public JAXBElement<RunMoveTo> createPHyperlinkMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSmartTagRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "smartTag", scope = P.Hyperlink.class)
    public JAXBElement<CTSmartTagRun> createPHyperlinkSmartTag(CTSmartTagRun value) {
        return new JAXBElement<CTSmartTagRun>(_RunTrackChangeSmartTag_QNAME, CTSmartTagRun.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = P.Hyperlink.class)
    public JAXBElement<CTMarkup> createPHyperlinkCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTRel }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "subDoc", scope = P.Hyperlink.class)
    public JAXBElement<CTRel> createPHyperlinkSubDoc(CTRel value) {
        return new JAXBElement<CTRel>(_CTSmartTagRunSubDoc_QNAME, CTRel.class, P.Hyperlink.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = Body.class)
    public JAXBElement<CTMoveBookmark> createBodyMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, Body.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = Body.class)
    public JAXBElement<RunMoveFrom> createBodyMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, Body.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Tbl }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "tbl", scope = Body.class)
    public JAXBElement<Tbl> createBodyTbl(Tbl value) {
        return new JAXBElement<Tbl>(_CTFtnEdnTbl_QNAME, Tbl.class, Body.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = Body.class)
    public JAXBElement<CTMoveFromRangeEnd> createBodyMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, Body.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = Body.class)
    public JAXBElement<CTTrackChange> createBodyCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, Body.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = Body.class)
    public JAXBElement<CTMarkup> createBodyCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, Body.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = Body.class)
    public JAXBElement<CTMoveToRangeEnd> createBodyMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, Body.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = Body.class)
    public JAXBElement<CTTrackChange> createBodyCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, Body.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = Body.class)
    public JAXBElement<CTMarkup> createBodyCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, Body.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = Body.class)
    public JAXBElement<CTTrackChange> createBodyCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, Body.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = Body.class)
    public JAXBElement<CTTrackChange> createBodyCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, Body.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTAltChunk }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "altChunk", scope = Body.class)
    public JAXBElement<CTAltChunk> createBodyAltChunk(CTAltChunk value) {
        return new JAXBElement<CTAltChunk>(_CTFtnEdnAltChunk_QNAME, CTAltChunk.class, Body.class, value);
    }

    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "altChunk", scope = SdtContentBlock.class)
    public JAXBElement<CTAltChunk> createSdtContentBlockAltChunk(CTAltChunk value) {
        return new JAXBElement<CTAltChunk>(_CTFtnEdnAltChunk_QNAME, CTAltChunk.class, SdtContentBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = Body.class)
    public JAXBElement<CTMarkup> createBodyCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, Body.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = Body.class)
    public JAXBElement<RangePermissionStart> createBodyPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, Body.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = Body.class)
    public JAXBElement<CTPerm> createBodyPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, Body.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = Body.class)
    public JAXBElement<CTMoveBookmark> createBodyMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, Body.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = Body.class)
    public JAXBElement<CTMarkupRange> createBodyBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, Body.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlBlock }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = Body.class)
    public JAXBElement<CTCustomXmlBlock> createBodyCustomXml(CTCustomXmlBlock value) {
        return new JAXBElement<CTCustomXmlBlock>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlBlock.class, Body.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = Body.class)
    public JAXBElement<CTBookmark> createBodyBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, Body.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = Body.class)
    public JAXBElement<RunMoveTo> createBodyMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, Body.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = Body.class)
    public JAXBElement<CTMarkup> createBodyCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, Body.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = SdtContentBlock.class)
    public JAXBElement<CTMoveBookmark> createSdtContentBlockMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, SdtContentBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = SdtContentBlock.class)
    public JAXBElement<RunMoveFrom> createSdtContentBlockMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, SdtContentBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Tbl }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "tbl", scope = SdtContentBlock.class)
    public JAXBElement<Tbl> createSdtContentBlockTbl(Tbl value) {
        return new JAXBElement<Tbl>(_CTFtnEdnTbl_QNAME, Tbl.class, SdtContentBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = SdtContentBlock.class)
    public JAXBElement<CTMoveFromRangeEnd> createSdtContentBlockMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, SdtContentBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = SdtContentBlock.class)
    public JAXBElement<CTTrackChange> createSdtContentBlockCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, SdtContentBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = SdtContentBlock.class)
    public JAXBElement<CTMarkup> createSdtContentBlockCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, SdtContentBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = SdtContentBlock.class)
    public JAXBElement<CTMoveToRangeEnd> createSdtContentBlockMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, SdtContentBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = SdtContentBlock.class)
    public JAXBElement<CTTrackChange> createSdtContentBlockCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, SdtContentBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = SdtContentBlock.class)
    public JAXBElement<CTMarkup> createSdtContentBlockCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, SdtContentBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = SdtContentBlock.class)
    public JAXBElement<CTTrackChange> createSdtContentBlockCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, SdtContentBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = SdtContentBlock.class)
    public JAXBElement<CTTrackChange> createSdtContentBlockCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, SdtContentBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = SdtContentBlock.class)
    public JAXBElement<CTMarkup> createSdtContentBlockCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, SdtContentBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = SdtContentBlock.class)
    public JAXBElement<RangePermissionStart> createSdtContentBlockPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, SdtContentBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = SdtContentBlock.class)
    public JAXBElement<CTPerm> createSdtContentBlockPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, SdtContentBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = SdtContentBlock.class)
    public JAXBElement<CTMoveBookmark> createSdtContentBlockMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, SdtContentBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = SdtContentBlock.class)
    public JAXBElement<CTMarkupRange> createSdtContentBlockBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, SdtContentBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlBlock }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = SdtContentBlock.class)
    public JAXBElement<CTCustomXmlBlock> createSdtContentBlockCustomXml(CTCustomXmlBlock value) {
        return new JAXBElement<CTCustomXmlBlock>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlBlock.class, SdtContentBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = SdtContentBlock.class)
    public JAXBElement<CTBookmark> createSdtContentBlockBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, SdtContentBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = SdtContentBlock.class)
    public JAXBElement<RunMoveTo> createSdtContentBlockMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, SdtContentBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = SdtContentBlock.class)
    public JAXBElement<CTMarkup> createSdtContentBlockCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, SdtContentBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = CTCustomXmlCell.class)
    public JAXBElement<CTMoveBookmark> createCTCustomXmlCellMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, CTCustomXmlCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = CTCustomXmlCell.class)
    public JAXBElement<RunMoveFrom> createCTCustomXmlCellMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, CTCustomXmlCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = CTCustomXmlCell.class)
    public JAXBElement<CTMoveFromRangeEnd> createCTCustomXmlCellMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, CTCustomXmlCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = CTCustomXmlCell.class)
    public JAXBElement<CTTrackChange> createCTCustomXmlCellCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, CTCustomXmlCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSdtCell }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "sdt", scope = CTCustomXmlCell.class)
    public JAXBElement<CTSdtCell> createCTCustomXmlCellSdt(CTSdtCell value) {
        return new JAXBElement<CTSdtCell>(_RunTrackChangeSdt_QNAME, CTSdtCell.class, CTCustomXmlCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = CTCustomXmlCell.class)
    public JAXBElement<CTMarkup> createCTCustomXmlCellCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, CTCustomXmlCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = CTCustomXmlCell.class)
    public JAXBElement<CTTrackChange> createCTCustomXmlCellCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, CTCustomXmlCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = CTCustomXmlCell.class)
    public JAXBElement<CTMoveToRangeEnd> createCTCustomXmlCellMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, CTCustomXmlCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = CTCustomXmlCell.class)
    public JAXBElement<CTMarkup> createCTCustomXmlCellCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, CTCustomXmlCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = CTCustomXmlCell.class)
    public JAXBElement<CTTrackChange> createCTCustomXmlCellCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, CTCustomXmlCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = CTCustomXmlCell.class)
    public JAXBElement<CTTrackChange> createCTCustomXmlCellCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, CTCustomXmlCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = CTCustomXmlCell.class)
    public JAXBElement<CTMarkup> createCTCustomXmlCellCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, CTCustomXmlCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = CTCustomXmlCell.class)
    public JAXBElement<RangePermissionStart> createCTCustomXmlCellPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, CTCustomXmlCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = CTCustomXmlCell.class)
    public JAXBElement<CTPerm> createCTCustomXmlCellPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, CTCustomXmlCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = CTCustomXmlCell.class)
    public JAXBElement<CTMoveBookmark> createCTCustomXmlCellMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, CTCustomXmlCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Tc }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "tc", scope = CTCustomXmlCell.class)
    public JAXBElement<Tc> createCTCustomXmlCellTc(Tc value) {
        return new JAXBElement<Tc>(_CTSdtContentCellTc_QNAME, Tc.class, CTCustomXmlCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = CTCustomXmlCell.class)
    public JAXBElement<CTMarkupRange> createCTCustomXmlCellBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, CTCustomXmlCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlCell }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = CTCustomXmlCell.class)
    public JAXBElement<CTCustomXmlCell> createCTCustomXmlCellCustomXml(CTCustomXmlCell value) {
        return new JAXBElement<CTCustomXmlCell>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlCell.class, CTCustomXmlCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = CTCustomXmlCell.class)
    public JAXBElement<CTBookmark> createCTCustomXmlCellBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, CTCustomXmlCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = CTCustomXmlCell.class)
    public JAXBElement<RunMoveTo> createCTCustomXmlCellMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, CTCustomXmlCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = CTCustomXmlCell.class)
    public JAXBElement<CTMarkup> createCTCustomXmlCellCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, CTCustomXmlCell.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = RunDel.class)
    public JAXBElement<CTMoveBookmark> createRunDelMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = RunDel.class)
    public JAXBElement<CTMoveFromRangeEnd> createRunDelMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSPre }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "sPre", scope = RunDel.class)
    public JAXBElement<CTSPre> createRunDelSPre(CTSPre value) {
        return new JAXBElement<CTSPre>(_RunTrackChangeSPre_QNAME, CTSPre.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link SdtRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "sdt", scope = RunDel.class)
    public JAXBElement<SdtRun> createRunDelSdt(SdtRun value) {
        return new JAXBElement<SdtRun>(_RunTrackChangeSdt_QNAME, SdtRun.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = RunDel.class)
    public JAXBElement<CTMoveToRangeEnd> createRunDelMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = RunDel.class)
    public JAXBElement<CTMarkup> createRunDelCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBorderBox }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "borderBox", scope = RunDel.class)
    public JAXBElement<CTBorderBox> createRunDelBorderBox(CTBorderBox value) {
        return new JAXBElement<CTBorderBox>(_RunTrackChangeBorderBox_QNAME, CTBorderBox.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = RunDel.class)
    public JAXBElement<CTMarkup> createRunDelCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = RunDel.class)
    public JAXBElement<CTTrackChange> createRunDelCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = RunDel.class)
    public JAXBElement<CTTrackChange> createRunDelCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = RunDel.class)
    public JAXBElement<CTMarkup> createRunDelCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTGroupChr }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "groupChr", scope = RunDel.class)
    public JAXBElement<CTGroupChr> createRunDelGroupChr(CTGroupChr value) {
        return new JAXBElement<CTGroupChr>(_RunTrackChangeGroupChr_QNAME, CTGroupChr.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = RunDel.class)
    public JAXBElement<RangePermissionStart> createRunDelPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTFunc }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "func", scope = RunDel.class)
    public JAXBElement<CTFunc> createRunDelFunc(CTFunc value) {
        return new JAXBElement<CTFunc>(_RunTrackChangeFunc_QNAME, CTFunc.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = RunDel.class)
    public JAXBElement<CTMoveBookmark> createRunDelMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = RunDel.class)
    public JAXBElement<CTMarkupRange> createRunDelBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSSubSup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "sSubSup", scope = RunDel.class)
    public JAXBElement<CTSSubSup> createRunDelSSubSup(CTSSubSup value) {
        return new JAXBElement<CTSSubSup>(_RunTrackChangeSSubSup_QNAME, CTSSubSup.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTLimUpp }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "limUpp", scope = RunDel.class)
    public JAXBElement<CTLimUpp> createRunDelLimUpp(CTLimUpp value) {
        return new JAXBElement<CTLimUpp>(_RunTrackChangeLimUpp_QNAME, CTLimUpp.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = RunDel.class)
    public JAXBElement<CTMarkup> createRunDelCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTAcc }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "acc", scope = RunDel.class)
    public JAXBElement<CTAcc> createRunDelAcc(CTAcc value) {
        return new JAXBElement<CTAcc>(_RunTrackChangeAcc_QNAME, CTAcc.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = RunDel.class)
    public JAXBElement<RunMoveFrom> createRunDelMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTM }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "m", scope = RunDel.class)
    public JAXBElement<CTM> createRunDelM(CTM value) {
        return new JAXBElement<CTM>(_RunTrackChangeM_QNAME, CTM.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = RunDel.class)
    public JAXBElement<CTTrackChange> createRunDelCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTLimLow }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "limLow", scope = RunDel.class)
    public JAXBElement<CTLimLow> createRunDelLimLow(CTLimLow value) {
        return new JAXBElement<CTLimLow>(_RunTrackChangeLimLow_QNAME, CTLimLow.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = RunDel.class)
    public JAXBElement<CTTrackChange> createRunDelCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSSup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "sSup", scope = RunDel.class)
    public JAXBElement<CTSSup> createRunDelSSup(CTSSup value) {
        return new JAXBElement<CTSSup>(_RunTrackChangeSSup_QNAME, CTSSup.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTD }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "d", scope = RunDel.class)
    public JAXBElement<CTD> createRunDelD(CTD value) {
        return new JAXBElement<CTD>(_RunTrackChangeD_QNAME, CTD.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTF }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "f", scope = RunDel.class)
    public JAXBElement<CTF> createRunDelF(CTF value) {
        return new JAXBElement<CTF>(_RunTrackChangeF_QNAME, CTF.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTEqArr }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "eqArr", scope = RunDel.class)
    public JAXBElement<CTEqArr> createRunDelEqArr(CTEqArr value) {
        return new JAXBElement<CTEqArr>(_RunTrackChangeEqArr_QNAME, CTEqArr.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTRad }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "rad", scope = RunDel.class)
    public JAXBElement<CTRad> createRunDelRad(CTRad value) {
        return new JAXBElement<CTRad>(_RunTrackChangeRad_QNAME, CTRad.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTNary }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "nary", scope = RunDel.class)
    public JAXBElement<CTNary> createRunDelNary(CTNary value) {
        return new JAXBElement<CTNary>(_RunTrackChangeNary_QNAME, CTNary.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBar }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "bar", scope = RunDel.class)
    public JAXBElement<CTBar> createRunDelBar(CTBar value) {
        return new JAXBElement<CTBar>(_RunTrackChangeBar_QNAME, CTBar.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = RunDel.class)
    public JAXBElement<CTPerm> createRunDelPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBox }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "box", scope = RunDel.class)
    public JAXBElement<CTBox> createRunDelBox(CTBox value) {
        return new JAXBElement<CTBox>(_RunTrackChangeBox_QNAME, CTBox.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = RunDel.class)
    public JAXBElement<CTCustomXmlRun> createRunDelCustomXml(CTCustomXmlRun value) {
        return new JAXBElement<CTCustomXmlRun>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlRun.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTR }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "r", scope = RunDel.class)
    public JAXBElement<CTR> createRunDelR(CTR value) {
        return new JAXBElement<CTR>(_RunTrackChangeR_QNAME, CTR.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = RunDel.class)
    public JAXBElement<CTBookmark> createRunDelBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPhant }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "phant", scope = RunDel.class)
    public JAXBElement<CTPhant> createRunDelPhant(CTPhant value) {
        return new JAXBElement<CTPhant>(_RunTrackChangePhant_QNAME, CTPhant.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSmartTagRun }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "smartTag", scope = RunDel.class)
    public JAXBElement<CTSmartTagRun> createRunDelSmartTag(CTSmartTagRun value) {
        return new JAXBElement<CTSmartTagRun>(_RunTrackChangeSmartTag_QNAME, CTSmartTagRun.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = RunDel.class)
    public JAXBElement<RunMoveTo> createRunDelMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSSub }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/officeDocument/2006/math", name = "sSub", scope = RunDel.class)
    public JAXBElement<CTSSub> createRunDelSSub(CTSSub value) {
        return new JAXBElement<CTSSub>(_RunTrackChangeSSub_QNAME, CTSSub.class, RunDel.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "tblHeader", scope = CTTrPrBase.class)
    public JAXBElement<BooleanDefaultTrue> createCTTrPrBaseTblHeader(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTTrPrBaseTblHeader_QNAME, BooleanDefaultTrue.class, CTTrPrBase.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Jc }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "jc", scope = CTTrPrBase.class)
    public JAXBElement<Jc> createCTTrPrBaseJc(Jc value) {
        return new JAXBElement<Jc>(_CTTrPrBaseJc_QNAME, Jc.class, CTTrPrBase.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "cantSplit", scope = CTTrPrBase.class)
    public JAXBElement<BooleanDefaultTrue> createCTTrPrBaseCantSplit(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTTrPrBaseCantSplit_QNAME, BooleanDefaultTrue.class, CTTrPrBase.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrPrBase.GridBefore }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "gridBefore", scope = CTTrPrBase.class)
    public JAXBElement<CTTrPrBase.GridBefore> createCTTrPrBaseGridBefore(CTTrPrBase.GridBefore value) {
        return new JAXBElement<CTTrPrBase.GridBefore>(_CTTrPrBaseGridBefore_QNAME, CTTrPrBase.GridBefore.class, CTTrPrBase.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link BooleanDefaultTrue }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "hidden", scope = CTTrPrBase.class)
    public JAXBElement<BooleanDefaultTrue> createCTTrPrBaseHidden(BooleanDefaultTrue value) {
        return new JAXBElement<BooleanDefaultTrue>(_CTTrPrBaseHidden_QNAME, BooleanDefaultTrue.class, CTTrPrBase.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTHeight }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "trHeight", scope = CTTrPrBase.class)
    public JAXBElement<CTHeight> createCTTrPrBaseTrHeight(CTHeight value) {
        return new JAXBElement<CTHeight>(_CTTrPrBaseTrHeight_QNAME, CTHeight.class, CTTrPrBase.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link TblWidth }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "tblCellSpacing", scope = CTTrPrBase.class)
    public JAXBElement<TblWidth> createCTTrPrBaseTblCellSpacing(TblWidth value) {
        return new JAXBElement<TblWidth>(_CTTrPrBaseTblCellSpacing_QNAME, TblWidth.class, CTTrPrBase.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrPrBase.GridAfter }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "gridAfter", scope = CTTrPrBase.class)
    public JAXBElement<CTTrPrBase.GridAfter> createCTTrPrBaseGridAfter(CTTrPrBase.GridAfter value) {
        return new JAXBElement<CTTrPrBase.GridAfter>(_CTTrPrBaseGridAfter_QNAME, CTTrPrBase.GridAfter.class, CTTrPrBase.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link TblWidth }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "wAfter", scope = CTTrPrBase.class)
    public JAXBElement<TblWidth> createCTTrPrBaseWAfter(TblWidth value) {
        return new JAXBElement<TblWidth>(_CTTrPrBaseWAfter_QNAME, TblWidth.class, CTTrPrBase.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link TblWidth }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "wBefore", scope = CTTrPrBase.class)
    public JAXBElement<TblWidth> createCTTrPrBaseWBefore(TblWidth value) {
        return new JAXBElement<TblWidth>(_CTTrPrBaseWBefore_QNAME, TblWidth.class, CTTrPrBase.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrPrBase.DivId }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "divId", scope = CTTrPrBase.class)
    public JAXBElement<CTTrPrBase.DivId> createCTTrPrBaseDivId(CTTrPrBase.DivId value) {
        return new JAXBElement<CTTrPrBase.DivId>(_CTTrPrBaseDivId_QNAME, CTTrPrBase.DivId.class, CTTrPrBase.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCnf }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "cnfStyle", scope = CTTrPrBase.class)
    public JAXBElement<CTCnf> createCTTrPrBaseCnfStyle(CTCnf value) {
        return new JAXBElement<CTCnf>(_CTTrPrBaseCnfStyle_QNAME, CTCnf.class, CTTrPrBase.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = Tc.class)
    public JAXBElement<CTMoveBookmark> createTcMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, Tc.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = Tc.class)
    public JAXBElement<RunMoveFrom> createTcMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, Tc.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Tbl }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "tbl", scope = Tc.class)
    public JAXBElement<Tbl> createTcTbl(Tbl value) {
        return new JAXBElement<Tbl>(_CTFtnEdnTbl_QNAME, Tbl.class, Tc.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = Tc.class)
    public JAXBElement<CTMoveFromRangeEnd> createTcMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, Tc.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = Tc.class)
    public JAXBElement<CTTrackChange> createTcCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, Tc.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = Tc.class)
    public JAXBElement<CTMarkup> createTcCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, Tc.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = Tc.class)
    public JAXBElement<CTMoveToRangeEnd> createTcMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, Tc.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = Tc.class)
    public JAXBElement<CTTrackChange> createTcCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, Tc.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = Tc.class)
    public JAXBElement<CTMarkup> createTcCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, Tc.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = Tc.class)
    public JAXBElement<CTTrackChange> createTcCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, Tc.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = Tc.class)
    public JAXBElement<CTTrackChange> createTcCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, Tc.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTAltChunk }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "altChunk", scope = Tc.class)
    public JAXBElement<CTAltChunk> createTcAltChunk(CTAltChunk value) {
        return new JAXBElement<CTAltChunk>(_CTFtnEdnAltChunk_QNAME, CTAltChunk.class, Tc.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = Tc.class)
    public JAXBElement<CTMarkup> createTcCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, Tc.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = Tc.class)
    public JAXBElement<RangePermissionStart> createTcPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, Tc.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = Tc.class)
    public JAXBElement<CTPerm> createTcPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, Tc.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = Tc.class)
    public JAXBElement<CTMoveBookmark> createTcMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, Tc.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = Tc.class)
    public JAXBElement<CTMarkupRange> createTcBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, Tc.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlBlock }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = Tc.class)
    public JAXBElement<CTCustomXmlBlock> createTcCustomXml(CTCustomXmlBlock value) {
        return new JAXBElement<CTCustomXmlBlock>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlBlock.class, Tc.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = Tc.class)
    public JAXBElement<CTBookmark> createTcBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, Tc.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = Tc.class)
    public JAXBElement<RunMoveTo> createTcMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, Tc.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = Tc.class)
    public JAXBElement<CTMarkup> createTcCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, Tc.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = CTCustomXmlBlock.class)
    public JAXBElement<CTMoveBookmark> createCTCustomXmlBlockMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, CTCustomXmlBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = CTCustomXmlBlock.class)
    public JAXBElement<RunMoveFrom> createCTCustomXmlBlockMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, CTCustomXmlBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Tbl }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "tbl", scope = CTCustomXmlBlock.class)
    public JAXBElement<Tbl> createCTCustomXmlBlockTbl(Tbl value) {
        return new JAXBElement<Tbl>(_CTFtnEdnTbl_QNAME, Tbl.class, CTCustomXmlBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = CTCustomXmlBlock.class)
    public JAXBElement<CTMoveFromRangeEnd> createCTCustomXmlBlockMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, CTCustomXmlBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = CTCustomXmlBlock.class)
    public JAXBElement<CTTrackChange> createCTCustomXmlBlockCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, CTCustomXmlBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = CTCustomXmlBlock.class)
    public JAXBElement<CTMarkup> createCTCustomXmlBlockCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, CTCustomXmlBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = CTCustomXmlBlock.class)
    public JAXBElement<CTMoveToRangeEnd> createCTCustomXmlBlockMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, CTCustomXmlBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = CTCustomXmlBlock.class)
    public JAXBElement<CTTrackChange> createCTCustomXmlBlockCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, CTCustomXmlBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = CTCustomXmlBlock.class)
    public JAXBElement<CTMarkup> createCTCustomXmlBlockCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, CTCustomXmlBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = CTCustomXmlBlock.class)
    public JAXBElement<CTTrackChange> createCTCustomXmlBlockCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, CTCustomXmlBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = CTCustomXmlBlock.class)
    public JAXBElement<CTTrackChange> createCTCustomXmlBlockCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, CTCustomXmlBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = CTCustomXmlBlock.class)
    public JAXBElement<CTMarkup> createCTCustomXmlBlockCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, CTCustomXmlBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = CTCustomXmlBlock.class)
    public JAXBElement<RangePermissionStart> createCTCustomXmlBlockPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, CTCustomXmlBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = CTCustomXmlBlock.class)
    public JAXBElement<CTPerm> createCTCustomXmlBlockPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, CTCustomXmlBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = CTCustomXmlBlock.class)
    public JAXBElement<CTMoveBookmark> createCTCustomXmlBlockMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, CTCustomXmlBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = CTCustomXmlBlock.class)
    public JAXBElement<CTMarkupRange> createCTCustomXmlBlockBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, CTCustomXmlBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlBlock }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = CTCustomXmlBlock.class)
    public JAXBElement<CTCustomXmlBlock> createCTCustomXmlBlockCustomXml(CTCustomXmlBlock value) {
        return new JAXBElement<CTCustomXmlBlock>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlBlock.class, CTCustomXmlBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = CTCustomXmlBlock.class)
    public JAXBElement<CTBookmark> createCTCustomXmlBlockBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, CTCustomXmlBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = CTCustomXmlBlock.class)
    public JAXBElement<RunMoveTo> createCTCustomXmlBlockMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, CTCustomXmlBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = CTCustomXmlBlock.class)
    public JAXBElement<CTMarkup> createCTCustomXmlBlockCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, CTCustomXmlBlock.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = CTCustomXmlRow.class)
    public JAXBElement<CTMoveBookmark> createCTCustomXmlRowMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, CTCustomXmlRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = CTCustomXmlRow.class)
    public JAXBElement<RunMoveFrom> createCTCustomXmlRowMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, CTCustomXmlRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = CTCustomXmlRow.class)
    public JAXBElement<CTMoveFromRangeEnd> createCTCustomXmlRowMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, CTCustomXmlRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = CTCustomXmlRow.class)
    public JAXBElement<CTTrackChange> createCTCustomXmlRowCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, CTCustomXmlRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSdtRow }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "sdt", scope = CTCustomXmlRow.class)
    public JAXBElement<CTSdtRow> createCTCustomXmlRowSdt(CTSdtRow value) {
        return new JAXBElement<CTSdtRow>(_RunTrackChangeSdt_QNAME, CTSdtRow.class, CTCustomXmlRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = CTCustomXmlRow.class)
    public JAXBElement<CTMarkup> createCTCustomXmlRowCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, CTCustomXmlRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = CTCustomXmlRow.class)
    public JAXBElement<CTMoveToRangeEnd> createCTCustomXmlRowMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, CTCustomXmlRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = CTCustomXmlRow.class)
    public JAXBElement<CTTrackChange> createCTCustomXmlRowCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, CTCustomXmlRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = CTCustomXmlRow.class)
    public JAXBElement<CTMarkup> createCTCustomXmlRowCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, CTCustomXmlRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = CTCustomXmlRow.class)
    public JAXBElement<CTTrackChange> createCTCustomXmlRowCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, CTCustomXmlRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = CTCustomXmlRow.class)
    public JAXBElement<CTTrackChange> createCTCustomXmlRowCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, CTCustomXmlRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = CTCustomXmlRow.class)
    public JAXBElement<CTMarkup> createCTCustomXmlRowCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, CTCustomXmlRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = CTCustomXmlRow.class)
    public JAXBElement<RangePermissionStart> createCTCustomXmlRowPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, CTCustomXmlRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = CTCustomXmlRow.class)
    public JAXBElement<CTPerm> createCTCustomXmlRowPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, CTCustomXmlRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = CTCustomXmlRow.class)
    public JAXBElement<CTMoveBookmark> createCTCustomXmlRowMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, CTCustomXmlRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = CTCustomXmlRow.class)
    public JAXBElement<CTMarkupRange> createCTCustomXmlRowBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, CTCustomXmlRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlRow }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = CTCustomXmlRow.class)
    public JAXBElement<CTCustomXmlRow> createCTCustomXmlRowCustomXml(CTCustomXmlRow value) {
        return new JAXBElement<CTCustomXmlRow>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlRow.class, CTCustomXmlRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = CTCustomXmlRow.class)
    public JAXBElement<CTBookmark> createCTCustomXmlRowBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, CTCustomXmlRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = CTCustomXmlRow.class)
    public JAXBElement<RunMoveTo> createCTCustomXmlRowMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, CTCustomXmlRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = CTCustomXmlRow.class)
    public JAXBElement<CTMarkup> createCTCustomXmlRowCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, CTCustomXmlRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = Tr.class)
    public JAXBElement<CTMoveBookmark> createTrMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, Tr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = Tr.class)
    public JAXBElement<RunMoveFrom> createTrMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, Tr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = Tr.class)
    public JAXBElement<CTMoveFromRangeEnd> createTrMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, Tr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = Tr.class)
    public JAXBElement<CTTrackChange> createTrCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, Tr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSdtCell }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "sdt", scope = Tr.class)
    public JAXBElement<CTSdtCell> createTrSdt(CTSdtCell value) {
        return new JAXBElement<CTSdtCell>(_RunTrackChangeSdt_QNAME, CTSdtCell.class, Tr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = Tr.class)
    public JAXBElement<CTMarkup> createTrCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, Tr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = Tr.class)
    public JAXBElement<CTTrackChange> createTrCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, Tr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = Tr.class)
    public JAXBElement<CTMoveToRangeEnd> createTrMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, Tr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = Tr.class)
    public JAXBElement<CTMarkup> createTrCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, Tr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = Tr.class)
    public JAXBElement<CTTrackChange> createTrCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, Tr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = Tr.class)
    public JAXBElement<CTTrackChange> createTrCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, Tr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = Tr.class)
    public JAXBElement<CTMarkup> createTrCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, Tr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = Tr.class)
    public JAXBElement<RangePermissionStart> createTrPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, Tr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = Tr.class)
    public JAXBElement<CTPerm> createTrPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, Tr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = Tr.class)
    public JAXBElement<CTMoveBookmark> createTrMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, Tr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Tc }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "tc", scope = Tr.class)
    public JAXBElement<Tc> createTrTc(Tc value) {
        return new JAXBElement<Tc>(_CTSdtContentCellTc_QNAME, Tc.class, Tr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = Tr.class)
    public JAXBElement<CTMarkupRange> createTrBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, Tr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlCell }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = Tr.class)
    public JAXBElement<CTCustomXmlCell> createTrCustomXml(CTCustomXmlCell value) {
        return new JAXBElement<CTCustomXmlCell>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlCell.class, Tr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = Tr.class)
    public JAXBElement<CTBookmark> createTrBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, Tr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = Tr.class)
    public JAXBElement<RunMoveTo> createTrMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, Tr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = Tr.class)
    public JAXBElement<CTMarkup> createTrCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, Tr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = CTSdtContentRow.class)
    public JAXBElement<CTMoveBookmark> createCTSdtContentRowMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, CTSdtContentRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = CTSdtContentRow.class)
    public JAXBElement<RunMoveFrom> createCTSdtContentRowMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, CTSdtContentRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = CTSdtContentRow.class)
    public JAXBElement<CTMoveFromRangeEnd> createCTSdtContentRowMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, CTSdtContentRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = CTSdtContentRow.class)
    public JAXBElement<CTTrackChange> createCTSdtContentRowCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, CTSdtContentRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTSdtRow }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "sdt", scope = CTSdtContentRow.class)
    public JAXBElement<CTSdtRow> createCTSdtContentRowSdt(CTSdtRow value) {
        return new JAXBElement<CTSdtRow>(_RunTrackChangeSdt_QNAME, CTSdtRow.class, CTSdtContentRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = CTSdtContentRow.class)
    public JAXBElement<CTMarkup> createCTSdtContentRowCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, CTSdtContentRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = CTSdtContentRow.class)
    public JAXBElement<CTMoveToRangeEnd> createCTSdtContentRowMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, CTSdtContentRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = CTSdtContentRow.class)
    public JAXBElement<CTTrackChange> createCTSdtContentRowCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, CTSdtContentRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = CTSdtContentRow.class)
    public JAXBElement<CTMarkup> createCTSdtContentRowCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, CTSdtContentRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = CTSdtContentRow.class)
    public JAXBElement<CTTrackChange> createCTSdtContentRowCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, CTSdtContentRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = CTSdtContentRow.class)
    public JAXBElement<CTTrackChange> createCTSdtContentRowCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, CTSdtContentRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = CTSdtContentRow.class)
    public JAXBElement<CTMarkup> createCTSdtContentRowCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, CTSdtContentRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = CTSdtContentRow.class)
    public JAXBElement<RangePermissionStart> createCTSdtContentRowPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, CTSdtContentRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = CTSdtContentRow.class)
    public JAXBElement<CTPerm> createCTSdtContentRowPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, CTSdtContentRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = CTSdtContentRow.class)
    public JAXBElement<CTMoveBookmark> createCTSdtContentRowMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, CTSdtContentRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = CTSdtContentRow.class)
    public JAXBElement<CTMarkupRange> createCTSdtContentRowBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, CTSdtContentRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlRow }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = CTSdtContentRow.class)
    public JAXBElement<CTCustomXmlRow> createCTSdtContentRowCustomXml(CTCustomXmlRow value) {
        return new JAXBElement<CTCustomXmlRow>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlRow.class, CTSdtContentRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = CTSdtContentRow.class)
    public JAXBElement<CTBookmark> createCTSdtContentRowBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, CTSdtContentRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = CTSdtContentRow.class)
    public JAXBElement<RunMoveTo> createCTSdtContentRowMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, CTSdtContentRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = CTSdtContentRow.class)
    public JAXBElement<CTMarkup> createCTSdtContentRowCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, CTSdtContentRow.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeStart", scope = Hdr.class)
    public JAXBElement<CTMoveBookmark> createHdrMoveFromRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveFromRangeStart_QNAME, CTMoveBookmark.class, Hdr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFrom", scope = Hdr.class)
    public JAXBElement<RunMoveFrom> createHdrMoveFrom(RunMoveFrom value) {
        return new JAXBElement<RunMoveFrom>(_RunTrackChangeMoveFrom_QNAME, RunMoveFrom.class, Hdr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Tbl }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "tbl", scope = Hdr.class)
    public JAXBElement<Tbl> createHdrTbl(Tbl value) {
        return new JAXBElement<Tbl>(_CTFtnEdnTbl_QNAME, Tbl.class, Hdr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveFromRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveFromRangeEnd", scope = Hdr.class)
    public JAXBElement<CTMoveFromRangeEnd> createHdrMoveFromRangeEnd(CTMoveFromRangeEnd value) {
        return new JAXBElement<CTMoveFromRangeEnd>(_RunTrackChangeMoveFromRangeEnd_QNAME, CTMoveFromRangeEnd.class, Hdr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeStart", scope = Hdr.class)
    public JAXBElement<CTTrackChange> createHdrCustomXmlMoveFromRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveFromRangeStart_QNAME, CTTrackChange.class, Hdr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeEnd", scope = Hdr.class)
    public JAXBElement<CTMarkup> createHdrCustomXmlDelRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlDelRangeEnd_QNAME, CTMarkup.class, Hdr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveToRangeEnd }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeEnd", scope = Hdr.class)
    public JAXBElement<CTMoveToRangeEnd> createHdrMoveToRangeEnd(CTMoveToRangeEnd value) {
        return new JAXBElement<CTMoveToRangeEnd>(_RunTrackChangeMoveToRangeEnd_QNAME, CTMoveToRangeEnd.class, Hdr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlDelRangeStart", scope = Hdr.class)
    public JAXBElement<CTTrackChange> createHdrCustomXmlDelRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlDelRangeStart_QNAME, CTTrackChange.class, Hdr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeEnd", scope = Hdr.class)
    public JAXBElement<CTMarkup> createHdrCustomXmlMoveToRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveToRangeEnd_QNAME, CTMarkup.class, Hdr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeStart", scope = Hdr.class)
    public JAXBElement<CTTrackChange> createHdrCustomXmlInsRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlInsRangeStart_QNAME, CTTrackChange.class, Hdr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveToRangeStart", scope = Hdr.class)
    public JAXBElement<CTTrackChange> createHdrCustomXmlMoveToRangeStart(CTTrackChange value) {
        return new JAXBElement<CTTrackChange>(_RunTrackChangeCustomXmlMoveToRangeStart_QNAME, CTTrackChange.class, Hdr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTAltChunk }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "altChunk", scope = Hdr.class)
    public JAXBElement<CTAltChunk> createHdrAltChunk(CTAltChunk value) {
        return new JAXBElement<CTAltChunk>(_CTFtnEdnAltChunk_QNAME, CTAltChunk.class, Hdr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlInsRangeEnd", scope = Hdr.class)
    public JAXBElement<CTMarkup> createHdrCustomXmlInsRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlInsRangeEnd_QNAME, CTMarkup.class, Hdr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RangePermissionStart }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permStart", scope = Hdr.class)
    public JAXBElement<RangePermissionStart> createHdrPermStart(RangePermissionStart value) {
        return new JAXBElement<RangePermissionStart>(_RunTrackChangePermStart_QNAME, RangePermissionStart.class, Hdr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTPerm }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "permEnd", scope = Hdr.class)
    public JAXBElement<CTPerm> createHdrPermEnd(CTPerm value) {
        return new JAXBElement<CTPerm>(_RunTrackChangePermEnd_QNAME, CTPerm.class, Hdr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMoveBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveToRangeStart", scope = Hdr.class)
    public JAXBElement<CTMoveBookmark> createHdrMoveToRangeStart(CTMoveBookmark value) {
        return new JAXBElement<CTMoveBookmark>(_RunTrackChangeMoveToRangeStart_QNAME, CTMoveBookmark.class, Hdr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkupRange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkEnd", scope = Hdr.class)
    public JAXBElement<CTMarkupRange> createHdrBookmarkEnd(CTMarkupRange value) {
        return new JAXBElement<CTMarkupRange>(_RunTrackChangeBookmarkEnd_QNAME, CTMarkupRange.class, Hdr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTCustomXmlBlock }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXml", scope = Hdr.class)
    public JAXBElement<CTCustomXmlBlock> createHdrCustomXml(CTCustomXmlBlock value) {
        return new JAXBElement<CTCustomXmlBlock>(_RunTrackChangeCustomXml_QNAME, CTCustomXmlBlock.class, Hdr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTBookmark }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "bookmarkStart", scope = Hdr.class)
    public JAXBElement<CTBookmark> createHdrBookmarkStart(CTBookmark value) {
        return new JAXBElement<CTBookmark>(_RunTrackChangeBookmarkStart_QNAME, CTBookmark.class, Hdr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link RunTrackChange }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "moveTo", scope = Hdr.class)
    public JAXBElement<RunMoveTo> createHdrMoveTo(RunMoveTo value) {
        return new JAXBElement<RunMoveTo>(_RunTrackChangeMoveTo_QNAME, RunMoveTo.class, Hdr.class, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link CTMarkup }{@code >}}
     *
     */
    @XmlElementDecl(namespace = "http://schemas.openxmlformats.org/wordprocessingml/2006/main", name = "customXmlMoveFromRangeEnd", scope = Hdr.class)
    public JAXBElement<CTMarkup> createHdrCustomXmlMoveFromRangeEnd(CTMarkup value) {
        return new JAXBElement<CTMarkup>(_RunTrackChangeCustomXmlMoveFromRangeEnd_QNAME, CTMarkup.class, Hdr.class, value);
    }
}
